// This file is automatically generated from /builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic.pac.

#ifndef _builddir_build_BUILD_GQUIC_Protocol_Analyzer_89b7b45043db496e64ea9189b8ddfc681d0c77a7_src_gquic_pac_h
#define _builddir_build_BUILD_GQUIC_Protocol_Analyzer_89b7b45043db496e64ea9189b8ddfc681d0c77a7_src_gquic_pac_h

#include <vector>

#include "binpac.h"


#include "binpac_bro.h"


#include "GQUIC.h"
#include "events.bif.h"


	#include <cctype>
	#include <unordered_set>
	#include "consts.bif.h"
	#include "types.bif.h"

namespace binpac {

namespace GQUIC {
class ContextGQUIC;
class GQUIC_Conn;
class GQUIC_Packet;
class PublicFlags;
class OldPacket;
class ConnectionIDOld;
class RegularPacket;
class ConnectionID;
class UnencryptedSearch;
class StreamID;
class SId;
class NewerVersions;
class DataLength;
class StreamOffset;
class HelloCheck;
class TypeHello;
class HelloPacket;
class RejPacket;
class RejPacketSCFG;
class ExtractPAD;
class ExtractSNI;
class ExtractSTK;
class ExtractSNO;
class ExtractVER;
class ExtractCCS;
class ExtractCRT;
class ExtractNONC;
class ExtractMSPC;
class ExtractAEAD;
class ExtractUAID;
class ExtractSCID;
class ExtractTCID;
class ExtractPDMD;
class ExtractSMHL;
class ExtractICSL;
class ExtractNONP;
class ExtractPUBS;
class ExtractMIDS;
class ExtractSCLS;
class ExtractKEXS;
class ExtractXLCT;
class ExtractCSCT;
class ExtractCOPT;
class ExtractCCRT;
class ExtractIRTT;
class ExtractCFCW;
class ExtractSFCW;
class ExtractPROF;
class ExtractSCFG;
class ExtractRREJ;
class ExtractOBIT;
class ExtractEXPY;
class ExtractSRBF;
class ExtractCETV;
class ExtractCTIM;
class ExtractFHOL;
class ExtractSTTL;
class ExtractTBKP;
class ExtractSVID;
class TagFinder;
enum PacketType {
	REGULAR,
	OLDER,
};
class GQUIC_Flow;
} // namespace GQUIC

int bytestring_to_int(const_bytestring const & s, int base);
double bytestring_to_double(const_bytestring const & s);
int bytestring_casecmp(const_bytestring const & s1, const_charptr const & s2);
bool bytestring_caseprefix(const_bytestring const & s1, const_charptr const & s2);
double network_time();
StringVal * utf16_bytestring_to_utf8_val(Connection * conn, bytestring const & utf16);
namespace GQUIC {

class ContextGQUIC
{
public:
	ContextGQUIC(GQUIC_Conn * connection, GQUIC_Flow * flow);
	~ContextGQUIC();
	
	// Member access functions
	GQUIC_Conn * connection() const { return connection_; }
	GQUIC_Flow * flow() const { return flow_; }
	
protected:
	GQUIC_Conn * connection_;
	GQUIC_Flow * flow_;
};


class GQUIC_Conn : public binpac::ConnectionAnalyzer
{
public:
	GQUIC_Conn(BroAnalyzer const & bro_analyzer);
	~GQUIC_Conn();
	
	// Member access functions
	GQUIC_Flow * upflow() const { return upflow_; }
	GQUIC_Flow * downflow() const { return downflow_; }
	BroAnalyzer const & bro_analyzer() const { return bro_analyzer_; }
	
	void NewData(bool is_orig, const_byteptr begin, const_byteptr end);
	void NewGap(bool is_orig, int gap_length);
	void FlowEOF(bool is_orig);
	
	// Functions
	bool process_packet(GQUIC_Packet * pkt, bool is_orig);
	bool hello_packet_creation(GQUIC_Packet * pkt, bool is_orig, RecordVal * rv);
	bool rej_packet_creation(GQUIC_Packet * pkt, bool is_orig, RecordVal * rv);
	uint16 get_gquic_version(RegularPacket * reg_pkt);
	uint16 get_gquic_version_old(OldPacket * old_pkt);
	uint64 get_packet_number_current(GQUIC_Packet * pkt, RegularPacket * reg_pkt, uint16 version);
	vector<uint8> * get_packet_number_bytes_current(GQUIC_Packet * pkt, RegularPacket * reg_pkt);
	uint64 get_packet_number_old(GQUIC_Packet * pkt, OldPacket * old_pkt, uint16 version);
	vector<uint8> * get_packet_number_bytes_old(GQUIC_Packet * pkt, OldPacket * old_pkt);
	uint64 convert_packet_bytes(vector<uint8> * bytes, uint16 version);
	
protected:
	
	// Additional members

		bool saw_server_pkt1;
		uint16 last_known_client_version;
		std::unordered_set<uint16> potential_client_versions;

		// Add the gquic string to conn.log
		void confirm()
			{
			bro_analyzer()->ProtocolConfirmation();

			if ( BifConst::GQUIC::skip_after_confirm )
				bro_analyzer()->SetSkip(true);
			}

		uint16 extract_gquic_version(const uint8* version_bytes)
			{
			if ( version_bytes[0] != 'Q' )
				{
				bro_analyzer()->ProtocolViolation("invalid GQUIC Version",
				    reinterpret_cast<const char*>(version_bytes), 4);
				return 0;
				}

			for ( auto i = 1u; i < 4; ++i )
				{
				if ( ! isdigit(version_bytes[i]) )
					{
					bro_analyzer()->ProtocolViolation(
					    "invalid GQUIC Version",
				        reinterpret_cast<const char*>(version_bytes), 4);
					return 0;
					}
				}

			uint16 rval = 0;
			rval += (version_bytes[1] - 0x30) * 100;
			rval += (version_bytes[2] - 0x30) * 10;
			rval += (version_bytes[3] - 0x30);
			return rval;
			}
	
	GQUIC_Flow * upflow_;
	GQUIC_Flow * downflow_;
	BroAnalyzer bro_analyzer_;
};


class GQUIC_Packet
{
public:
	GQUIC_Packet(bool is_orig);
	~GQUIC_Packet();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextGQUIC * t_context);
	
	// Member access functions
	PublicFlags * flags() const { return flags_; }
	int content_case_index() const	{ return content_case_index_; }
	RegularPacket * reg_pkt() const
		{
		switch ( content_case_index() )
			{
			case ((int) 0):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:15:reg_pkt", (int64)content_case_index(), "REGULAR");
				break;
			}
		return reg_pkt_;
		}
	OldPacket * old_pkt() const
		{
		switch ( content_case_index() )
			{
			case ((int) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:16:old_pkt", (int64)content_case_index(), "OLDER");
				break;
			}
		return old_pkt_;
		}
	int unencrypted_search_case_index() const	{ return unencrypted_search_case_index_; }
	UnencryptedSearch * search() const
		{
		switch ( unencrypted_search_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:22:search", (int64)unencrypted_search_case_index(), "true");
				break;
			}
		return search_;
		}
	bool is_orig() const { return is_orig_; }
	int byteorder() const { return byteorder_; }
	int proc() const { return proc_; }
	
protected:
	PublicFlags * flags_;
	int content_case_index_;
	RegularPacket * reg_pkt_;
	OldPacket * old_pkt_;
	int unencrypted_search_case_index_;
	UnencryptedSearch * search_;
	const_bytestring frames_;
	bool is_orig_;
	int byteorder_;
	int proc_;
};


class PublicFlags
{
public:
	PublicFlags(bool is_orig);
	~PublicFlags();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	uint8 byte() const { return byte_; }
	bool is_orig() const { return is_orig_; }
	int length() const { return length_; }
	bool hello_length() const { return hello_length_; }
	bool is_long() const { return is_long_; }
	bool fixed_bit() const { return fixed_bit_; }
	bool type_initial() const { return type_initial_; }
	bool type_0rtt() const { return type_0rtt_; }
	bool type_handshake() const { return type_handshake_; }
	bool type_retry() const { return type_retry_; }
	uint8 pkt_num_size() const { return pkt_num_size_; }
	bool have_version() const { return have_version_; }
	bool have_nonce() const { return have_nonce_; }
	bool have_conn_id() const { return have_conn_id_; }
	uint8 pkt_num_size_old() const { return pkt_num_size_old_; }
	int packet_type() const { return packet_type_; }
	bool cid_exists() const { return cid_exists_; }
	const_bytestring const & sourcedata() const { return sourcedata_; }
	
protected:
	uint8 byte_;
	bool is_orig_;
	int length_;
	bool hello_length_;
	bool is_long_;
	bool fixed_bit_;
	bool type_initial_;
	bool type_0rtt_;
	bool type_handshake_;
	bool type_retry_;
	uint8 pkt_num_size_;
	bool have_version_;
	bool have_nonce_;
	bool have_conn_id_;
	uint8 pkt_num_size_old_;
	int packet_type_;
	bool cid_exists_;
	const_bytestring sourcedata_;
};


class OldPacket
{
public:
	OldPacket(PublicFlags * flags, bool is_orig);
	~OldPacket();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	ConnectionIDOld * cid() const { return cid_; }
	int version_case_index() const	{ return version_case_index_; }
	vector<uint8> * version_val() const
		{
		switch ( version_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:61:version_val", (int64)version_case_index(), "true");
				break;
			}
		return version_val_;
		}
	int nonce_case_index() const	{ return nonce_case_index_; }
	vector<uint8> * nonce_val() const
		{
		switch ( nonce_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:66:nonce_val", (int64)nonce_case_index(), "true");
				break;
			}
		return nonce_val_;
		}
	uint8 pkt_num_bytes_case_index() const	{ return pkt_num_bytes_case_index_; }
	vector<uint8> * pkt_num_bytes1() const
		{
		switch ( pkt_num_bytes_case_index() )
			{
			case ((uint8) 0):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:71:pkt_num_bytes1", (int64)pkt_num_bytes_case_index(), "((int) 0x00)");
				break;
			}
		return pkt_num_bytes1_;
		}
	vector<uint8> * pkt_num_bytes2() const
		{
		switch ( pkt_num_bytes_case_index() )
			{
			case ((uint8) 16):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:72:pkt_num_bytes2", (int64)pkt_num_bytes_case_index(), "((int) 0x10)");
				break;
			}
		return pkt_num_bytes2_;
		}
	vector<uint8> * pkt_num_bytes4() const
		{
		switch ( pkt_num_bytes_case_index() )
			{
			case ((uint8) 32):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:73:pkt_num_bytes4", (int64)pkt_num_bytes_case_index(), "((int) 0x20)");
				break;
			}
		return pkt_num_bytes4_;
		}
	vector<uint8> * pkt_num_bytes6() const
		{
		switch ( pkt_num_bytes_case_index() )
			{
			case ((uint8) 48):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:74:pkt_num_bytes6", (int64)pkt_num_bytes_case_index(), "((int) 0x30)");
				break;
			}
		return pkt_num_bytes6_;
		}
	PublicFlags * flags() const { return flags_; }
	bool is_orig() const { return is_orig_; }
	int byteorder() const { return byteorder_; }
	
protected:
	ConnectionIDOld * cid_;
	int version_case_index_;
	vector<uint8> * version_val_;
	uint8 version_val__elem_;
	int nonce_case_index_;
	vector<uint8> * nonce_val_;
	uint8 nonce_val__elem_;
	uint8 pkt_num_bytes_case_index_;
	vector<uint8> * pkt_num_bytes1_;
	uint8 pkt_num_bytes1__elem_;
	vector<uint8> * pkt_num_bytes2_;
	uint8 pkt_num_bytes2__elem_;
	vector<uint8> * pkt_num_bytes4_;
	uint8 pkt_num_bytes4__elem_;
	vector<uint8> * pkt_num_bytes6_;
	uint8 pkt_num_bytes6__elem_;
	PublicFlags * flags_;
	bool is_orig_;
	int byteorder_;
};


class ConnectionIDOld
{
public:
	ConnectionIDOld(PublicFlags * flags);
	~ConnectionIDOld();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int present_case_index() const	{ return present_case_index_; }
	vector<uint8> * bytes() const
		{
		switch ( present_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:81:bytes", (int64)present_case_index(), "true");
				break;
			}
		return bytes_;
		}
	PublicFlags * flags() const { return flags_; }
	
protected:
	int present_case_index_;
	vector<uint8> * bytes_;
	uint8 bytes__elem_;
	PublicFlags * flags_;
};


class RegularPacket
{
public:
	RegularPacket(PublicFlags * flags, bool is_orig);
	~RegularPacket();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int version_case_index() const	{ return version_case_index_; }
	bytestring const & version_val() const
		{
		switch ( version_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:88:version_val", (int64)version_case_index(), "true");
				break;
			}
		return version_val_;
		}
	int dcil_scil_case_index() const	{ return dcil_scil_case_index_; }
	uint8 conn_id() const
		{
		switch ( dcil_scil_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:92:conn_id", (int64)dcil_scil_case_index(), "true");
				break;
			}
		return conn_id_;
		}
	ConnectionID * cid() const { return cid_; }
	uint8 pkt_num_bytes_case_index() const	{ return pkt_num_bytes_case_index_; }
	vector<uint8> * pkt_num_bytes1() const
		{
		switch ( pkt_num_bytes_case_index() )
			{
			case ((uint8) 0):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:98:pkt_num_bytes1", (int64)pkt_num_bytes_case_index(), "((int) 0x00)");
				break;
			}
		return pkt_num_bytes1_;
		}
	vector<uint8> * pkt_num_bytes2() const
		{
		switch ( pkt_num_bytes_case_index() )
			{
			case ((uint8) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:99:pkt_num_bytes2", (int64)pkt_num_bytes_case_index(), "((int) 0x01)");
				break;
			}
		return pkt_num_bytes2_;
		}
	vector<uint8> * pkt_num_bytes3() const
		{
		switch ( pkt_num_bytes_case_index() )
			{
			case ((uint8) 2):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:100:pkt_num_bytes3", (int64)pkt_num_bytes_case_index(), "((int) 0x02)");
				break;
			}
		return pkt_num_bytes3_;
		}
	vector<uint8> * pkt_num_bytes4() const
		{
		switch ( pkt_num_bytes_case_index() )
			{
			case ((uint8) 3):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:101:pkt_num_bytes4", (int64)pkt_num_bytes_case_index(), "((int) 0x03)");
				break;
			}
		return pkt_num_bytes4_;
		}
	PublicFlags * flags() const { return flags_; }
	bool is_orig() const { return is_orig_; }
	
protected:
	int version_case_index_;
	bytestring version_val_;
	int dcil_scil_case_index_;
	uint8 conn_id_;
	ConnectionID * cid_;
	uint8 pkt_num_bytes_case_index_;
	vector<uint8> * pkt_num_bytes1_;
	uint8 pkt_num_bytes1__elem_;
	vector<uint8> * pkt_num_bytes2_;
	uint8 pkt_num_bytes2__elem_;
	vector<uint8> * pkt_num_bytes3_;
	uint8 pkt_num_bytes3__elem_;
	vector<uint8> * pkt_num_bytes4_;
	uint8 pkt_num_bytes4__elem_;
	PublicFlags * flags_;
	bool is_orig_;
};


class ConnectionID
{
public:
	ConnectionID(PublicFlags * flags);
	~ConnectionID();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int present_case_index() const	{ return present_case_index_; }
	vector<uint8> * bytes() const
		{
		switch ( present_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:109:bytes", (int64)present_case_index(), "true");
				break;
			}
		return bytes_;
		}
	PublicFlags * flags() const { return flags_; }
	
protected:
	int present_case_index_;
	vector<uint8> * bytes_;
	uint8 bytes__elem_;
	PublicFlags * flags_;
};


class UnencryptedSearch
{
public:
	UnencryptedSearch(PublicFlags * flags, bool is_orig);
	~UnencryptedSearch();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder);
	
	// Member access functions
	vector<uint8> * msg_auth_hash() const { return msg_auth_hash_; }
	StreamID * stream() const { return stream_; }
	SId * sid() const { return sid_; }
	NewerVersions * extra() const { return extra_; }
	StreamOffset * offset() const { return offset_; }
	DataLength * data_len() const { return data_len_; }
	HelloCheck * expected_string() const { return expected_string_; }
	TypeHello * build_hello() const { return build_hello_; }
	PublicFlags * flags() const { return flags_; }
	bool is_orig() const { return is_orig_; }
	
protected:
	vector<uint8> * msg_auth_hash_;
	uint8 msg_auth_hash__elem_;
	StreamID * stream_;
	SId * sid_;
	NewerVersions * extra_;
	StreamOffset * offset_;
	DataLength * data_len_;
	HelloCheck * expected_string_;
	TypeHello * build_hello_;
	PublicFlags * flags_;
	bool is_orig_;
};


class StreamID
{
public:
	StreamID(PublicFlags * flags);
	~StreamID();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	uint8 byte() const { return byte_; }
	PublicFlags * flags() const { return flags_; }
	bool streams() const { return streams_; }
	bool extra_bit() const { return extra_bit_; }
	bool data_length() const { return data_length_; }
	int offset_length() const { return offset_length_; }
	bool fin_bit() const { return fin_bit_; }
	
protected:
	uint8 byte_;
	PublicFlags * flags_;
	bool streams_;
	bool extra_bit_;
	bool data_length_;
	int offset_length_;
	bool fin_bit_;
};


class SId
{
public:
	SId(StreamID * stream);
	~SId();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int is_stream_case_index() const	{ return is_stream_case_index_; }
	uint8 id() const
		{
		switch ( is_stream_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:138:id", (int64)is_stream_case_index(), "true");
				break;
			}
		return id_;
		}
	StreamID * stream() const { return stream_; }
	
protected:
	int is_stream_case_index_;
	uint8 id_;
	StreamID * stream_;
};


class NewerVersions
{
public:
	NewerVersions(StreamID * stream);
	~NewerVersions();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int extra_space_case_index() const	{ return extra_space_case_index_; }
	vector<uint8> * plus_six() const
		{
		switch ( extra_space_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:145:plus_six", (int64)extra_space_case_index(), "true");
				break;
			}
		return plus_six_;
		}
	StreamID * stream() const { return stream_; }
	
protected:
	int extra_space_case_index_;
	vector<uint8> * plus_six_;
	uint8 plus_six__elem_;
	StreamID * stream_;
};


class DataLength
{
public:
	DataLength(StreamID * stream);
	~DataLength();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder);
	
	// Member access functions
	int len_case_index() const	{ return len_case_index_; }
	uint16 yes() const
		{
		switch ( len_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:151:yes", (int64)len_case_index(), "true");
				break;
			}
		return yes_;
		}
	StreamID * stream() const { return stream_; }
	
protected:
	int len_case_index_;
	uint16 yes_;
	StreamID * stream_;
};


class StreamOffset
{
public:
	StreamOffset(StreamID * stream);
	~StreamOffset();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int offset_type_case_index() const	{ return offset_type_case_index_; }
	vector<uint8> * pkt_offset_bytes2() const
		{
		switch ( offset_type_case_index() )
			{
			case ((int) 4):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:159:pkt_offset_bytes2", (int64)offset_type_case_index(), "((int) 0x04)");
				break;
			}
		return pkt_offset_bytes2_;
		}
	vector<uint8> * pkt_offset_bytes3() const
		{
		switch ( offset_type_case_index() )
			{
			case ((int) 8):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:160:pkt_offset_bytes3", (int64)offset_type_case_index(), "((int) 0x08)");
				break;
			}
		return pkt_offset_bytes3_;
		}
	vector<uint8> * pkt_offset_bytes4() const
		{
		switch ( offset_type_case_index() )
			{
			case ((int) 12):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:161:pkt_offset_bytes4", (int64)offset_type_case_index(), "((int) 0x0c)");
				break;
			}
		return pkt_offset_bytes4_;
		}
	vector<uint8> * pkt_offset_bytes5() const
		{
		switch ( offset_type_case_index() )
			{
			case ((int) 16):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:162:pkt_offset_bytes5", (int64)offset_type_case_index(), "((int) 0x10)");
				break;
			}
		return pkt_offset_bytes5_;
		}
	vector<uint8> * pkt_offset_bytes6() const
		{
		switch ( offset_type_case_index() )
			{
			case ((int) 20):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:163:pkt_offset_bytes6", (int64)offset_type_case_index(), "((int) 0x14)");
				break;
			}
		return pkt_offset_bytes6_;
		}
	vector<uint8> * pkt_offset_bytes7() const
		{
		switch ( offset_type_case_index() )
			{
			case ((int) 24):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:164:pkt_offset_bytes7", (int64)offset_type_case_index(), "((int) 0x18)");
				break;
			}
		return pkt_offset_bytes7_;
		}
	vector<uint8> * pkt_offset_bytes8() const
		{
		switch ( offset_type_case_index() )
			{
			case ((int) 28):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:165:pkt_offset_bytes8", (int64)offset_type_case_index(), "((int) 0x1c)");
				break;
			}
		return pkt_offset_bytes8_;
		}
	StreamID * stream() const { return stream_; }
	
protected:
	int offset_type_case_index_;
	vector<uint8> * pkt_offset_bytes2_;
	uint8 pkt_offset_bytes2__elem_;
	vector<uint8> * pkt_offset_bytes3_;
	uint8 pkt_offset_bytes3__elem_;
	vector<uint8> * pkt_offset_bytes4_;
	uint8 pkt_offset_bytes4__elem_;
	vector<uint8> * pkt_offset_bytes5_;
	uint8 pkt_offset_bytes5__elem_;
	vector<uint8> * pkt_offset_bytes6_;
	uint8 pkt_offset_bytes6__elem_;
	vector<uint8> * pkt_offset_bytes7_;
	uint8 pkt_offset_bytes7__elem_;
	vector<uint8> * pkt_offset_bytes8_;
	uint8 pkt_offset_bytes8__elem_;
	StreamID * stream_;
};


class HelloCheck
{
public:
	HelloCheck(PublicFlags * flags, bool is_orig);
	~HelloCheck();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	bytestring const & hello_string() const { return hello_string_; }
	PublicFlags * flags() const { return flags_; }
	bool is_orig() const { return is_orig_; }
	bool hello_check() const { return hello_check_; }
	bool rej_check() const { return rej_check_; }
	
protected:
	bytestring hello_string_;
	PublicFlags * flags_;
	bool is_orig_;
	bool hello_check_;
	bool rej_check_;
};


class TypeHello
{
public:
	TypeHello(PublicFlags * flags, bool is_orig, HelloCheck * expected_string);
	~TypeHello();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder);
	
	// Member access functions
	int client_case_index() const	{ return client_case_index_; }
	HelloPacket * yes() const
		{
		switch ( client_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:181:yes", (int64)client_case_index(), "true");
				break;
			}
		return yes_;
		}
	int server_case_index() const	{ return server_case_index_; }
	RejPacket * rej() const
		{
		switch ( server_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:185:rej", (int64)server_case_index(), "true");
				break;
			}
		return rej_;
		}
	PublicFlags * flags() const { return flags_; }
	bool is_orig() const { return is_orig_; }
	HelloCheck * expected_string() const { return expected_string_; }
	
protected:
	int client_case_index_;
	HelloPacket * yes_;
	int server_case_index_;
	RejPacket * rej_;
	PublicFlags * flags_;
	bool is_orig_;
	HelloCheck * expected_string_;
};


class HelloPacket
{
public:
	HelloPacket(PublicFlags * flags, bool is_orig);
	~HelloPacket();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint16 tag_number() const { return tag_number_; }
	uint16 zero_pading() const { return zero_pading_; }
	TagFinder * other_tags() const { return other_tags_; }
	ExtractPAD * pad() const { return pad_; }
	ExtractSNI * sni() const { return sni_; }
	ExtractSTK * stk() const { return stk_; }
	ExtractSNO * sno() const { return sno_; }
	ExtractVER * ver() const { return ver_; }
	ExtractCCS * ccs() const { return ccs_; }
	ExtractNONC * nonc() const { return nonc_; }
	ExtractMSPC * mspc() const { return mspc_; }
	ExtractAEAD * aead() const { return aead_; }
	ExtractUAID * uaid() const { return uaid_; }
	ExtractSCID * scid() const { return scid_; }
	ExtractTCID * tcid() const { return tcid_; }
	ExtractPDMD * pdmd() const { return pdmd_; }
	ExtractSMHL * smhl() const { return smhl_; }
	ExtractICSL * icsl() const { return icsl_; }
	ExtractCTIM * ctim() const { return ctim_; }
	ExtractNONP * nonp() const { return nonp_; }
	ExtractPUBS * pubs() const { return pubs_; }
	ExtractMIDS * mids() const { return mids_; }
	ExtractSCLS * scls() const { return scls_; }
	ExtractKEXS * kexs() const { return kexs_; }
	ExtractXLCT * xlct() const { return xlct_; }
	ExtractCSCT * csct() const { return csct_; }
	ExtractCOPT * copt() const { return copt_; }
	ExtractCCRT * ccrt() const { return ccrt_; }
	ExtractIRTT * irtt() const { return irtt_; }
	ExtractCETV * cetv() const { return cetv_; }
	ExtractCFCW * cfcw() const { return cfcw_; }
	ExtractSFCW * sfcw() const { return sfcw_; }
	PublicFlags * flags() const { return flags_; }
	bool is_orig() const { return is_orig_; }
	int p_tag_offset() const { return p_tag_offset_; }
	
protected:
	uint16 tag_number_;
	uint16 zero_pading_;
	TagFinder * other_tags_;
	ExtractPAD * pad_;
	ExtractSNI * sni_;
	ExtractSTK * stk_;
	ExtractSNO * sno_;
	ExtractVER * ver_;
	ExtractCCS * ccs_;
	ExtractNONC * nonc_;
	ExtractMSPC * mspc_;
	ExtractAEAD * aead_;
	ExtractUAID * uaid_;
	ExtractSCID * scid_;
	ExtractTCID * tcid_;
	ExtractPDMD * pdmd_;
	ExtractSMHL * smhl_;
	ExtractICSL * icsl_;
	ExtractCTIM * ctim_;
	ExtractNONP * nonp_;
	ExtractPUBS * pubs_;
	ExtractMIDS * mids_;
	ExtractSCLS * scls_;
	ExtractKEXS * kexs_;
	ExtractXLCT * xlct_;
	ExtractCSCT * csct_;
	ExtractCOPT * copt_;
	ExtractCCRT * ccrt_;
	ExtractIRTT * irtt_;
	ExtractCETV * cetv_;
	ExtractCFCW * cfcw_;
	ExtractSFCW * sfcw_;
	PublicFlags * flags_;
	bool is_orig_;
	int p_tag_offset_;
};


class RejPacket
{
public:
	RejPacket(PublicFlags * flags, bool is_orig);
	~RejPacket();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint16 tag_number() const { return tag_number_; }
	uint16 zero_pading() const { return zero_pading_; }
	TagFinder * other_tags() const { return other_tags_; }
	ExtractSTK * stk() const { return stk_; }
	ExtractSNO * sno() const { return sno_; }
	ExtractSVID * svid() const { return svid_; }
	ExtractPROF * prof() const { return prof_; }
	ExtractSCFG * scfg() const { return scfg_; }
	ExtractRREJ * rrej() const { return rrej_; }
	ExtractSTTL * sttl() const { return sttl_; }
	ExtractCSCT * csct() const { return csct_; }
	PublicFlags * flags() const { return flags_; }
	bool is_orig() const { return is_orig_; }
	int p_tag_offset() const { return p_tag_offset_; }
	
protected:
	uint16 tag_number_;
	uint16 zero_pading_;
	TagFinder * other_tags_;
	ExtractSTK * stk_;
	ExtractSNO * sno_;
	ExtractSVID * svid_;
	ExtractPROF * prof_;
	ExtractSCFG * scfg_;
	ExtractRREJ * rrej_;
	ExtractSTTL * sttl_;
	ExtractCSCT * csct_;
	PublicFlags * flags_;
	bool is_orig_;
	int p_tag_offset_;
};


class RejPacketSCFG
{
public:
	RejPacketSCFG();
	~RejPacketSCFG();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	bytestring const & tag() const { return tag_; }
	uint32 tag_number() const { return tag_number_; }
	TagFinder * other_tags() const { return other_tags_; }
	ExtractVER * ver() const { return ver_; }
	ExtractAEAD * aead() const { return aead_; }
	ExtractSCID * scid() const { return scid_; }
	ExtractPDMD * pdmd() const { return pdmd_; }
	ExtractTBKP * tbkp() const { return tbkp_; }
	ExtractPUBS * pubs() const { return pubs_; }
	ExtractKEXS * kexs() const { return kexs_; }
	ExtractOBIT * obit() const { return obit_; }
	ExtractEXPY * expy() const { return expy_; }
	int p_tag_offset() const { return p_tag_offset_; }
	
protected:
	bytestring tag_;
	uint32 tag_number_;
	TagFinder * other_tags_;
	ExtractVER * ver_;
	ExtractAEAD * aead_;
	ExtractSCID * scid_;
	ExtractPDMD * pdmd_;
	ExtractTBKP * tbkp_;
	ExtractPUBS * pubs_;
	ExtractKEXS * kexs_;
	ExtractOBIT * obit_;
	ExtractEXPY * expy_;
	int p_tag_offset_;
};


class ExtractPAD
{
public:
	ExtractPAD(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset);
	~ExtractPAD();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int exists_case_index() const	{ return exists_case_index_; }
	bytestring const & collect() const
		{
		switch ( exists_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:266:collect", (int64)exists_case_index(), "true");
				break;
			}
		return collect_;
		}
	TagFinder * other_tags() const { return other_tags_; }
	uint16 tag_number() const { return tag_number_; }
	uint32 p_tag_offset() const { return p_tag_offset_; }
	
protected:
	int exists_case_index_;
	bytestring collect_;
	TagFinder * other_tags_;
	uint16 tag_number_;
	uint32 p_tag_offset_;
};


class ExtractSNI
{
public:
	ExtractSNI(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset);
	~ExtractSNI();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int exists_case_index() const	{ return exists_case_index_; }
	bytestring const & collect() const
		{
		switch ( exists_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:273:collect", (int64)exists_case_index(), "true");
				break;
			}
		return collect_;
		}
	TagFinder * other_tags() const { return other_tags_; }
	uint16 tag_number() const { return tag_number_; }
	uint32 p_tag_offset() const { return p_tag_offset_; }
	
protected:
	int exists_case_index_;
	bytestring collect_;
	TagFinder * other_tags_;
	uint16 tag_number_;
	uint32 p_tag_offset_;
};


class ExtractSTK
{
public:
	ExtractSTK(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset);
	~ExtractSTK();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int exists_case_index() const	{ return exists_case_index_; }
	bytestring const & collect() const
		{
		switch ( exists_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:280:collect", (int64)exists_case_index(), "true");
				break;
			}
		return collect_;
		}
	TagFinder * other_tags() const { return other_tags_; }
	uint16 tag_number() const { return tag_number_; }
	uint32 p_tag_offset() const { return p_tag_offset_; }
	
protected:
	int exists_case_index_;
	bytestring collect_;
	TagFinder * other_tags_;
	uint16 tag_number_;
	uint32 p_tag_offset_;
};


class ExtractSNO
{
public:
	ExtractSNO(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset);
	~ExtractSNO();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int exists_case_index() const	{ return exists_case_index_; }
	bytestring const & collect() const
		{
		switch ( exists_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:287:collect", (int64)exists_case_index(), "true");
				break;
			}
		return collect_;
		}
	TagFinder * other_tags() const { return other_tags_; }
	uint16 tag_number() const { return tag_number_; }
	uint32 p_tag_offset() const { return p_tag_offset_; }
	
protected:
	int exists_case_index_;
	bytestring collect_;
	TagFinder * other_tags_;
	uint16 tag_number_;
	uint32 p_tag_offset_;
};


class ExtractVER
{
public:
	ExtractVER(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset);
	~ExtractVER();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int exists_case_index() const	{ return exists_case_index_; }
	bytestring const & collect() const
		{
		switch ( exists_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:294:collect", (int64)exists_case_index(), "true");
				break;
			}
		return collect_;
		}
	TagFinder * other_tags() const { return other_tags_; }
	uint16 tag_number() const { return tag_number_; }
	uint32 p_tag_offset() const { return p_tag_offset_; }
	
protected:
	int exists_case_index_;
	bytestring collect_;
	TagFinder * other_tags_;
	uint16 tag_number_;
	uint32 p_tag_offset_;
};


class ExtractCCS
{
public:
	ExtractCCS(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset);
	~ExtractCCS();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int exists_case_index() const	{ return exists_case_index_; }
	bytestring const & collect() const
		{
		switch ( exists_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:302:collect", (int64)exists_case_index(), "true");
				break;
			}
		return collect_;
		}
	TagFinder * other_tags() const { return other_tags_; }
	uint16 tag_number() const { return tag_number_; }
	uint32 p_tag_offset() const { return p_tag_offset_; }
	
protected:
	int exists_case_index_;
	bytestring collect_;
	TagFinder * other_tags_;
	uint16 tag_number_;
	uint32 p_tag_offset_;
};


class ExtractCRT
{
public:
	ExtractCRT(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset);
	~ExtractCRT();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int exists_case_index() const	{ return exists_case_index_; }
	bytestring const & collect() const
		{
		switch ( exists_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:309:collect", (int64)exists_case_index(), "true");
				break;
			}
		return collect_;
		}
	TagFinder * other_tags() const { return other_tags_; }
	uint16 tag_number() const { return tag_number_; }
	uint32 p_tag_offset() const { return p_tag_offset_; }
	
protected:
	int exists_case_index_;
	bytestring collect_;
	TagFinder * other_tags_;
	uint16 tag_number_;
	uint32 p_tag_offset_;
};


class ExtractNONC
{
public:
	ExtractNONC(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset);
	~ExtractNONC();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int exists_case_index() const	{ return exists_case_index_; }
	bytestring const & collect() const
		{
		switch ( exists_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:316:collect", (int64)exists_case_index(), "true");
				break;
			}
		return collect_;
		}
	TagFinder * other_tags() const { return other_tags_; }
	uint16 tag_number() const { return tag_number_; }
	uint32 p_tag_offset() const { return p_tag_offset_; }
	
protected:
	int exists_case_index_;
	bytestring collect_;
	TagFinder * other_tags_;
	uint16 tag_number_;
	uint32 p_tag_offset_;
};


class ExtractMSPC
{
public:
	ExtractMSPC(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset);
	~ExtractMSPC();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int exists_case_index() const	{ return exists_case_index_; }
	bytestring const & collect() const
		{
		switch ( exists_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:323:collect", (int64)exists_case_index(), "true");
				break;
			}
		return collect_;
		}
	TagFinder * other_tags() const { return other_tags_; }
	uint16 tag_number() const { return tag_number_; }
	uint32 p_tag_offset() const { return p_tag_offset_; }
	
protected:
	int exists_case_index_;
	bytestring collect_;
	TagFinder * other_tags_;
	uint16 tag_number_;
	uint32 p_tag_offset_;
};


class ExtractAEAD
{
public:
	ExtractAEAD(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset);
	~ExtractAEAD();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int exists_case_index() const	{ return exists_case_index_; }
	bytestring const & collect() const
		{
		switch ( exists_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:330:collect", (int64)exists_case_index(), "true");
				break;
			}
		return collect_;
		}
	TagFinder * other_tags() const { return other_tags_; }
	uint16 tag_number() const { return tag_number_; }
	uint32 p_tag_offset() const { return p_tag_offset_; }
	
protected:
	int exists_case_index_;
	bytestring collect_;
	TagFinder * other_tags_;
	uint16 tag_number_;
	uint32 p_tag_offset_;
};


class ExtractUAID
{
public:
	ExtractUAID(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset);
	~ExtractUAID();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int exists_case_index() const	{ return exists_case_index_; }
	bytestring const & collect() const
		{
		switch ( exists_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:337:collect", (int64)exists_case_index(), "true");
				break;
			}
		return collect_;
		}
	TagFinder * other_tags() const { return other_tags_; }
	uint16 tag_number() const { return tag_number_; }
	uint32 p_tag_offset() const { return p_tag_offset_; }
	
protected:
	int exists_case_index_;
	bytestring collect_;
	TagFinder * other_tags_;
	uint16 tag_number_;
	uint32 p_tag_offset_;
};


class ExtractSCID
{
public:
	ExtractSCID(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset);
	~ExtractSCID();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int exists_case_index() const	{ return exists_case_index_; }
	bytestring const & collect() const
		{
		switch ( exists_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:344:collect", (int64)exists_case_index(), "true");
				break;
			}
		return collect_;
		}
	TagFinder * other_tags() const { return other_tags_; }
	uint16 tag_number() const { return tag_number_; }
	uint32 p_tag_offset() const { return p_tag_offset_; }
	
protected:
	int exists_case_index_;
	bytestring collect_;
	TagFinder * other_tags_;
	uint16 tag_number_;
	uint32 p_tag_offset_;
};


class ExtractTCID
{
public:
	ExtractTCID(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset);
	~ExtractTCID();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int exists_case_index() const	{ return exists_case_index_; }
	bytestring const & collect() const
		{
		switch ( exists_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:351:collect", (int64)exists_case_index(), "true");
				break;
			}
		return collect_;
		}
	TagFinder * other_tags() const { return other_tags_; }
	uint16 tag_number() const { return tag_number_; }
	uint32 p_tag_offset() const { return p_tag_offset_; }
	
protected:
	int exists_case_index_;
	bytestring collect_;
	TagFinder * other_tags_;
	uint16 tag_number_;
	uint32 p_tag_offset_;
};


class ExtractPDMD
{
public:
	ExtractPDMD(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset);
	~ExtractPDMD();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int exists_case_index() const	{ return exists_case_index_; }
	bytestring const & collect() const
		{
		switch ( exists_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:358:collect", (int64)exists_case_index(), "true");
				break;
			}
		return collect_;
		}
	TagFinder * other_tags() const { return other_tags_; }
	uint16 tag_number() const { return tag_number_; }
	uint32 p_tag_offset() const { return p_tag_offset_; }
	
protected:
	int exists_case_index_;
	bytestring collect_;
	TagFinder * other_tags_;
	uint16 tag_number_;
	uint32 p_tag_offset_;
};


class ExtractSMHL
{
public:
	ExtractSMHL(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset);
	~ExtractSMHL();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int exists_case_index() const	{ return exists_case_index_; }
	bytestring const & collect() const
		{
		switch ( exists_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:365:collect", (int64)exists_case_index(), "true");
				break;
			}
		return collect_;
		}
	TagFinder * other_tags() const { return other_tags_; }
	uint16 tag_number() const { return tag_number_; }
	uint32 p_tag_offset() const { return p_tag_offset_; }
	
protected:
	int exists_case_index_;
	bytestring collect_;
	TagFinder * other_tags_;
	uint16 tag_number_;
	uint32 p_tag_offset_;
};


class ExtractICSL
{
public:
	ExtractICSL(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset);
	~ExtractICSL();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int exists_case_index() const	{ return exists_case_index_; }
	bytestring const & collect() const
		{
		switch ( exists_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:372:collect", (int64)exists_case_index(), "true");
				break;
			}
		return collect_;
		}
	TagFinder * other_tags() const { return other_tags_; }
	uint16 tag_number() const { return tag_number_; }
	uint32 p_tag_offset() const { return p_tag_offset_; }
	
protected:
	int exists_case_index_;
	bytestring collect_;
	TagFinder * other_tags_;
	uint16 tag_number_;
	uint32 p_tag_offset_;
};


class ExtractNONP
{
public:
	ExtractNONP(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset);
	~ExtractNONP();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int exists_case_index() const	{ return exists_case_index_; }
	bytestring const & collect() const
		{
		switch ( exists_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:379:collect", (int64)exists_case_index(), "true");
				break;
			}
		return collect_;
		}
	TagFinder * other_tags() const { return other_tags_; }
	uint16 tag_number() const { return tag_number_; }
	uint32 p_tag_offset() const { return p_tag_offset_; }
	
protected:
	int exists_case_index_;
	bytestring collect_;
	TagFinder * other_tags_;
	uint16 tag_number_;
	uint32 p_tag_offset_;
};


class ExtractPUBS
{
public:
	ExtractPUBS(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset);
	~ExtractPUBS();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int exists_case_index() const	{ return exists_case_index_; }
	bytestring const & collect() const
		{
		switch ( exists_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:386:collect", (int64)exists_case_index(), "true");
				break;
			}
		return collect_;
		}
	TagFinder * other_tags() const { return other_tags_; }
	uint16 tag_number() const { return tag_number_; }
	uint32 p_tag_offset() const { return p_tag_offset_; }
	
protected:
	int exists_case_index_;
	bytestring collect_;
	TagFinder * other_tags_;
	uint16 tag_number_;
	uint32 p_tag_offset_;
};


class ExtractMIDS
{
public:
	ExtractMIDS(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset);
	~ExtractMIDS();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int exists_case_index() const	{ return exists_case_index_; }
	bytestring const & collect() const
		{
		switch ( exists_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:393:collect", (int64)exists_case_index(), "true");
				break;
			}
		return collect_;
		}
	TagFinder * other_tags() const { return other_tags_; }
	uint16 tag_number() const { return tag_number_; }
	uint32 p_tag_offset() const { return p_tag_offset_; }
	
protected:
	int exists_case_index_;
	bytestring collect_;
	TagFinder * other_tags_;
	uint16 tag_number_;
	uint32 p_tag_offset_;
};


class ExtractSCLS
{
public:
	ExtractSCLS(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset);
	~ExtractSCLS();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int exists_case_index() const	{ return exists_case_index_; }
	bytestring const & collect() const
		{
		switch ( exists_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:400:collect", (int64)exists_case_index(), "true");
				break;
			}
		return collect_;
		}
	TagFinder * other_tags() const { return other_tags_; }
	uint16 tag_number() const { return tag_number_; }
	uint32 p_tag_offset() const { return p_tag_offset_; }
	
protected:
	int exists_case_index_;
	bytestring collect_;
	TagFinder * other_tags_;
	uint16 tag_number_;
	uint32 p_tag_offset_;
};


class ExtractKEXS
{
public:
	ExtractKEXS(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset);
	~ExtractKEXS();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int exists_case_index() const	{ return exists_case_index_; }
	bytestring const & collect() const
		{
		switch ( exists_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:407:collect", (int64)exists_case_index(), "true");
				break;
			}
		return collect_;
		}
	TagFinder * other_tags() const { return other_tags_; }
	uint16 tag_number() const { return tag_number_; }
	uint32 p_tag_offset() const { return p_tag_offset_; }
	
protected:
	int exists_case_index_;
	bytestring collect_;
	TagFinder * other_tags_;
	uint16 tag_number_;
	uint32 p_tag_offset_;
};


class ExtractXLCT
{
public:
	ExtractXLCT(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset);
	~ExtractXLCT();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int exists_case_index() const	{ return exists_case_index_; }
	bytestring const & collect() const
		{
		switch ( exists_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:414:collect", (int64)exists_case_index(), "true");
				break;
			}
		return collect_;
		}
	TagFinder * other_tags() const { return other_tags_; }
	uint16 tag_number() const { return tag_number_; }
	uint32 p_tag_offset() const { return p_tag_offset_; }
	
protected:
	int exists_case_index_;
	bytestring collect_;
	TagFinder * other_tags_;
	uint16 tag_number_;
	uint32 p_tag_offset_;
};


class ExtractCSCT
{
public:
	ExtractCSCT(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset);
	~ExtractCSCT();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int exists_case_index() const	{ return exists_case_index_; }
	bytestring const & collect() const
		{
		switch ( exists_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:421:collect", (int64)exists_case_index(), "true");
				break;
			}
		return collect_;
		}
	TagFinder * other_tags() const { return other_tags_; }
	uint16 tag_number() const { return tag_number_; }
	uint32 p_tag_offset() const { return p_tag_offset_; }
	
protected:
	int exists_case_index_;
	bytestring collect_;
	TagFinder * other_tags_;
	uint16 tag_number_;
	uint32 p_tag_offset_;
};


class ExtractCOPT
{
public:
	ExtractCOPT(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset);
	~ExtractCOPT();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int exists_case_index() const	{ return exists_case_index_; }
	bytestring const & collect() const
		{
		switch ( exists_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:428:collect", (int64)exists_case_index(), "true");
				break;
			}
		return collect_;
		}
	TagFinder * other_tags() const { return other_tags_; }
	uint16 tag_number() const { return tag_number_; }
	uint32 p_tag_offset() const { return p_tag_offset_; }
	
protected:
	int exists_case_index_;
	bytestring collect_;
	TagFinder * other_tags_;
	uint16 tag_number_;
	uint32 p_tag_offset_;
};


class ExtractCCRT
{
public:
	ExtractCCRT(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset);
	~ExtractCCRT();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int exists_case_index() const	{ return exists_case_index_; }
	bytestring const & collect() const
		{
		switch ( exists_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:435:collect", (int64)exists_case_index(), "true");
				break;
			}
		return collect_;
		}
	TagFinder * other_tags() const { return other_tags_; }
	uint16 tag_number() const { return tag_number_; }
	uint32 p_tag_offset() const { return p_tag_offset_; }
	
protected:
	int exists_case_index_;
	bytestring collect_;
	TagFinder * other_tags_;
	uint16 tag_number_;
	uint32 p_tag_offset_;
};


class ExtractIRTT
{
public:
	ExtractIRTT(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset);
	~ExtractIRTT();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int exists_case_index() const	{ return exists_case_index_; }
	bytestring const & collect() const
		{
		switch ( exists_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:442:collect", (int64)exists_case_index(), "true");
				break;
			}
		return collect_;
		}
	TagFinder * other_tags() const { return other_tags_; }
	uint16 tag_number() const { return tag_number_; }
	uint32 p_tag_offset() const { return p_tag_offset_; }
	
protected:
	int exists_case_index_;
	bytestring collect_;
	TagFinder * other_tags_;
	uint16 tag_number_;
	uint32 p_tag_offset_;
};


class ExtractCFCW
{
public:
	ExtractCFCW(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset);
	~ExtractCFCW();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int exists_case_index() const	{ return exists_case_index_; }
	bytestring const & collect() const
		{
		switch ( exists_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:449:collect", (int64)exists_case_index(), "true");
				break;
			}
		return collect_;
		}
	TagFinder * other_tags() const { return other_tags_; }
	uint16 tag_number() const { return tag_number_; }
	uint32 p_tag_offset() const { return p_tag_offset_; }
	
protected:
	int exists_case_index_;
	bytestring collect_;
	TagFinder * other_tags_;
	uint16 tag_number_;
	uint32 p_tag_offset_;
};


class ExtractSFCW
{
public:
	ExtractSFCW(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset);
	~ExtractSFCW();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int exists_case_index() const	{ return exists_case_index_; }
	bytestring const & collect() const
		{
		switch ( exists_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:456:collect", (int64)exists_case_index(), "true");
				break;
			}
		return collect_;
		}
	TagFinder * other_tags() const { return other_tags_; }
	uint16 tag_number() const { return tag_number_; }
	uint32 p_tag_offset() const { return p_tag_offset_; }
	
protected:
	int exists_case_index_;
	bytestring collect_;
	TagFinder * other_tags_;
	uint16 tag_number_;
	uint32 p_tag_offset_;
};


class ExtractPROF
{
public:
	ExtractPROF(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset);
	~ExtractPROF();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int exists_case_index() const	{ return exists_case_index_; }
	bytestring const & collect() const
		{
		switch ( exists_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:463:collect", (int64)exists_case_index(), "true");
				break;
			}
		return collect_;
		}
	TagFinder * other_tags() const { return other_tags_; }
	uint16 tag_number() const { return tag_number_; }
	uint32 p_tag_offset() const { return p_tag_offset_; }
	
protected:
	int exists_case_index_;
	bytestring collect_;
	TagFinder * other_tags_;
	uint16 tag_number_;
	uint32 p_tag_offset_;
};


class ExtractSCFG
{
public:
	ExtractSCFG(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset);
	~ExtractSCFG();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int exists_case_index() const	{ return exists_case_index_; }
	RejPacketSCFG * collect() const
		{
		switch ( exists_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:470:collect", (int64)exists_case_index(), "true");
				break;
			}
		return collect_;
		}
	TagFinder * other_tags() const { return other_tags_; }
	uint16 tag_number() const { return tag_number_; }
	uint32 p_tag_offset() const { return p_tag_offset_; }
	
protected:
	int exists_case_index_;
	RejPacketSCFG * collect_;
	TagFinder * other_tags_;
	uint16 tag_number_;
	uint32 p_tag_offset_;
};


class ExtractRREJ
{
public:
	ExtractRREJ(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset);
	~ExtractRREJ();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int exists_case_index() const	{ return exists_case_index_; }
	bytestring const & collect() const
		{
		switch ( exists_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:479:collect", (int64)exists_case_index(), "true");
				break;
			}
		return collect_;
		}
	TagFinder * other_tags() const { return other_tags_; }
	uint16 tag_number() const { return tag_number_; }
	uint32 p_tag_offset() const { return p_tag_offset_; }
	
protected:
	int exists_case_index_;
	bytestring collect_;
	TagFinder * other_tags_;
	uint16 tag_number_;
	uint32 p_tag_offset_;
};


class ExtractOBIT
{
public:
	ExtractOBIT(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset);
	~ExtractOBIT();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int exists_case_index() const	{ return exists_case_index_; }
	bytestring const & collect() const
		{
		switch ( exists_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:486:collect", (int64)exists_case_index(), "true");
				break;
			}
		return collect_;
		}
	TagFinder * other_tags() const { return other_tags_; }
	uint16 tag_number() const { return tag_number_; }
	uint32 p_tag_offset() const { return p_tag_offset_; }
	
protected:
	int exists_case_index_;
	bytestring collect_;
	TagFinder * other_tags_;
	uint16 tag_number_;
	uint32 p_tag_offset_;
};


class ExtractEXPY
{
public:
	ExtractEXPY(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset);
	~ExtractEXPY();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int exists_case_index() const	{ return exists_case_index_; }
	bytestring const & collect() const
		{
		switch ( exists_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:493:collect", (int64)exists_case_index(), "true");
				break;
			}
		return collect_;
		}
	TagFinder * other_tags() const { return other_tags_; }
	uint16 tag_number() const { return tag_number_; }
	uint32 p_tag_offset() const { return p_tag_offset_; }
	
protected:
	int exists_case_index_;
	bytestring collect_;
	TagFinder * other_tags_;
	uint16 tag_number_;
	uint32 p_tag_offset_;
};


class ExtractSRBF
{
public:
	ExtractSRBF(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset);
	~ExtractSRBF();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int exists_case_index() const	{ return exists_case_index_; }
	bytestring const & collect() const
		{
		switch ( exists_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:500:collect", (int64)exists_case_index(), "true");
				break;
			}
		return collect_;
		}
	TagFinder * other_tags() const { return other_tags_; }
	uint16 tag_number() const { return tag_number_; }
	uint32 p_tag_offset() const { return p_tag_offset_; }
	
protected:
	int exists_case_index_;
	bytestring collect_;
	TagFinder * other_tags_;
	uint16 tag_number_;
	uint32 p_tag_offset_;
};


class ExtractCETV
{
public:
	ExtractCETV(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset);
	~ExtractCETV();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int exists_case_index() const	{ return exists_case_index_; }
	bytestring const & collect() const
		{
		switch ( exists_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:507:collect", (int64)exists_case_index(), "true");
				break;
			}
		return collect_;
		}
	TagFinder * other_tags() const { return other_tags_; }
	uint16 tag_number() const { return tag_number_; }
	uint32 p_tag_offset() const { return p_tag_offset_; }
	
protected:
	int exists_case_index_;
	bytestring collect_;
	TagFinder * other_tags_;
	uint16 tag_number_;
	uint32 p_tag_offset_;
};


class ExtractCTIM
{
public:
	ExtractCTIM(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset);
	~ExtractCTIM();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int exists_case_index() const	{ return exists_case_index_; }
	bytestring const & collect() const
		{
		switch ( exists_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:514:collect", (int64)exists_case_index(), "true");
				break;
			}
		return collect_;
		}
	TagFinder * other_tags() const { return other_tags_; }
	uint16 tag_number() const { return tag_number_; }
	uint32 p_tag_offset() const { return p_tag_offset_; }
	
protected:
	int exists_case_index_;
	bytestring collect_;
	TagFinder * other_tags_;
	uint16 tag_number_;
	uint32 p_tag_offset_;
};


class ExtractFHOL
{
public:
	ExtractFHOL(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset);
	~ExtractFHOL();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int exists_case_index() const	{ return exists_case_index_; }
	bytestring const & collect() const
		{
		switch ( exists_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:521:collect", (int64)exists_case_index(), "true");
				break;
			}
		return collect_;
		}
	TagFinder * other_tags() const { return other_tags_; }
	uint16 tag_number() const { return tag_number_; }
	uint32 p_tag_offset() const { return p_tag_offset_; }
	
protected:
	int exists_case_index_;
	bytestring collect_;
	TagFinder * other_tags_;
	uint16 tag_number_;
	uint32 p_tag_offset_;
};


class ExtractSTTL
{
public:
	ExtractSTTL(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset);
	~ExtractSTTL();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int exists_case_index() const	{ return exists_case_index_; }
	bytestring const & collect() const
		{
		switch ( exists_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:528:collect", (int64)exists_case_index(), "true");
				break;
			}
		return collect_;
		}
	TagFinder * other_tags() const { return other_tags_; }
	uint16 tag_number() const { return tag_number_; }
	uint32 p_tag_offset() const { return p_tag_offset_; }
	
protected:
	int exists_case_index_;
	bytestring collect_;
	TagFinder * other_tags_;
	uint16 tag_number_;
	uint32 p_tag_offset_;
};


class ExtractTBKP
{
public:
	ExtractTBKP(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset);
	~ExtractTBKP();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int exists_case_index() const	{ return exists_case_index_; }
	bytestring const & collect() const
		{
		switch ( exists_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:535:collect", (int64)exists_case_index(), "true");
				break;
			}
		return collect_;
		}
	TagFinder * other_tags() const { return other_tags_; }
	uint16 tag_number() const { return tag_number_; }
	uint32 p_tag_offset() const { return p_tag_offset_; }
	
protected:
	int exists_case_index_;
	bytestring collect_;
	TagFinder * other_tags_;
	uint16 tag_number_;
	uint32 p_tag_offset_;
};


class ExtractSVID
{
public:
	ExtractSVID(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset);
	~ExtractSVID();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	int exists_case_index() const	{ return exists_case_index_; }
	bytestring const & collect() const
		{
		switch ( exists_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:542:collect", (int64)exists_case_index(), "true");
				break;
			}
		return collect_;
		}
	TagFinder * other_tags() const { return other_tags_; }
	uint16 tag_number() const { return tag_number_; }
	uint32 p_tag_offset() const { return p_tag_offset_; }
	
protected:
	int exists_case_index_;
	bytestring collect_;
	TagFinder * other_tags_;
	uint16 tag_number_;
	uint32 p_tag_offset_;
};


class TagFinder
{
public:
	TagFinder(uint16 tag_number);
	~TagFinder();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	bytestring const & seek_tags() const { return seek_tags_; }
	uint16 tag_number() const { return tag_number_; }
	bool pad_check() const { return pad_check_; }
	bool sni_check() const { return sni_check_; }
	bool stk_check() const { return stk_check_; }
	bool sno_check() const { return sno_check_; }
	bool ver_check() const { return ver_check_; }
	bool ccs_check() const { return ccs_check_; }
	bool crt_check() const { return crt_check_; }
	bool nonc_check() const { return nonc_check_; }
	bool mspc_check() const { return mspc_check_; }
	bool aead_check() const { return aead_check_; }
	bool uaid_check() const { return uaid_check_; }
	bool scid_check() const { return scid_check_; }
	bool tcid_check() const { return tcid_check_; }
	bool pdmd_check() const { return pdmd_check_; }
	bool smhl_check() const { return smhl_check_; }
	bool icsl_check() const { return icsl_check_; }
	bool nonp_check() const { return nonp_check_; }
	bool pubs_check() const { return pubs_check_; }
	bool mids_check() const { return mids_check_; }
	bool scls_check() const { return scls_check_; }
	bool kexs_check() const { return kexs_check_; }
	bool xlct_check() const { return xlct_check_; }
	bool csct_check() const { return csct_check_; }
	bool copt_check() const { return copt_check_; }
	bool ccrt_check() const { return ccrt_check_; }
	bool irtt_check() const { return irtt_check_; }
	bool cfcw_check() const { return cfcw_check_; }
	bool sfcw_check() const { return sfcw_check_; }
	bool prof_check() const { return prof_check_; }
	bool scfg_check() const { return scfg_check_; }
	bool rrej_check() const { return rrej_check_; }
	bool obit_check() const { return obit_check_; }
	bool expy_check() const { return expy_check_; }
	bool srbf_check() const { return srbf_check_; }
	bool cetv_check() const { return cetv_check_; }
	bool ctim_check() const { return ctim_check_; }
	bool fhol_check() const { return fhol_check_; }
	bool sttl_check() const { return sttl_check_; }
	bool tbkp_check() const { return tbkp_check_; }
	bool svid_check() const { return svid_check_; }
	
protected:
	bytestring seek_tags_;
	uint16 tag_number_;
	bool pad_check_;
	bool sni_check_;
	bool stk_check_;
	bool sno_check_;
	bool ver_check_;
	bool ccs_check_;
	bool crt_check_;
	bool nonc_check_;
	bool mspc_check_;
	bool aead_check_;
	bool uaid_check_;
	bool scid_check_;
	bool tcid_check_;
	bool pdmd_check_;
	bool smhl_check_;
	bool icsl_check_;
	bool nonp_check_;
	bool pubs_check_;
	bool mids_check_;
	bool scls_check_;
	bool kexs_check_;
	bool xlct_check_;
	bool csct_check_;
	bool copt_check_;
	bool ccrt_check_;
	bool irtt_check_;
	bool cfcw_check_;
	bool sfcw_check_;
	bool prof_check_;
	bool scfg_check_;
	bool rrej_check_;
	bool obit_check_;
	bool expy_check_;
	bool srbf_check_;
	bool cetv_check_;
	bool ctim_check_;
	bool fhol_check_;
	bool sttl_check_;
	bool tbkp_check_;
	bool svid_check_;
};

bool HelloLength(uint16 length, bool is_orig);
bool CIDCheck(bool is_orig, bool is_long);
bool PAD_check(bytestring const & other_tags, uint16 tag_number);
uint16 find_pad_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset);
bool SNI_check(bytestring const & other_tags, uint16 tag_number);
uint16 find_sni_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset);
bool STK_check(bytestring const & other_tags, uint16 tag_number);
uint16 find_stk_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset);
bool SNO_check(bytestring const & other_tags, uint16 tag_number);
uint16 find_sno_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset);
bool VER_check(bytestring const & other_tags, uint16 tag_number);
uint16 find_ver_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset);
bool CCS_check(bytestring const & other_tags, uint16 tag_number);
uint16 find_ccs_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset);
bool CRT_check(bytestring const & other_tags, uint16 tag_number);
uint16 find_crt_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset);
bool NONC_check(bytestring const & other_tags, uint16 tag_number);
uint16 find_nonc_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset);
bool MSPC_check(bytestring const & other_tags, uint16 tag_number);
uint16 find_mspc_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset);
bool AEAD_check(bytestring const & other_tags, uint16 tag_number);
uint16 find_aead_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset);
bool UAID_check(bytestring const & other_tags, uint16 tag_number);
uint16 find_uaid_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset);
bool SCID_check(bytestring const & other_tags, uint16 tag_number);
uint16 find_scid_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset);
bool TCID_check(bytestring const & other_tags, uint16 tag_number);
uint16 find_tcid_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset);
bool PDMD_check(bytestring const & other_tags, uint16 tag_number);
uint16 find_pdmd_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset);
bool SMHL_check(bytestring const & other_tags, uint16 tag_number);
uint16 find_smhl_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset);
bool NONP_check(bytestring const & other_tags, uint16 tag_number);
uint16 find_nonp_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset);
bool PUBS_check(bytestring const & other_tags, uint16 tag_number);
uint16 find_pubs_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset);
bool MIDS_check(bytestring const & other_tags, uint16 tag_number);
uint16 find_mids_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset);
bool SCLS_check(bytestring const & other_tags, uint16 tag_number);
uint16 find_scls_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset);
bool KEXS_check(bytestring const & other_tags, uint16 tag_number);
uint16 find_kexs_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset);
bool XLCT_check(bytestring const & other_tags, uint16 tag_number);
uint16 find_xlct_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset);
bool CSCT_check(bytestring const & other_tags, uint16 tag_number);
uint16 find_csct_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset);
bool COPT_check(bytestring const & other_tags, uint16 tag_number);
uint16 find_copt_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset);
bool CCRT_check(bytestring const & other_tags, uint16 tag_number);
uint16 find_ccrt_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset);
bool IRTT_check(bytestring const & other_tags, uint16 tag_number);
uint16 find_irtt_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset);
bool CFCW_check(bytestring const & other_tags, uint16 tag_number);
uint16 find_cfcw_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset);
bool SFCW_check(bytestring const & other_tags, uint16 tag_number);
uint16 find_sfcw_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset);
bool PROF_check(bytestring const & other_tags, uint16 tag_number);
uint16 find_prof_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset);
bool SCFG_check(bytestring const & other_tags, uint16 tag_number);
uint16 find_scfg_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset);
bool RREJ_check(bytestring const & other_tags, uint16 tag_number);
uint16 find_rrej_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset);
bool OBIT_check(bytestring const & other_tags, uint16 tag_number);
uint16 find_obit_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset);
bool EXPY_check(bytestring const & other_tags, uint16 tag_number);
uint16 find_expy_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset);
bool SRBF_check(bytestring const & other_tags, uint16 tag_number);
uint16 find_srbf_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset);
bool CETV_check(bytestring const & other_tags, uint16 tag_number);
uint16 find_cetv_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset);
bool CTIM_check(bytestring const & other_tags, uint16 tag_number);
uint16 find_ctim_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset);
bool FHOL_check(bytestring const & other_tags, uint16 tag_number);
uint16 find_fhol_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset);
bool STTL_check(bytestring const & other_tags, uint16 tag_number);
uint16 find_sttl_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset);
bool TBKP_check(bytestring const & other_tags, uint16 tag_number);
uint16 find_tbkp_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset);
bool ICSL_check(bytestring const & other_tags, uint16 tag_number);
uint16 find_icsl_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset);
bool SVID_check(bytestring const & other_tags, uint16 tag_number);
uint16 find_svid_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset);

class GQUIC_Flow : public binpac::FlowAnalyzer
{
public:
	GQUIC_Flow(GQUIC_Conn * connection, bool is_orig);
	~GQUIC_Flow();
	
	// Member access functions
	GQUIC_Conn * connection() const { return connection_; }
	bool is_orig() const { return is_orig_; }
	
	void NewData(const_byteptr t_begin_of_data, const_byteptr t_end_of_data);
	void NewGap(int gap_length);
	void FlowEOF();
	
protected:
	GQUIC_Packet * dataunit_;
	ContextGQUIC * context_;
	GQUIC_Conn * connection_;
	bool is_orig_;
};



} // namespace GQUIC
}  // namespace binpac
#endif /* _builddir_build_BUILD_GQUIC_Protocol_Analyzer_89b7b45043db496e64ea9189b8ddfc681d0c77a7_src_gquic_pac_h */
