// This file is automatically generated from /builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic.pac.


#ifdef __clang__
#pragma clang diagnostic ignored "-Wparentheses-equality"
#endif

#include "/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/build/gquic_pac.h"

namespace binpac {







namespace GQUIC {
ContextGQUIC::ContextGQUIC(GQUIC_Conn * connection, GQUIC_Flow * flow)
	{
	connection_ = connection;
	flow_ = flow;
	}

ContextGQUIC::~ContextGQUIC()
	{
	}

GQUIC_Conn::GQUIC_Conn(BroAnalyzer const & bro_analyzer)
	{
	upflow_ = new GQUIC_Flow(this, true);
	downflow_ = new GQUIC_Flow(this, false);
	bro_analyzer_ = bro_analyzer;

		saw_server_pkt1 = false;
		last_known_client_version = 0;
	
	}

GQUIC_Conn::~GQUIC_Conn()
	{

	
	delete upflow_;
	upflow_ = 0;
	delete downflow_;
	downflow_ = 0;
	}

void GQUIC_Conn::NewData(bool is_orig, const_byteptr begin, const_byteptr end)
	{
	if ( is_orig )
		upflow_->NewData(begin, end);
	else
		downflow_->NewData(begin, end);
	}

void GQUIC_Conn::NewGap(bool is_orig, int gap_length)
	{
	if ( is_orig )
		upflow_->NewGap(gap_length);
	else
		downflow_->NewGap(gap_length);
	}

void GQUIC_Conn::FlowEOF(bool is_orig)
	{
	if ( is_orig )
		upflow_->FlowEOF();
	else
		downflow_->FlowEOF();
	}

bool GQUIC_Conn::process_packet(GQUIC_Packet * pkt, bool is_orig)
	{

		switch ( pkt->flags()->packet_type() ) {
		//This is currently the only type the parser analyzes.  Other types do exist, but are not as beneficial to parse
		case REGULAR:
			{
			auto pkt_num = 0u;
			auto pkt_version = get_gquic_version(pkt->reg_pkt());

			if ( is_orig )
				{
				if ( pkt_version )
					{
					last_known_client_version = pkt_version;
					auto p = potential_client_versions.emplace(pkt_version);

					if ( gquic_client_version && p.second )
						BifEvent::generate_gquic_client_version(
						    bro_analyzer(),
						    bro_analyzer()->Conn(),
						    pkt_version);
					}

				pkt_num = get_packet_number_current(pkt, pkt->reg_pkt(), last_known_client_version);

				if ( last_known_client_version && saw_server_pkt1 )
					confirm();
				}
			else
				{
				pkt_num = get_packet_number_current(pkt, pkt->reg_pkt(), last_known_client_version);

				if ( pkt_num == 1 )
					saw_server_pkt1 = true;

				if ( last_known_client_version && saw_server_pkt1)
					confirm();
				}

			if ( gquic_packet )
				{
				//Populate standard GQUIC packet characteristics
				auto rv = new RecordVal(BifType::Record::GQUIC::PublicHeader);
				rv->Assign(0, new Val(pkt_num, TYPE_COUNT));

				if ( pkt->reg_pkt()->cid()->present_case_index() )
					{
					auto bytes = pkt->reg_pkt()->cid()->bytes();
					auto ptr = reinterpret_cast<const char*>(bytes->data());
					rv->Assign(1, new StringVal(bytes->size(), ptr));
					}
					rv->Assign(2, new Val(pkt->flags()->is_long(), TYPE_BOOL));
				if ( pkt->reg_pkt()->version_case_index() )
					rv->Assign(3, new Val(pkt_version, TYPE_COUNT));

				if ( pkt->flags()->hello_length() == true )
					{
					if ( pkt->search()->expected_string()->hello_check() == true )
						{
						hello_packet_creation(pkt, is_orig, rv);
						}
					else if ( pkt->search()->expected_string()->rej_check() == true)
						rej_packet_creation(pkt, is_orig, rv);
					else
						{
						BifEvent::generate_gquic_packet(bro_analyzer(), bro_analyzer()->Conn(), is_orig, rv);
						}
					}
				else
					{
					BifEvent::generate_gquic_packet(bro_analyzer(), bro_analyzer()->Conn(), is_orig, rv);
					}
				}
			}
			break;

		case OLDER:
			{
			auto pkt_num = 0u;
			auto pkt_version = get_gquic_version_old(pkt->old_pkt());

			if ( is_orig )
				{
				if ( pkt_version )
					{
					last_known_client_version = pkt_version;
					auto p = potential_client_versions.emplace(pkt_version);

					if ( gquic_client_version && p.second )
						BifEvent::generate_gquic_client_version(
								bro_analyzer(),
								bro_analyzer()->Conn(),
								pkt_version);
					}

				pkt_num = get_packet_number_old(pkt, pkt->old_pkt(), last_known_client_version);

				if ( last_known_client_version && saw_server_pkt1 )
					confirm();
				}
			else
				{
				pkt_num = get_packet_number_old(pkt, pkt->old_pkt(), last_known_client_version);

				if ( pkt_num == 1 )
					saw_server_pkt1 = true;

				if ( last_known_client_version && saw_server_pkt1)
					confirm();
				}

			if ( gquic_packet )
				{
				//Populate standard GQUIC packet characteristics
				auto rv = new RecordVal(BifType::Record::GQUIC::PublicHeader);
				rv->Assign(0, new Val(pkt_num, TYPE_COUNT));

				if ( pkt->old_pkt()->cid()->present_case_index() )
					{
					auto bytes = pkt->old_pkt()->cid()->bytes();
					auto ptr = reinterpret_cast<const char*>(bytes->data());
					rv->Assign(1, new StringVal(bytes->size(), ptr));
					}
				rv->Assign(2, new Val(pkt->flags()->have_version(), TYPE_BOOL));
				if ( pkt->old_pkt()->version_case_index() )
					rv->Assign(3, new Val(pkt_version, TYPE_COUNT));

				if ( pkt->flags()->hello_length() == true )
					{
					if ( pkt->search()->expected_string()->hello_check() == true )
						{
						hello_packet_creation(pkt, is_orig, rv);
						}
					else if ( pkt->search()->expected_string()->rej_check() == true)
						rej_packet_creation(pkt, is_orig, rv);	
					else
						{
						BifEvent::generate_gquic_packet(bro_analyzer(), bro_analyzer()->Conn(), is_orig, rv);
						}
					}

				else
					{
					BifEvent::generate_gquic_packet(bro_analyzer(), bro_analyzer()->Conn(), is_orig, rv);
					}
				}
			}
			break;
		default:
			break;
		}

		return true;
		
	}

bool GQUIC_Conn::hello_packet_creation(GQUIC_Packet * pkt, bool is_orig, RecordVal * rv)
	{

		//Populate the characteristics of the Hello Packet
		//The first of each pair is a boolean which determines the existence of the tag
		//The second of the pair is the string of the tag's value
		auto hi_1 = new RecordVal(BifType::Record::GQUIC::HelloInfo);
		if ( pkt->search()->build_hello()->yes()->tag_number() )
			{
			auto bytes = pkt->search()->build_hello()->yes()->tag_number();
			hi_1->Assign(0, new Val(bytes, TYPE_COUNT));
			auto bytes2 = pkt->search()->build_hello()->yes()->p_tag_offset();
			hi_1->Assign(1, new Val(bytes2, TYPE_COUNT));
			}
		hi_1->Assign(2, new Val(pkt->search()->build_hello()->yes()->other_tags()->sni_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->yes()->other_tags()->sni_check() )
			hi_1->Assign(3, new StringVal(pkt->search()->build_hello()->yes()->sni()->collect().length(), (const char*)pkt->search()->build_hello()->yes()->sni()->collect().begin()));
		hi_1->Assign(4, new Val(pkt->search()->build_hello()->yes()->other_tags()->stk_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->yes()->other_tags()->stk_check() )
			hi_1->Assign(5, new StringVal(pkt->search()->build_hello()->yes()->stk()->collect().length(), (const char*)pkt->search()->build_hello()->yes()->stk()->collect().begin()));
		hi_1->Assign(6, new Val(pkt->search()->build_hello()->yes()->other_tags()->sno_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->yes()->other_tags()->sno_check() )
			hi_1->Assign(7, new StringVal(pkt->search()->build_hello()->yes()->sno()->collect().length(), (const char*)pkt->search()->build_hello()->yes()->sno()->collect().begin()));
		hi_1->Assign(8, new Val(pkt->search()->build_hello()->yes()->other_tags()->ver_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->yes()->other_tags()->ver_check() )
			hi_1->Assign(9, new StringVal(pkt->search()->build_hello()->yes()->ver()->collect().length(), (const char*)pkt->search()->build_hello()->yes()->ver()->collect().begin()));
		hi_1->Assign(10, new Val(pkt->search()->build_hello()->yes()->other_tags()->ccs_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->yes()->other_tags()->ccs_check() )
			hi_1->Assign(11, new StringVal(pkt->search()->build_hello()->yes()->ccs()->collect().length(), (const char*)pkt->search()->build_hello()->yes()->ccs()->collect().begin()));
		hi_1->Assign(12, new Val(pkt->search()->build_hello()->yes()->other_tags()->nonc_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->yes()->other_tags()->nonc_check() )
			hi_1->Assign(13, new StringVal(pkt->search()->build_hello()->yes()->nonc()->collect().length(), (const char*)pkt->search()->build_hello()->yes()->nonc()->collect().begin()));
		hi_1->Assign(14, new Val(pkt->search()->build_hello()->yes()->other_tags()->mspc_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->yes()->other_tags()->mspc_check() )
			hi_1->Assign(15, new StringVal(pkt->search()->build_hello()->yes()->mspc()->collect().length(), (const char*)pkt->search()->build_hello()->yes()->mspc()->collect().begin()));
		hi_1->Assign(16, new Val(pkt->search()->build_hello()->yes()->other_tags()->aead_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->yes()->other_tags()->aead_check() )
			hi_1->Assign(17, new StringVal(pkt->search()->build_hello()->yes()->aead()->collect().length(), (const char*)pkt->search()->build_hello()->yes()->aead()->collect().begin()));
		hi_1->Assign(18, new Val(pkt->search()->build_hello()->yes()->other_tags()->uaid_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->yes()->other_tags()->uaid_check() )
			hi_1->Assign(19, new StringVal(pkt->search()->build_hello()->yes()->uaid()->collect().length(), (const char*)pkt->search()->build_hello()->yes()->uaid()->collect().begin()));
		hi_1->Assign(20, new Val(pkt->search()->build_hello()->yes()->other_tags()->scid_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->yes()->other_tags()->scid_check() )
			hi_1->Assign(21, new StringVal(pkt->search()->build_hello()->yes()->scid()->collect().length(), (const char*)pkt->search()->build_hello()->yes()->scid()->collect().begin()));
		hi_1->Assign(22, new Val(pkt->search()->build_hello()->yes()->other_tags()->tcid_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->yes()->other_tags()->tcid_check() )
			hi_1->Assign(23, new StringVal(pkt->search()->build_hello()->yes()->tcid()->collect().length(), (const char*)pkt->search()->build_hello()->yes()->tcid()->collect().begin()));
		hi_1->Assign(24, new Val(pkt->search()->build_hello()->yes()->other_tags()->pdmd_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->yes()->other_tags()->pdmd_check() )
			hi_1->Assign(25, new StringVal(pkt->search()->build_hello()->yes()->pdmd()->collect().length(), (const char*)pkt->search()->build_hello()->yes()->pdmd()->collect().begin()));
		hi_1->Assign(26, new Val(pkt->search()->build_hello()->yes()->other_tags()->smhl_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->yes()->other_tags()->smhl_check() )
			hi_1->Assign(27, new StringVal(pkt->search()->build_hello()->yes()->smhl()->collect().length(), (const char*)pkt->search()->build_hello()->yes()->smhl()->collect().begin()));
		hi_1->Assign(28, new Val(pkt->search()->build_hello()->yes()->other_tags()->icsl_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->yes()->other_tags()->icsl_check() )
			hi_1->Assign(29, new StringVal(pkt->search()->build_hello()->yes()->icsl()->collect().length(), (const char*)pkt->search()->build_hello()->yes()->icsl()->collect().begin()));
		hi_1->Assign(30, new Val(pkt->search()->build_hello()->yes()->other_tags()->ctim_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->yes()->other_tags()->ctim_check() )
			hi_1->Assign(31, new StringVal(pkt->search()->build_hello()->yes()->ctim()->collect().length(), (const char*)pkt->search()->build_hello()->yes()->ctim()->collect().begin()));
		hi_1->Assign(32, new Val(pkt->search()->build_hello()->yes()->other_tags()->nonp_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->yes()->other_tags()->nonp_check() )
			hi_1->Assign(33, new StringVal(pkt->search()->build_hello()->yes()->nonp()->collect().length(), (const char*)pkt->search()->build_hello()->yes()->nonp()->collect().begin()));
		hi_1->Assign(34, new Val(pkt->search()->build_hello()->yes()->other_tags()->pubs_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->yes()->other_tags()->pubs_check() )
			hi_1->Assign(35, new StringVal(pkt->search()->build_hello()->yes()->pubs()->collect().length(), (const char*)pkt->search()->build_hello()->yes()->pubs()->collect().begin()));
		hi_1->Assign(36, new Val(pkt->search()->build_hello()->yes()->other_tags()->mids_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->yes()->other_tags()->mids_check() )
			hi_1->Assign(37, new StringVal(pkt->search()->build_hello()->yes()->mids()->collect().length(), (const char*)pkt->search()->build_hello()->yes()->mids()->collect().begin()));
		hi_1->Assign(38, new Val(pkt->search()->build_hello()->yes()->other_tags()->scls_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->yes()->other_tags()->scls_check() )
			hi_1->Assign(39, new StringVal(pkt->search()->build_hello()->yes()->scls()->collect().length(), (const char*)pkt->search()->build_hello()->yes()->scls()->collect().begin()));
		hi_1->Assign(40, new Val(pkt->search()->build_hello()->yes()->other_tags()->kexs_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->yes()->other_tags()->kexs_check() )
			hi_1->Assign(41, new StringVal(pkt->search()->build_hello()->yes()->kexs()->collect().length(), (const char*)pkt->search()->build_hello()->yes()->kexs()->collect().begin()));
		hi_1->Assign(42, new Val(pkt->search()->build_hello()->yes()->other_tags()->xlct_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->yes()->other_tags()->xlct_check() )
			hi_1->Assign(43, new StringVal(pkt->search()->build_hello()->yes()->xlct()->collect().length(), (const char*)pkt->search()->build_hello()->yes()->xlct()->collect().begin()));
		hi_1->Assign(44, new Val(pkt->search()->build_hello()->yes()->other_tags()->csct_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->yes()->other_tags()->csct_check() )
			hi_1->Assign(45, new StringVal(pkt->search()->build_hello()->yes()->csct()->collect().length(), (const char*)pkt->search()->build_hello()->yes()->csct()->collect().begin()));
		hi_1->Assign(46, new Val(pkt->search()->build_hello()->yes()->other_tags()->copt_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->yes()->other_tags()->copt_check() )
			hi_1->Assign(47, new StringVal(pkt->search()->build_hello()->yes()->copt()->collect().length(), (const char*)pkt->search()->build_hello()->yes()->copt()->collect().begin()));
		hi_1->Assign(48, new Val(pkt->search()->build_hello()->yes()->other_tags()->ccrt_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->yes()->other_tags()->ccrt_check() )
			hi_1->Assign(49, new StringVal(pkt->search()->build_hello()->yes()->ccrt()->collect().length(), (const char*)pkt->search()->build_hello()->yes()->ccrt()->collect().begin()));
		hi_1->Assign(50, new Val(pkt->search()->build_hello()->yes()->other_tags()->irtt_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->yes()->other_tags()->irtt_check() )
			hi_1->Assign(51, new StringVal(pkt->search()->build_hello()->yes()->irtt()->collect().length(), (const char*)pkt->search()->build_hello()->yes()->irtt()->collect().begin()));
		hi_1->Assign(52, new Val(pkt->search()->build_hello()->yes()->other_tags()->cetv_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->yes()->other_tags()->cetv_check() )
			hi_1->Assign(53, new StringVal(pkt->search()->build_hello()->yes()->cetv()->collect().length(), (const char*)pkt->search()->build_hello()->yes()->cetv()->collect().begin()));
		hi_1->Assign(54, new Val(pkt->search()->build_hello()->yes()->other_tags()->cfcw_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->yes()->other_tags()->cfcw_check() )
			hi_1->Assign(55, new StringVal(pkt->search()->build_hello()->yes()->cfcw()->collect().length(), (const char*)pkt->search()->build_hello()->yes()->cfcw()->collect().begin()));
		hi_1->Assign(56, new Val(pkt->search()->build_hello()->yes()->other_tags()->sfcw_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->yes()->other_tags()->sfcw_check() )
			hi_1->Assign(57, new StringVal(pkt->search()->build_hello()->yes()->sfcw()->collect().length(), (const char*)pkt->search()->build_hello()->yes()->sfcw()->collect().begin()));
		hi_1->Assign(58, new StringVal(pkt->search()->build_hello()->yes()->other_tags()->seek_tags().length(), (const char*)pkt->search()->build_hello()->yes()->other_tags()->seek_tags().begin()));
		BifEvent::generate_gquic_hello(bro_analyzer(), bro_analyzer()->Conn(), is_orig, rv, hi_1);
		return true;
	
	}

bool GQUIC_Conn::rej_packet_creation(GQUIC_Packet * pkt, bool is_orig, RecordVal * rv)
	{

		auto rej_1 = new RecordVal(BifType::Record::GQUIC::RejInfo);
		if ( pkt->search()->build_hello()->rej()->tag_number() )
			rej_1->Assign(0, new Val(pkt->search()->build_hello()->rej()->tag_number(), TYPE_COUNT));
		rej_1->Assign(1, new StringVal(pkt->search()->build_hello()->rej()->other_tags()->seek_tags().length(), (const char*)pkt->search()->build_hello()->rej()->other_tags()->seek_tags().begin()));
		rej_1->Assign(2, new Val(pkt->search()->build_hello()->rej()->other_tags()->stk_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->rej()->other_tags()->stk_check() )
			rej_1->Assign(3, new StringVal(pkt->search()->build_hello()->rej()->stk()->collect().length(), (const char*)pkt->search()->build_hello()->rej()->stk()->collect().begin()));
		rej_1->Assign(4, new Val(pkt->search()->build_hello()->rej()->other_tags()->sno_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->rej()->other_tags()->sno_check() )
			rej_1->Assign(5, new StringVal(pkt->search()->build_hello()->rej()->sno()->collect().length(), (const char*)pkt->search()->build_hello()->rej()->sno()->collect().begin()));
		rej_1->Assign(6, new Val(pkt->search()->build_hello()->rej()->other_tags()->svid_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->rej()->other_tags()->svid_check() )
			rej_1->Assign(7, new StringVal(pkt->search()->build_hello()->rej()->svid()->collect().length(), (const char*)pkt->search()->build_hello()->rej()->svid()->collect().begin()));
		rej_1->Assign(8, new Val(pkt->search()->build_hello()->rej()->other_tags()->prof_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->rej()->other_tags()->prof_check() )
			rej_1->Assign(9, new StringVal(pkt->search()->build_hello()->rej()->prof()->collect().length(), (const char*)pkt->search()->build_hello()->rej()->prof()->collect().begin()));
		rej_1->Assign(10, new Val(pkt->search()->build_hello()->rej()->other_tags()->scfg_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->rej()->other_tags()->scfg_check() )
			rej_1->Assign(11, new StringVal(pkt->search()->build_hello()->rej()->scfg()->collect()->other_tags()->seek_tags().length(), (const char*)pkt->search()->build_hello()->rej()->scfg()->collect()->other_tags()->seek_tags().begin()));
		rej_1->Assign(12, new Val(pkt->search()->build_hello()->rej()->other_tags()->rrej_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->rej()->other_tags()->rrej_check() )
			rej_1->Assign(13, new StringVal(pkt->search()->build_hello()->rej()->rrej()->collect().length(), (const char*)pkt->search()->build_hello()->rej()->rrej()->collect().begin()));
		rej_1->Assign(14, new Val(pkt->search()->build_hello()->rej()->other_tags()->sttl_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->rej()->other_tags()->sttl_check() )
			rej_1->Assign(15, new StringVal(pkt->search()->build_hello()->rej()->sttl()->collect().length(), (const char*)pkt->search()->build_hello()->rej()->sttl()->collect().begin()));
		rej_1->Assign(16, new Val(pkt->search()->build_hello()->rej()->other_tags()->csct_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->rej()->other_tags()->csct_check() )
			rej_1->Assign(17, new StringVal(pkt->search()->build_hello()->rej()->csct()->collect().length(), (const char*)pkt->search()->build_hello()->rej()->csct()->collect().begin()));
		rej_1->Assign(18, new Val(pkt->search()->build_hello()->rej()->scfg()->collect()->other_tags()->ver_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->rej()->scfg()->collect()->other_tags()->ver_check() )
			rej_1->Assign(19, new StringVal(pkt->search()->build_hello()->rej()->scfg()->collect()->ver()->collect().length(), (const char*)pkt->search()->build_hello()->rej()->scfg()->collect()->ver()->collect().begin()));
		rej_1->Assign(20, new Val(pkt->search()->build_hello()->rej()->scfg()->collect()->other_tags()->aead_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->rej()->scfg()->collect()->other_tags()->aead_check() )
			rej_1->Assign(21, new StringVal(pkt->search()->build_hello()->rej()->scfg()->collect()->aead()->collect().length(), (const char*)pkt->search()->build_hello()->rej()->scfg()->collect()->aead()->collect().begin()));
		rej_1->Assign(22, new Val(pkt->search()->build_hello()->rej()->scfg()->collect()->other_tags()->scid_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->rej()->scfg()->collect()->other_tags()->scid_check() )
			rej_1->Assign(23, new StringVal(pkt->search()->build_hello()->rej()->scfg()->collect()->scid()->collect().length(), (const char*)pkt->search()->build_hello()->rej()->scfg()->collect()->scid()->collect().begin()));
		rej_1->Assign(24, new Val(pkt->search()->build_hello()->rej()->scfg()->collect()->other_tags()->pdmd_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->rej()->scfg()->collect()->other_tags()->pdmd_check() )
			rej_1->Assign(25, new StringVal(pkt->search()->build_hello()->rej()->scfg()->collect()->pdmd()->collect().length(), (const char*)pkt->search()->build_hello()->rej()->scfg()->collect()->pdmd()->collect().begin()));
		rej_1->Assign(26, new Val(pkt->search()->build_hello()->rej()->scfg()->collect()->other_tags()->tbkp_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->rej()->scfg()->collect()->other_tags()->tbkp_check() )
			rej_1->Assign(27, new StringVal(pkt->search()->build_hello()->rej()->scfg()->collect()->tbkp()->collect().length(), (const char*)pkt->search()->build_hello()->rej()->scfg()->collect()->tbkp()->collect().begin()));
		rej_1->Assign(28, new Val(pkt->search()->build_hello()->rej()->scfg()->collect()->other_tags()->pubs_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->rej()->scfg()->collect()->other_tags()->pubs_check() )
			rej_1->Assign(29, new StringVal(pkt->search()->build_hello()->rej()->scfg()->collect()->pubs()->collect().length(), (const char*)pkt->search()->build_hello()->rej()->scfg()->collect()->pubs()->collect().begin()));
		rej_1->Assign(30, new Val(pkt->search()->build_hello()->rej()->scfg()->collect()->other_tags()->kexs_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->rej()->scfg()->collect()->other_tags()->kexs_check() )
			rej_1->Assign(31, new StringVal(pkt->search()->build_hello()->rej()->scfg()->collect()->kexs()->collect().length(), (const char*)pkt->search()->build_hello()->rej()->scfg()->collect()->kexs()->collect().begin()));
		rej_1->Assign(32, new Val(pkt->search()->build_hello()->rej()->scfg()->collect()->other_tags()->obit_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->rej()->scfg()->collect()->other_tags()->obit_check() )
			rej_1->Assign(33, new StringVal(pkt->search()->build_hello()->rej()->scfg()->collect()->obit()->collect().length(), (const char*)pkt->search()->build_hello()->rej()->scfg()->collect()->obit()->collect().begin()));
		rej_1->Assign(34, new Val(pkt->search()->build_hello()->rej()->scfg()->collect()->other_tags()->expy_check(), TYPE_BOOL));
		if ( pkt->search()->build_hello()->rej()->scfg()->collect()->other_tags()->expy_check() )
			rej_1->Assign(35, new StringVal(pkt->search()->build_hello()->rej()->scfg()->collect()->expy()->collect().length(), (const char*)pkt->search()->build_hello()->rej()->scfg()->collect()->expy()->collect().begin()));
		rej_1->Assign(36, new Val(pkt->search()->build_hello()->rej()->scfg()->collect()->tag_number(), TYPE_COUNT));
		BifEvent::generate_gquic_rej(bro_analyzer(), bro_analyzer()->Conn(), is_orig, rv, rej_1);
		return true;
		
	}

uint16 GQUIC_Conn::get_gquic_version(RegularPacket * reg_pkt)
	{

		if ( ! reg_pkt->version_case_index() )
			return 0;

		return extract_gquic_version(reg_pkt->version_val().data());
		
	}

uint16 GQUIC_Conn::get_gquic_version_old(OldPacket * old_pkt)
	{

		if ( ! old_pkt->version_case_index() )
			return 0;

		return extract_gquic_version(old_pkt->version_val()->data());
		
	}

uint64 GQUIC_Conn::get_packet_number_current(GQUIC_Packet * pkt, RegularPacket * reg_pkt, uint16 version)
	{

		return convert_packet_bytes(get_packet_number_bytes_current(pkt, reg_pkt), version);
		
	}

vector<uint8> * GQUIC_Conn::get_packet_number_bytes_current(GQUIC_Packet * pkt, RegularPacket * reg_pkt)
	{

		switch ( reg_pkt->pkt_num_bytes_case_index() ) {
			case 0x00:
				return pkt->reg_pkt()->pkt_num_bytes1();
			case 0x01:
				return pkt->reg_pkt()->pkt_num_bytes2();
			case 0x02:
				return pkt->reg_pkt()->pkt_num_bytes3();
			case 0x03:
				return pkt->reg_pkt()->pkt_num_bytes4();
			default:
				assert(false);
		}
		return nullptr;
		
	}

uint64 GQUIC_Conn::get_packet_number_old(GQUIC_Packet * pkt, OldPacket * old_pkt, uint16 version)
	{

		return convert_packet_bytes(get_packet_number_bytes_old(pkt, old_pkt), version);
		
	}

vector<uint8> * GQUIC_Conn::get_packet_number_bytes_old(GQUIC_Packet * pkt, OldPacket * old_pkt)
	{

		switch ( old_pkt->pkt_num_bytes_case_index() ) {
			case 0x00:
				return pkt->old_pkt()->pkt_num_bytes1();
			case 0x10:
				return pkt->old_pkt()->pkt_num_bytes2();
			case 0x20:
				return pkt->old_pkt()->pkt_num_bytes4();
			case 0x30:
				return pkt->old_pkt()->pkt_num_bytes6();
			default:
				assert(false);
		}
		return nullptr;
		
	}

uint64 GQUIC_Conn::convert_packet_bytes(vector<uint8> * bytes, uint16 version)
	{

		uint64 rval = 0;
		uint8* byte_ptr = reinterpret_cast<uint8*>(&rval);
		byte_ptr += sizeof(rval) - bytes->size();

		for ( auto i = 0u; i < bytes->size(); ++i )
			{
			auto byte = (*bytes)[i];
			*byte_ptr = byte;
			++byte_ptr;
			}

		// Version 0 essentially means we haven't seen a version yet, so
		// assume a recent version of GQUIC.
		auto gquic_is_big_endian = version == 0 || version >= 39;

		if ( gquic_is_big_endian )
			rval = ntohll(rval);
		else
			{
#ifdef WORDS_BIGENDIAN
			uint64 tmp;
			uint8* src = reinterpret_cast<uint8*>(&rval);
			uint8* dst = reinterpret_cast<uint8*>(&tmp);
			dst[0] = src[7];
			dst[1] = src[6];
			dst[2] = src[5];
			dst[3] = src[4];
			dst[4] = src[3];
			dst[5] = src[2];
			dst[6] = src[1];
			dst[7] = src[0];
			rval = tmp;
#endif
			}

		return rval;
		
	}

GQUIC_Packet::GQUIC_Packet(bool is_orig)
	{
	flags_ = 0;
	content_case_index_ = -1;
	reg_pkt_ = 0;
	old_pkt_ = 0;
	unencrypted_search_case_index_ = -1;
	search_ = 0;
	is_orig_ = is_orig;
	byteorder_ = bigendian;
	proc_ = 0;
	}

GQUIC_Packet::~GQUIC_Packet()
	{
	delete flags_;
	flags_ = 0;
	switch ( content_case_index() )
		{
		case ((int) 0):
			// Clean up "reg_pkt"
			{
			delete reg_pkt_;
			reg_pkt_ = 0;
			}
			break;
		case ((int) 1):
			// Clean up "old_pkt"
			{
			delete old_pkt_;
			old_pkt_ = 0;
			}
			break;
		default:
			// Clean up "nil_pkt"
			{
			}
			break;
		}
	switch ( unencrypted_search_case_index() )
		{
		case ((bool) 1):
			// Clean up "search"
			{
			delete search_;
			search_ = 0;
			}
			break;
		case ((bool) 0):
			// Clean up "stop"
			{
			}
			break;
		default:
			// Clean up "stopx"
			{
			}
			break;
		}
	}

int GQUIC_Packet::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextGQUIC * t_context)
	{
	// Checking out-of-bound for "GQUIC_Packet:flags"
	if ( t_begin_of_data + (1) > t_end_of_data || t_begin_of_data + (1) < t_begin_of_data )
		{
		// Handle out-of-bound condition
		throw binpac::ExceptionOutOfBound("GQUIC_Packet:flags",
			(0) + (1), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "flags"
	flags_ = new PublicFlags(is_orig());
	flags_->Parse(t_begin_of_data, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	// Parse "content"
	int t_content__size;
	content_case_index_ = flags()->packet_type();
	switch ( content_case_index() )
		{
		case ((int) 0):
			// Parse "reg_pkt"
			{
			reg_pkt_ = new RegularPacket(flags(), is_orig());
			int t_reg_pkt__size;
			t_reg_pkt__size = reg_pkt_->Parse((t_begin_of_data + 1), t_end_of_data);
			// Evaluate 'let' and 'withinput' fields
			t_content__size = t_reg_pkt__size;
			}
			break;
		case ((int) 1):
			// Parse "old_pkt"
			{
			old_pkt_ = new OldPacket(flags(), is_orig());
			int t_old_pkt__size;
			t_old_pkt__size = old_pkt_->Parse((t_begin_of_data + 1), t_end_of_data);
			// Evaluate 'let' and 'withinput' fields
			t_content__size = t_old_pkt__size;
			}
			break;
		default:
			// Parse "nil_pkt"
			{
			// Evaluate 'let' and 'withinput' fields
			t_content__size = 0;
			}
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_content = (t_begin_of_data + 1) + (t_content__size);
	BINPAC_ASSERT(t_dataptr_after_content <= t_end_of_data);
	// Parse "unencrypted_search"
	int t_unencrypted_search__size;
	unencrypted_search_case_index_ = flags()->hello_length();
	switch ( unencrypted_search_case_index() )
		{
		case ((bool) 1):
			// Parse "search"
			{
			search_ = new UnencryptedSearch(flags(), is_orig());
			int t_search__size;
			t_search__size = search_->Parse(t_dataptr_after_content, t_end_of_data, byteorder());
			// Evaluate 'let' and 'withinput' fields
			t_unencrypted_search__size = t_search__size;
			}
			break;
		case ((bool) 0):
			// Parse "stop"
			{
			// Evaluate 'let' and 'withinput' fields
			t_unencrypted_search__size = 0;
			}
			break;
		default:
			// Parse "stopx"
			{
			// Evaluate 'let' and 'withinput' fields
			t_unencrypted_search__size = 0;
			}
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_unencrypted_search = t_dataptr_after_content + (t_unencrypted_search__size);
	BINPAC_ASSERT(t_dataptr_after_unencrypted_search <= t_end_of_data);
	// Parse "frames"
	int t_frames_string_length;
	t_frames_string_length = (t_end_of_data) - (t_dataptr_after_unencrypted_search);
	int t_frames__size;
	t_frames__size = t_frames_string_length;
	// check for negative sizes
	if ( t_frames_string_length < 0 )
	throw binpac::ExceptionInvalidStringLength("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:26", t_frames_string_length);
	frames_.init(t_dataptr_after_unencrypted_search, t_frames_string_length);
	// Evaluate 'let' and 'withinput' fields
	
	int t_GQUIC_Packet__size;
	const_byteptr const t_dataptr_after_frames = t_dataptr_after_unencrypted_search + (t_frames__size);
	BINPAC_ASSERT(t_dataptr_after_frames <= t_end_of_data);
	t_GQUIC_Packet__size = t_dataptr_after_frames - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	proc_ = t_context->connection()->process_packet(this, is_orig());
	BINPAC_ASSERT(t_begin_of_data + (t_GQUIC_Packet__size) <= t_end_of_data);
	return t_GQUIC_Packet__size;
	}

PublicFlags::PublicFlags(bool is_orig)
	{
	byte_ = 0;
	is_orig_ = is_orig;
	length_ = 0;
	hello_length_ = 0;
	is_long_ = 0;
	fixed_bit_ = 0;
	type_initial_ = 0;
	type_0rtt_ = 0;
	type_handshake_ = 0;
	type_retry_ = 0;
	pkt_num_size_ = 0;
	have_version_ = 0;
	have_nonce_ = 0;
	have_conn_id_ = 0;
	pkt_num_size_old_ = 0;
	packet_type_ = 0;
	cid_exists_ = 0;
	}

PublicFlags::~PublicFlags()
	{
	}

int PublicFlags::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	sourcedata_ = const_bytestring(t_begin_of_data, t_end_of_data);
	// Checking out-of-bound for "PublicFlags"
	if ( t_begin_of_data + (1) > t_end_of_data || t_begin_of_data + (1) < t_begin_of_data )
		{
		// Handle out-of-bound condition
		throw binpac::ExceptionOutOfBound("PublicFlags",
			(0) + (1), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "byte"
	byte_ = *((uint8 const *) (t_begin_of_data));
	// Evaluate 'let' and 'withinput' fields
	
	// Evaluate 'let' and 'withinput' fields
	length_ = sourcedata().length();
	hello_length_ = HelloLength(length(), is_orig());
	is_long_ =  ( byte() & 0x80 )  == 0x80;
	fixed_bit_ =  ( byte() & 0x40 )  == 0x40;
	type_initial_ =  ( byte() & 0x30 )  == 0x00;
	type_0rtt_ =  ( byte() & 0x30 )  == 0x10;
	type_handshake_ =  ( byte() & 0x30 )  == 0x20;
	type_retry_ =  ( byte() & 0x30 )  == 0x30;
	pkt_num_size_ =  ( byte() & 0x03 ) ;
	have_version_ =  ( byte() & 0x01 )  == 0x01;
	have_nonce_ =  ( byte() & 0x04 )  == 0x04 && ! is_orig();
	have_conn_id_ =  ( byte() & 0x08 )  == 0x08;
	pkt_num_size_old_ =  ( byte() & 0x30 ) ;
	packet_type_ =  ( fixed_bit() ? REGULAR : OLDER ) ;
	cid_exists_ = CIDCheck(is_orig(), is_long());
	sourcedata_.set_end(t_begin_of_data + 1);
	BINPAC_ASSERT(t_begin_of_data + (1) <= t_end_of_data);
	return 1;
	}

OldPacket::OldPacket(PublicFlags * flags, bool is_orig)
	{
	cid_ = 0;
	version_case_index_ = -1;
	version_val_ = 0;
	version_val__elem_ = 0;
	nonce_case_index_ = -1;
	nonce_val_ = 0;
	nonce_val__elem_ = 0;
	pkt_num_bytes_case_index_ = -1;
	pkt_num_bytes1_ = 0;
	pkt_num_bytes1__elem_ = 0;
	pkt_num_bytes2_ = 0;
	pkt_num_bytes2__elem_ = 0;
	pkt_num_bytes4_ = 0;
	pkt_num_bytes4__elem_ = 0;
	pkt_num_bytes6_ = 0;
	pkt_num_bytes6__elem_ = 0;
	flags_ = flags;
	is_orig_ = is_orig;
	byteorder_ = bigendian;
	}

OldPacket::~OldPacket()
	{
	delete cid_;
	cid_ = 0;
	switch ( version_case_index() )
		{
		case ((bool) 1):
			// Clean up "version_val"
			{
			delete version_val_;
			}
			break;
		case ((bool) 0):
			// Clean up "version_nil"
			{
			}
			break;
		}
	switch ( nonce_case_index() )
		{
		case ((bool) 1):
			// Clean up "nonce_val"
			{
			delete nonce_val_;
			}
			break;
		case ((bool) 0):
			// Clean up "nonce_nil"
			{
			}
			break;
		}
	switch ( pkt_num_bytes_case_index() )
		{
		case ((uint8) 0):
			// Clean up "pkt_num_bytes1"
			{
			delete pkt_num_bytes1_;
			}
			break;
		case ((uint8) 16):
			// Clean up "pkt_num_bytes2"
			{
			delete pkt_num_bytes2_;
			}
			break;
		case ((uint8) 32):
			// Clean up "pkt_num_bytes4"
			{
			delete pkt_num_bytes4_;
			}
			break;
		case ((uint8) 48):
			// Clean up "pkt_num_bytes6"
			{
			delete pkt_num_bytes6_;
			}
			break;
		default:
			// Clean up "pkt_num_bytesx"
			{
			}
			break;
		}
	}

int OldPacket::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "cid"
	cid_ = new ConnectionIDOld(flags());
	int t_cid__size;
	t_cid__size = cid_->Parse(t_begin_of_data, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_cid = t_begin_of_data + (t_cid__size);
	BINPAC_ASSERT(t_dataptr_after_cid <= t_end_of_data);
	// Parse "version"
	int t_version__size;
	version_case_index_ = flags()->have_version();
	switch ( version_case_index() )
		{
		case ((bool) 1):
			// Parse "version_val"
			{
			int t_version_val__arraylength;
			t_version_val__arraylength = 0;
			t_version_val__arraylength = 4;
			if ( t_version_val__arraylength < 0 )
				{
				throw binpac::ExceptionOutOfBound("OldPacket:version_val",
				  t_version_val__arraylength, (t_end_of_data) - (t_begin_of_data));
				}
			// Check bounds for static-size array: OldPacket:version_val
			if ( t_version_val__arraylength > ((t_end_of_data - t_dataptr_after_cid) / 1) )
				throw binpac::ExceptionOutOfBound("OldPacket:version_val",
				  t_version_val__arraylength, (t_end_of_data) - (t_dataptr_after_cid));
			version_val__elem_ = 0;
			int t_version_val__elem__it;
			t_version_val__elem__it = 0;
			version_val_ = new vector<uint8>;
			version_val_->reserve(t_version_val__arraylength);
			const_byteptr t_version_val__elem__dataptr = t_dataptr_after_cid;
			for (; t_version_val__elem__it < t_version_val__arraylength; ++t_version_val__elem__it)
				{
				version_val__elem_ = *((uint8 const *) (t_version_val__elem__dataptr));
				// Evaluate 'let' and 'withinput' fields
				version_val_->push_back(version_val__elem_);
				t_version_val__elem__dataptr += 1;
				BINPAC_ASSERT(t_version_val__elem__dataptr <= t_end_of_data);
				}
		end_of_version_val: ;
			// Evaluate 'let' and 'withinput' fields
			t_version__size = 4;
			}
			break;
		case ((bool) 0):
			// Parse "version_nil"
			{
			// Evaluate 'let' and 'withinput' fields
			t_version__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("OldPacket", (int64)version_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_version = t_dataptr_after_cid + (t_version__size);
	BINPAC_ASSERT(t_dataptr_after_version <= t_end_of_data);
	// Parse "nonce"
	int t_nonce__size;
	nonce_case_index_ = flags()->have_nonce();
	switch ( nonce_case_index() )
		{
		case ((bool) 1):
			// Parse "nonce_val"
			{
			int t_nonce_val__arraylength;
			t_nonce_val__arraylength = 0;
			t_nonce_val__arraylength = 32;
			if ( t_nonce_val__arraylength < 0 )
				{
				throw binpac::ExceptionOutOfBound("OldPacket:nonce_val",
				  t_nonce_val__arraylength, (t_end_of_data) - (t_begin_of_data));
				}
			// Check bounds for static-size array: OldPacket:nonce_val
			if ( t_nonce_val__arraylength > ((t_end_of_data - t_dataptr_after_version) / 1) )
				throw binpac::ExceptionOutOfBound("OldPacket:nonce_val",
				  t_nonce_val__arraylength, (t_end_of_data) - (t_dataptr_after_version));
			nonce_val__elem_ = 0;
			int t_nonce_val__elem__it;
			t_nonce_val__elem__it = 0;
			nonce_val_ = new vector<uint8>;
			nonce_val_->reserve(t_nonce_val__arraylength);
			const_byteptr t_nonce_val__elem__dataptr = t_dataptr_after_version;
			for (; t_nonce_val__elem__it < t_nonce_val__arraylength; ++t_nonce_val__elem__it)
				{
				nonce_val__elem_ = *((uint8 const *) (t_nonce_val__elem__dataptr));
				// Evaluate 'let' and 'withinput' fields
				nonce_val_->push_back(nonce_val__elem_);
				t_nonce_val__elem__dataptr += 1;
				BINPAC_ASSERT(t_nonce_val__elem__dataptr <= t_end_of_data);
				}
		end_of_nonce_val: ;
			// Evaluate 'let' and 'withinput' fields
			t_nonce__size = 32;
			}
			break;
		case ((bool) 0):
			// Parse "nonce_nil"
			{
			// Evaluate 'let' and 'withinput' fields
			t_nonce__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("OldPacket", (int64)nonce_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_nonce = t_dataptr_after_version + (t_nonce__size);
	BINPAC_ASSERT(t_dataptr_after_nonce <= t_end_of_data);
	// Parse "pkt_num_bytes"
	int t_pkt_num_bytes__size;
	pkt_num_bytes_case_index_ = flags()->pkt_num_size_old();
	switch ( pkt_num_bytes_case_index() )
		{
		case ((uint8) 0):
			// Parse "pkt_num_bytes1"
			{
			int t_pkt_num_bytes1__arraylength;
			t_pkt_num_bytes1__arraylength = 0;
			t_pkt_num_bytes1__arraylength = 1;
			if ( t_pkt_num_bytes1__arraylength < 0 )
				{
				throw binpac::ExceptionOutOfBound("OldPacket:pkt_num_bytes1",
				  t_pkt_num_bytes1__arraylength, (t_end_of_data) - (t_begin_of_data));
				}
			// Check bounds for static-size array: OldPacket:pkt_num_bytes1
			if ( t_pkt_num_bytes1__arraylength > ((t_end_of_data - t_dataptr_after_nonce) / 1) )
				throw binpac::ExceptionOutOfBound("OldPacket:pkt_num_bytes1",
				  t_pkt_num_bytes1__arraylength, (t_end_of_data) - (t_dataptr_after_nonce));
			pkt_num_bytes1__elem_ = 0;
			int t_pkt_num_bytes1__elem__it;
			t_pkt_num_bytes1__elem__it = 0;
			pkt_num_bytes1_ = new vector<uint8>;
			pkt_num_bytes1_->reserve(t_pkt_num_bytes1__arraylength);
			const_byteptr t_pkt_num_bytes1__elem__dataptr = t_dataptr_after_nonce;
			for (; t_pkt_num_bytes1__elem__it < t_pkt_num_bytes1__arraylength; ++t_pkt_num_bytes1__elem__it)
				{
				pkt_num_bytes1__elem_ = *((uint8 const *) (t_pkt_num_bytes1__elem__dataptr));
				// Evaluate 'let' and 'withinput' fields
				pkt_num_bytes1_->push_back(pkt_num_bytes1__elem_);
				t_pkt_num_bytes1__elem__dataptr += 1;
				BINPAC_ASSERT(t_pkt_num_bytes1__elem__dataptr <= t_end_of_data);
				}
		end_of_pkt_num_bytes1: ;
			// Evaluate 'let' and 'withinput' fields
			t_pkt_num_bytes__size = 1;
			}
			break;
		case ((uint8) 16):
			// Parse "pkt_num_bytes2"
			{
			int t_pkt_num_bytes2__arraylength;
			t_pkt_num_bytes2__arraylength = 0;
			t_pkt_num_bytes2__arraylength = 2;
			if ( t_pkt_num_bytes2__arraylength < 0 )
				{
				throw binpac::ExceptionOutOfBound("OldPacket:pkt_num_bytes2",
				  t_pkt_num_bytes2__arraylength, (t_end_of_data) - (t_begin_of_data));
				}
			// Check bounds for static-size array: OldPacket:pkt_num_bytes2
			if ( t_pkt_num_bytes2__arraylength > ((t_end_of_data - t_dataptr_after_nonce) / 1) )
				throw binpac::ExceptionOutOfBound("OldPacket:pkt_num_bytes2",
				  t_pkt_num_bytes2__arraylength, (t_end_of_data) - (t_dataptr_after_nonce));
			pkt_num_bytes2__elem_ = 0;
			int t_pkt_num_bytes2__elem__it;
			t_pkt_num_bytes2__elem__it = 0;
			pkt_num_bytes2_ = new vector<uint8>;
			pkt_num_bytes2_->reserve(t_pkt_num_bytes2__arraylength);
			const_byteptr t_pkt_num_bytes2__elem__dataptr = t_dataptr_after_nonce;
			for (; t_pkt_num_bytes2__elem__it < t_pkt_num_bytes2__arraylength; ++t_pkt_num_bytes2__elem__it)
				{
				pkt_num_bytes2__elem_ = *((uint8 const *) (t_pkt_num_bytes2__elem__dataptr));
				// Evaluate 'let' and 'withinput' fields
				pkt_num_bytes2_->push_back(pkt_num_bytes2__elem_);
				t_pkt_num_bytes2__elem__dataptr += 1;
				BINPAC_ASSERT(t_pkt_num_bytes2__elem__dataptr <= t_end_of_data);
				}
		end_of_pkt_num_bytes2: ;
			// Evaluate 'let' and 'withinput' fields
			t_pkt_num_bytes__size = 2;
			}
			break;
		case ((uint8) 32):
			// Parse "pkt_num_bytes4"
			{
			int t_pkt_num_bytes4__arraylength;
			t_pkt_num_bytes4__arraylength = 0;
			t_pkt_num_bytes4__arraylength = 4;
			if ( t_pkt_num_bytes4__arraylength < 0 )
				{
				throw binpac::ExceptionOutOfBound("OldPacket:pkt_num_bytes4",
				  t_pkt_num_bytes4__arraylength, (t_end_of_data) - (t_begin_of_data));
				}
			// Check bounds for static-size array: OldPacket:pkt_num_bytes4
			if ( t_pkt_num_bytes4__arraylength > ((t_end_of_data - t_dataptr_after_nonce) / 1) )
				throw binpac::ExceptionOutOfBound("OldPacket:pkt_num_bytes4",
				  t_pkt_num_bytes4__arraylength, (t_end_of_data) - (t_dataptr_after_nonce));
			pkt_num_bytes4__elem_ = 0;
			int t_pkt_num_bytes4__elem__it;
			t_pkt_num_bytes4__elem__it = 0;
			pkt_num_bytes4_ = new vector<uint8>;
			pkt_num_bytes4_->reserve(t_pkt_num_bytes4__arraylength);
			const_byteptr t_pkt_num_bytes4__elem__dataptr = t_dataptr_after_nonce;
			for (; t_pkt_num_bytes4__elem__it < t_pkt_num_bytes4__arraylength; ++t_pkt_num_bytes4__elem__it)
				{
				pkt_num_bytes4__elem_ = *((uint8 const *) (t_pkt_num_bytes4__elem__dataptr));
				// Evaluate 'let' and 'withinput' fields
				pkt_num_bytes4_->push_back(pkt_num_bytes4__elem_);
				t_pkt_num_bytes4__elem__dataptr += 1;
				BINPAC_ASSERT(t_pkt_num_bytes4__elem__dataptr <= t_end_of_data);
				}
		end_of_pkt_num_bytes4: ;
			// Evaluate 'let' and 'withinput' fields
			t_pkt_num_bytes__size = 4;
			}
			break;
		case ((uint8) 48):
			// Parse "pkt_num_bytes6"
			{
			int t_pkt_num_bytes6__arraylength;
			t_pkt_num_bytes6__arraylength = 0;
			t_pkt_num_bytes6__arraylength = 6;
			if ( t_pkt_num_bytes6__arraylength < 0 )
				{
				throw binpac::ExceptionOutOfBound("OldPacket:pkt_num_bytes6",
				  t_pkt_num_bytes6__arraylength, (t_end_of_data) - (t_begin_of_data));
				}
			// Check bounds for static-size array: OldPacket:pkt_num_bytes6
			if ( t_pkt_num_bytes6__arraylength > ((t_end_of_data - t_dataptr_after_nonce) / 1) )
				throw binpac::ExceptionOutOfBound("OldPacket:pkt_num_bytes6",
				  t_pkt_num_bytes6__arraylength, (t_end_of_data) - (t_dataptr_after_nonce));
			pkt_num_bytes6__elem_ = 0;
			int t_pkt_num_bytes6__elem__it;
			t_pkt_num_bytes6__elem__it = 0;
			pkt_num_bytes6_ = new vector<uint8>;
			pkt_num_bytes6_->reserve(t_pkt_num_bytes6__arraylength);
			const_byteptr t_pkt_num_bytes6__elem__dataptr = t_dataptr_after_nonce;
			for (; t_pkt_num_bytes6__elem__it < t_pkt_num_bytes6__arraylength; ++t_pkt_num_bytes6__elem__it)
				{
				pkt_num_bytes6__elem_ = *((uint8 const *) (t_pkt_num_bytes6__elem__dataptr));
				// Evaluate 'let' and 'withinput' fields
				pkt_num_bytes6_->push_back(pkt_num_bytes6__elem_);
				t_pkt_num_bytes6__elem__dataptr += 1;
				BINPAC_ASSERT(t_pkt_num_bytes6__elem__dataptr <= t_end_of_data);
				}
		end_of_pkt_num_bytes6: ;
			// Evaluate 'let' and 'withinput' fields
			t_pkt_num_bytes__size = 6;
			}
			break;
		default:
			// Parse "pkt_num_bytesx"
			{
			// Evaluate 'let' and 'withinput' fields
			t_pkt_num_bytes__size = 0;
			}
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_OldPacket__size;
	const_byteptr const t_dataptr_after_pkt_num_bytes = t_dataptr_after_nonce + (t_pkt_num_bytes__size);
	BINPAC_ASSERT(t_dataptr_after_pkt_num_bytes <= t_end_of_data);
	t_OldPacket__size = t_dataptr_after_pkt_num_bytes - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_OldPacket__size) <= t_end_of_data);
	return t_OldPacket__size;
	}

ConnectionIDOld::ConnectionIDOld(PublicFlags * flags)
	{
	present_case_index_ = -1;
	bytes_ = 0;
	bytes__elem_ = 0;
	flags_ = flags;
	}

ConnectionIDOld::~ConnectionIDOld()
	{
	switch ( present_case_index() )
		{
		case ((bool) 1):
			// Clean up "bytes"
			{
			delete bytes_;
			}
			break;
		case ((bool) 0):
			// Clean up "nil"
			{
			}
			break;
		}
	}

int ConnectionIDOld::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "present"
	int t_present__size;
	present_case_index_ = flags()->have_conn_id();
	switch ( present_case_index() )
		{
		case ((bool) 1):
			// Parse "bytes"
			{
			int t_bytes__arraylength;
			t_bytes__arraylength = 0;
			t_bytes__arraylength = 8;
			if ( t_bytes__arraylength < 0 )
				{
				throw binpac::ExceptionOutOfBound("ConnectionIDOld:bytes",
				  t_bytes__arraylength, (t_end_of_data) - (t_begin_of_data));
				}
			// Check bounds for static-size array: ConnectionIDOld:bytes
			if ( t_bytes__arraylength > ((t_end_of_data - t_begin_of_data) / 1) )
				throw binpac::ExceptionOutOfBound("ConnectionIDOld:bytes",
				  t_bytes__arraylength, (t_end_of_data) - (t_begin_of_data));
			bytes__elem_ = 0;
			int t_bytes__elem__it;
			t_bytes__elem__it = 0;
			bytes_ = new vector<uint8>;
			bytes_->reserve(t_bytes__arraylength);
			const_byteptr t_bytes__elem__dataptr = t_begin_of_data;
			for (; t_bytes__elem__it < t_bytes__arraylength; ++t_bytes__elem__it)
				{
				bytes__elem_ = *((uint8 const *) (t_bytes__elem__dataptr));
				// Evaluate 'let' and 'withinput' fields
				bytes_->push_back(bytes__elem_);
				t_bytes__elem__dataptr += 1;
				BINPAC_ASSERT(t_bytes__elem__dataptr <= t_end_of_data);
				}
		end_of_bytes: ;
			// Evaluate 'let' and 'withinput' fields
			t_present__size = 8;
			}
			break;
		case ((bool) 0):
			// Parse "nil"
			{
			// Evaluate 'let' and 'withinput' fields
			t_present__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("ConnectionIDOld", (int64)present_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_ConnectionIDOld__size;
	const_byteptr const t_dataptr_after_present = t_begin_of_data + (t_present__size);
	BINPAC_ASSERT(t_dataptr_after_present <= t_end_of_data);
	t_ConnectionIDOld__size = t_dataptr_after_present - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_ConnectionIDOld__size) <= t_end_of_data);
	return t_ConnectionIDOld__size;
	}

RegularPacket::RegularPacket(PublicFlags * flags, bool is_orig)
	{
	version_case_index_ = -1;
	dcil_scil_case_index_ = -1;
	conn_id_ = 0;
	cid_ = 0;
	pkt_num_bytes_case_index_ = -1;
	pkt_num_bytes1_ = 0;
	pkt_num_bytes1__elem_ = 0;
	pkt_num_bytes2_ = 0;
	pkt_num_bytes2__elem_ = 0;
	pkt_num_bytes3_ = 0;
	pkt_num_bytes3__elem_ = 0;
	pkt_num_bytes4_ = 0;
	pkt_num_bytes4__elem_ = 0;
	flags_ = flags;
	is_orig_ = is_orig;
	}

RegularPacket::~RegularPacket()
	{
	switch ( version_case_index() )
		{
		case ((bool) 1):
			// Clean up "version_val"
			{
			version_val_.free();
			}
			break;
		case ((bool) 0):
			// Clean up "version_nil"
			{
			}
			break;
		}
	switch ( dcil_scil_case_index() )
		{
		case ((bool) 1):
			// Clean up "conn_id"
			{
			}
			break;
		case ((bool) 0):
			// Clean up "short"
			{
			}
			break;
		}
	delete cid_;
	cid_ = 0;
	switch ( pkt_num_bytes_case_index() )
		{
		case ((uint8) 0):
			// Clean up "pkt_num_bytes1"
			{
			delete pkt_num_bytes1_;
			}
			break;
		case ((uint8) 1):
			// Clean up "pkt_num_bytes2"
			{
			delete pkt_num_bytes2_;
			}
			break;
		case ((uint8) 2):
			// Clean up "pkt_num_bytes3"
			{
			delete pkt_num_bytes3_;
			}
			break;
		case ((uint8) 3):
			// Clean up "pkt_num_bytes4"
			{
			delete pkt_num_bytes4_;
			}
			break;
		default:
			// Clean up "pkt_num_bytesx"
			{
			}
			break;
		}
	}

int RegularPacket::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "version"
	int t_version__size;
	version_case_index_ = flags()->is_long();
	switch ( version_case_index() )
		{
		case ((bool) 1):
			// Parse "version_val"
			{
			// Checking out-of-bound for "RegularPacket:version_val"
			if ( t_begin_of_data + (4) > t_end_of_data || t_begin_of_data + (4) < t_begin_of_data )
				{
				// Handle out-of-bound condition
				throw binpac::ExceptionOutOfBound("RegularPacket:version_val",
					(0) + (4), 
					(t_end_of_data) - (t_begin_of_data));
				}
			{
			// Setting t_end_of_data with &length
			const_byteptr t_end_of_data = t_begin_of_data + 4;
			int t_version_val_string_length;
			t_version_val_string_length = 4;
			int t_version_val__size;
			t_version_val__size = t_version_val_string_length;
			version_val_.init(t_begin_of_data, t_version_val_string_length);
			// Evaluate 'let' and 'withinput' fields
			}
			t_version__size = 4;
			}
			break;
		case ((bool) 0):
			// Parse "version_nil"
			{
			// Evaluate 'let' and 'withinput' fields
			t_version__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("RegularPacket", (int64)version_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_version = t_begin_of_data + (t_version__size);
	BINPAC_ASSERT(t_dataptr_after_version <= t_end_of_data);
	// Parse "dcil_scil"
	int t_dcil_scil__size;
	dcil_scil_case_index_ = flags()->is_long();
	switch ( dcil_scil_case_index() )
		{
		case ((bool) 1):
			// Parse "conn_id"
			{
			// Checking out-of-bound for "RegularPacket:conn_id"
			if ( t_dataptr_after_version + (1) > t_end_of_data || t_dataptr_after_version + (1) < t_dataptr_after_version )
				{
				// Handle out-of-bound condition
				throw binpac::ExceptionOutOfBound("RegularPacket:conn_id",
					((t_dataptr_after_version - t_begin_of_data)) + (1), 
					(t_end_of_data) - (t_begin_of_data));
				}
			conn_id_ = *((uint8 const *) (t_dataptr_after_version));
			// Evaluate 'let' and 'withinput' fields
			t_dcil_scil__size = 1;
			}
			break;
		case ((bool) 0):
			// Parse "short"
			{
			// Evaluate 'let' and 'withinput' fields
			t_dcil_scil__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("RegularPacket", (int64)dcil_scil_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_dcil_scil = t_dataptr_after_version + (t_dcil_scil__size);
	BINPAC_ASSERT(t_dataptr_after_dcil_scil <= t_end_of_data);
	// Parse "cid"
	cid_ = new ConnectionID(flags());
	int t_cid__size;
	t_cid__size = cid_->Parse(t_dataptr_after_dcil_scil, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_cid = t_dataptr_after_dcil_scil + (t_cid__size);
	BINPAC_ASSERT(t_dataptr_after_cid <= t_end_of_data);
	// Parse "pkt_num_bytes"
	int t_pkt_num_bytes__size;
	pkt_num_bytes_case_index_ = flags()->pkt_num_size();
	switch ( pkt_num_bytes_case_index() )
		{
		case ((uint8) 0):
			// Parse "pkt_num_bytes1"
			{
			int t_pkt_num_bytes1__arraylength;
			t_pkt_num_bytes1__arraylength = 0;
			t_pkt_num_bytes1__arraylength = 1;
			if ( t_pkt_num_bytes1__arraylength < 0 )
				{
				throw binpac::ExceptionOutOfBound("RegularPacket:pkt_num_bytes1",
				  t_pkt_num_bytes1__arraylength, (t_end_of_data) - (t_begin_of_data));
				}
			// Check bounds for static-size array: RegularPacket:pkt_num_bytes1
			if ( t_pkt_num_bytes1__arraylength > ((t_end_of_data - t_dataptr_after_cid) / 1) )
				throw binpac::ExceptionOutOfBound("RegularPacket:pkt_num_bytes1",
				  t_pkt_num_bytes1__arraylength, (t_end_of_data) - (t_dataptr_after_cid));
			pkt_num_bytes1__elem_ = 0;
			int t_pkt_num_bytes1__elem__it;
			t_pkt_num_bytes1__elem__it = 0;
			pkt_num_bytes1_ = new vector<uint8>;
			pkt_num_bytes1_->reserve(t_pkt_num_bytes1__arraylength);
			const_byteptr t_pkt_num_bytes1__elem__dataptr = t_dataptr_after_cid;
			for (; t_pkt_num_bytes1__elem__it < t_pkt_num_bytes1__arraylength; ++t_pkt_num_bytes1__elem__it)
				{
				pkt_num_bytes1__elem_ = *((uint8 const *) (t_pkt_num_bytes1__elem__dataptr));
				// Evaluate 'let' and 'withinput' fields
				pkt_num_bytes1_->push_back(pkt_num_bytes1__elem_);
				t_pkt_num_bytes1__elem__dataptr += 1;
				BINPAC_ASSERT(t_pkt_num_bytes1__elem__dataptr <= t_end_of_data);
				}
		end_of_pkt_num_bytes1: ;
			// Evaluate 'let' and 'withinput' fields
			t_pkt_num_bytes__size = 1;
			}
			break;
		case ((uint8) 1):
			// Parse "pkt_num_bytes2"
			{
			int t_pkt_num_bytes2__arraylength;
			t_pkt_num_bytes2__arraylength = 0;
			t_pkt_num_bytes2__arraylength = 2;
			if ( t_pkt_num_bytes2__arraylength < 0 )
				{
				throw binpac::ExceptionOutOfBound("RegularPacket:pkt_num_bytes2",
				  t_pkt_num_bytes2__arraylength, (t_end_of_data) - (t_begin_of_data));
				}
			// Check bounds for static-size array: RegularPacket:pkt_num_bytes2
			if ( t_pkt_num_bytes2__arraylength > ((t_end_of_data - t_dataptr_after_cid) / 1) )
				throw binpac::ExceptionOutOfBound("RegularPacket:pkt_num_bytes2",
				  t_pkt_num_bytes2__arraylength, (t_end_of_data) - (t_dataptr_after_cid));
			pkt_num_bytes2__elem_ = 0;
			int t_pkt_num_bytes2__elem__it;
			t_pkt_num_bytes2__elem__it = 0;
			pkt_num_bytes2_ = new vector<uint8>;
			pkt_num_bytes2_->reserve(t_pkt_num_bytes2__arraylength);
			const_byteptr t_pkt_num_bytes2__elem__dataptr = t_dataptr_after_cid;
			for (; t_pkt_num_bytes2__elem__it < t_pkt_num_bytes2__arraylength; ++t_pkt_num_bytes2__elem__it)
				{
				pkt_num_bytes2__elem_ = *((uint8 const *) (t_pkt_num_bytes2__elem__dataptr));
				// Evaluate 'let' and 'withinput' fields
				pkt_num_bytes2_->push_back(pkt_num_bytes2__elem_);
				t_pkt_num_bytes2__elem__dataptr += 1;
				BINPAC_ASSERT(t_pkt_num_bytes2__elem__dataptr <= t_end_of_data);
				}
		end_of_pkt_num_bytes2: ;
			// Evaluate 'let' and 'withinput' fields
			t_pkt_num_bytes__size = 2;
			}
			break;
		case ((uint8) 2):
			// Parse "pkt_num_bytes3"
			{
			int t_pkt_num_bytes3__arraylength;
			t_pkt_num_bytes3__arraylength = 0;
			t_pkt_num_bytes3__arraylength = 3;
			if ( t_pkt_num_bytes3__arraylength < 0 )
				{
				throw binpac::ExceptionOutOfBound("RegularPacket:pkt_num_bytes3",
				  t_pkt_num_bytes3__arraylength, (t_end_of_data) - (t_begin_of_data));
				}
			// Check bounds for static-size array: RegularPacket:pkt_num_bytes3
			if ( t_pkt_num_bytes3__arraylength > ((t_end_of_data - t_dataptr_after_cid) / 1) )
				throw binpac::ExceptionOutOfBound("RegularPacket:pkt_num_bytes3",
				  t_pkt_num_bytes3__arraylength, (t_end_of_data) - (t_dataptr_after_cid));
			pkt_num_bytes3__elem_ = 0;
			int t_pkt_num_bytes3__elem__it;
			t_pkt_num_bytes3__elem__it = 0;
			pkt_num_bytes3_ = new vector<uint8>;
			pkt_num_bytes3_->reserve(t_pkt_num_bytes3__arraylength);
			const_byteptr t_pkt_num_bytes3__elem__dataptr = t_dataptr_after_cid;
			for (; t_pkt_num_bytes3__elem__it < t_pkt_num_bytes3__arraylength; ++t_pkt_num_bytes3__elem__it)
				{
				pkt_num_bytes3__elem_ = *((uint8 const *) (t_pkt_num_bytes3__elem__dataptr));
				// Evaluate 'let' and 'withinput' fields
				pkt_num_bytes3_->push_back(pkt_num_bytes3__elem_);
				t_pkt_num_bytes3__elem__dataptr += 1;
				BINPAC_ASSERT(t_pkt_num_bytes3__elem__dataptr <= t_end_of_data);
				}
		end_of_pkt_num_bytes3: ;
			// Evaluate 'let' and 'withinput' fields
			t_pkt_num_bytes__size = 3;
			}
			break;
		case ((uint8) 3):
			// Parse "pkt_num_bytes4"
			{
			int t_pkt_num_bytes4__arraylength;
			t_pkt_num_bytes4__arraylength = 0;
			t_pkt_num_bytes4__arraylength = 4;
			if ( t_pkt_num_bytes4__arraylength < 0 )
				{
				throw binpac::ExceptionOutOfBound("RegularPacket:pkt_num_bytes4",
				  t_pkt_num_bytes4__arraylength, (t_end_of_data) - (t_begin_of_data));
				}
			// Check bounds for static-size array: RegularPacket:pkt_num_bytes4
			if ( t_pkt_num_bytes4__arraylength > ((t_end_of_data - t_dataptr_after_cid) / 1) )
				throw binpac::ExceptionOutOfBound("RegularPacket:pkt_num_bytes4",
				  t_pkt_num_bytes4__arraylength, (t_end_of_data) - (t_dataptr_after_cid));
			pkt_num_bytes4__elem_ = 0;
			int t_pkt_num_bytes4__elem__it;
			t_pkt_num_bytes4__elem__it = 0;
			pkt_num_bytes4_ = new vector<uint8>;
			pkt_num_bytes4_->reserve(t_pkt_num_bytes4__arraylength);
			const_byteptr t_pkt_num_bytes4__elem__dataptr = t_dataptr_after_cid;
			for (; t_pkt_num_bytes4__elem__it < t_pkt_num_bytes4__arraylength; ++t_pkt_num_bytes4__elem__it)
				{
				pkt_num_bytes4__elem_ = *((uint8 const *) (t_pkt_num_bytes4__elem__dataptr));
				// Evaluate 'let' and 'withinput' fields
				pkt_num_bytes4_->push_back(pkt_num_bytes4__elem_);
				t_pkt_num_bytes4__elem__dataptr += 1;
				BINPAC_ASSERT(t_pkt_num_bytes4__elem__dataptr <= t_end_of_data);
				}
		end_of_pkt_num_bytes4: ;
			// Evaluate 'let' and 'withinput' fields
			t_pkt_num_bytes__size = 4;
			}
			break;
		default:
			// Parse "pkt_num_bytesx"
			{
			// Evaluate 'let' and 'withinput' fields
			t_pkt_num_bytes__size = 0;
			}
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_RegularPacket__size;
	const_byteptr const t_dataptr_after_pkt_num_bytes = t_dataptr_after_cid + (t_pkt_num_bytes__size);
	BINPAC_ASSERT(t_dataptr_after_pkt_num_bytes <= t_end_of_data);
	t_RegularPacket__size = t_dataptr_after_pkt_num_bytes - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_RegularPacket__size) <= t_end_of_data);
	return t_RegularPacket__size;
	}

ConnectionID::ConnectionID(PublicFlags * flags)
	{
	present_case_index_ = -1;
	bytes_ = 0;
	bytes__elem_ = 0;
	flags_ = flags;
	}

ConnectionID::~ConnectionID()
	{
	switch ( present_case_index() )
		{
		case ((bool) 1):
			// Clean up "bytes"
			{
			delete bytes_;
			}
			break;
		case ((bool) 0):
			// Clean up "nil"
			{
			}
			break;
		}
	}

int ConnectionID::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "present"
	int t_present__size;
	present_case_index_ = flags()->cid_exists();
	switch ( present_case_index() )
		{
		case ((bool) 1):
			// Parse "bytes"
			{
			int t_bytes__arraylength;
			t_bytes__arraylength = 0;
			t_bytes__arraylength = 8;
			if ( t_bytes__arraylength < 0 )
				{
				throw binpac::ExceptionOutOfBound("ConnectionID:bytes",
				  t_bytes__arraylength, (t_end_of_data) - (t_begin_of_data));
				}
			// Check bounds for static-size array: ConnectionID:bytes
			if ( t_bytes__arraylength > ((t_end_of_data - t_begin_of_data) / 1) )
				throw binpac::ExceptionOutOfBound("ConnectionID:bytes",
				  t_bytes__arraylength, (t_end_of_data) - (t_begin_of_data));
			bytes__elem_ = 0;
			int t_bytes__elem__it;
			t_bytes__elem__it = 0;
			bytes_ = new vector<uint8>;
			bytes_->reserve(t_bytes__arraylength);
			const_byteptr t_bytes__elem__dataptr = t_begin_of_data;
			for (; t_bytes__elem__it < t_bytes__arraylength; ++t_bytes__elem__it)
				{
				bytes__elem_ = *((uint8 const *) (t_bytes__elem__dataptr));
				// Evaluate 'let' and 'withinput' fields
				bytes_->push_back(bytes__elem_);
				t_bytes__elem__dataptr += 1;
				BINPAC_ASSERT(t_bytes__elem__dataptr <= t_end_of_data);
				}
		end_of_bytes: ;
			// Evaluate 'let' and 'withinput' fields
			t_present__size = 8;
			}
			break;
		case ((bool) 0):
			// Parse "nil"
			{
			// Evaluate 'let' and 'withinput' fields
			t_present__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("ConnectionID", (int64)present_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_ConnectionID__size;
	const_byteptr const t_dataptr_after_present = t_begin_of_data + (t_present__size);
	BINPAC_ASSERT(t_dataptr_after_present <= t_end_of_data);
	t_ConnectionID__size = t_dataptr_after_present - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_ConnectionID__size) <= t_end_of_data);
	return t_ConnectionID__size;
	}

UnencryptedSearch::UnencryptedSearch(PublicFlags * flags, bool is_orig)
	{
	msg_auth_hash_ = 0;
	msg_auth_hash__elem_ = 0;
	stream_ = 0;
	sid_ = 0;
	extra_ = 0;
	offset_ = 0;
	data_len_ = 0;
	expected_string_ = 0;
	build_hello_ = 0;
	flags_ = flags;
	is_orig_ = is_orig;
	}

UnencryptedSearch::~UnencryptedSearch()
	{
	delete msg_auth_hash_;
	delete stream_;
	stream_ = 0;
	delete sid_;
	sid_ = 0;
	delete extra_;
	extra_ = 0;
	delete offset_;
	offset_ = 0;
	delete data_len_;
	data_len_ = 0;
	delete expected_string_;
	expected_string_ = 0;
	delete build_hello_;
	build_hello_ = 0;
	}

int UnencryptedSearch::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "UnencryptedSearch:stream"
	if ( (t_begin_of_data + 12) + (1) > t_end_of_data || (t_begin_of_data + 12) + (1) < (t_begin_of_data + 12) )
		{
		// Handle out-of-bound condition
		throw binpac::ExceptionOutOfBound("UnencryptedSearch:stream",
			(12) + (1), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "msg_auth_hash"
	int t_msg_auth_hash__arraylength;
	t_msg_auth_hash__arraylength = 0;
	t_msg_auth_hash__arraylength = 12;
	if ( t_msg_auth_hash__arraylength < 0 )
		{
		throw binpac::ExceptionOutOfBound("UnencryptedSearch:msg_auth_hash",
		  t_msg_auth_hash__arraylength, (t_end_of_data) - (t_begin_of_data));
		}
	// Check bounds for static-size array: UnencryptedSearch:msg_auth_hash
	if ( t_msg_auth_hash__arraylength > ((t_end_of_data - t_begin_of_data) / 1) )
		throw binpac::ExceptionOutOfBound("UnencryptedSearch:msg_auth_hash",
		  t_msg_auth_hash__arraylength, (t_end_of_data) - (t_begin_of_data));
	msg_auth_hash__elem_ = 0;
	int t_msg_auth_hash__elem__it;
	t_msg_auth_hash__elem__it = 0;
	msg_auth_hash_ = new vector<uint8>;
	msg_auth_hash_->reserve(t_msg_auth_hash__arraylength);
	const_byteptr t_msg_auth_hash__elem__dataptr = t_begin_of_data;
	for (; t_msg_auth_hash__elem__it < t_msg_auth_hash__arraylength; ++t_msg_auth_hash__elem__it)
		{
		msg_auth_hash__elem_ = *((uint8 const *) (t_msg_auth_hash__elem__dataptr));
		// Evaluate 'let' and 'withinput' fields
		msg_auth_hash_->push_back(msg_auth_hash__elem_);
		t_msg_auth_hash__elem__dataptr += 1;
		BINPAC_ASSERT(t_msg_auth_hash__elem__dataptr <= t_end_of_data);
		}
end_of_msg_auth_hash: ;
	// Evaluate 'let' and 'withinput' fields
	
	// Parse "stream"
	stream_ = new StreamID(flags());
	stream_->Parse((t_begin_of_data + 12), t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	// Parse "sid"
	sid_ = new SId(stream());
	int t_sid__size;
	t_sid__size = sid_->Parse((t_begin_of_data + 13), t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_sid = (t_begin_of_data + 13) + (t_sid__size);
	BINPAC_ASSERT(t_dataptr_after_sid <= t_end_of_data);
	// Parse "extra"
	extra_ = new NewerVersions(stream());
	int t_extra__size;
	t_extra__size = extra_->Parse(t_dataptr_after_sid, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_extra = t_dataptr_after_sid + (t_extra__size);
	BINPAC_ASSERT(t_dataptr_after_extra <= t_end_of_data);
	// Parse "offset"
	offset_ = new StreamOffset(stream());
	int t_offset__size;
	t_offset__size = offset_->Parse(t_dataptr_after_extra, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_offset = t_dataptr_after_extra + (t_offset__size);
	BINPAC_ASSERT(t_dataptr_after_offset <= t_end_of_data);
	// Parse "data_len"
	data_len_ = new DataLength(stream());
	int t_data_len__size;
	t_data_len__size = data_len_->Parse(t_dataptr_after_offset, t_end_of_data, t_byteorder);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_data_len = t_dataptr_after_offset + (t_data_len__size);
	BINPAC_ASSERT(t_dataptr_after_data_len <= t_end_of_data);
	// Parse "expected_string"
	expected_string_ = new HelloCheck(flags(), is_orig());
	int t_expected_string__size;
	t_expected_string__size = expected_string_->Parse(t_dataptr_after_data_len, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_expected_string = t_dataptr_after_data_len + (t_expected_string__size);
	BINPAC_ASSERT(t_dataptr_after_expected_string <= t_end_of_data);
	// Parse "build_hello"
	build_hello_ = new TypeHello(flags(), is_orig(), expected_string());
	int t_build_hello__size;
	t_build_hello__size = build_hello_->Parse(t_dataptr_after_expected_string, t_end_of_data, t_byteorder);
	// Evaluate 'let' and 'withinput' fields
	
	int t_UnencryptedSearch__size;
	const_byteptr const t_dataptr_after_build_hello = t_dataptr_after_expected_string + (t_build_hello__size);
	BINPAC_ASSERT(t_dataptr_after_build_hello <= t_end_of_data);
	t_UnencryptedSearch__size = t_dataptr_after_build_hello - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_UnencryptedSearch__size) <= t_end_of_data);
	return t_UnencryptedSearch__size;
	}

StreamID::StreamID(PublicFlags * flags)
	{
	byte_ = 0;
	flags_ = flags;
	streams_ = 0;
	extra_bit_ = 0;
	data_length_ = 0;
	offset_length_ = 0;
	fin_bit_ = 0;
	}

StreamID::~StreamID()
	{
	}

int StreamID::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Checking out-of-bound for "StreamID"
	if ( t_begin_of_data + (1) > t_end_of_data || t_begin_of_data + (1) < t_begin_of_data )
		{
		// Handle out-of-bound condition
		throw binpac::ExceptionOutOfBound("StreamID",
			(0) + (1), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "byte"
	byte_ = *((uint8 const *) (t_begin_of_data));
	// Evaluate 'let' and 'withinput' fields
	
	// Evaluate 'let' and 'withinput' fields
	streams_ =  ( byte() & 0x80 )  == 0x80;
	extra_bit_ =  ( byte() & 0x40 )  == 0x40;
	data_length_ =  ( byte() & 0x20 )  == 0x20;
	offset_length_ =  ( byte() & 0x1c ) ;
	fin_bit_ =  ( byte() & 0x01 )  == 0x01;
	BINPAC_ASSERT(t_begin_of_data + (1) <= t_end_of_data);
	return 1;
	}

SId::SId(StreamID * stream)
	{
	is_stream_case_index_ = -1;
	id_ = 0;
	stream_ = stream;
	}

SId::~SId()
	{
	switch ( is_stream_case_index() )
		{
		case ((bool) 1):
			// Clean up "id"
			{
			}
			break;
		case ((bool) 0):
			// Clean up "nil"
			{
			}
			break;
		}
	}

int SId::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "is_stream"
	int t_is_stream__size;
	is_stream_case_index_ = stream()->streams();
	switch ( is_stream_case_index() )
		{
		case ((bool) 1):
			// Parse "id"
			{
			// Checking out-of-bound for "SId:id"
			if ( t_begin_of_data + (1) > t_end_of_data || t_begin_of_data + (1) < t_begin_of_data )
				{
				// Handle out-of-bound condition
				throw binpac::ExceptionOutOfBound("SId:id",
					(0) + (1), 
					(t_end_of_data) - (t_begin_of_data));
				}
			id_ = *((uint8 const *) (t_begin_of_data));
			// Evaluate 'let' and 'withinput' fields
			t_is_stream__size = 1;
			}
			break;
		case ((bool) 0):
			// Parse "nil"
			{
			// Evaluate 'let' and 'withinput' fields
			t_is_stream__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("SId", (int64)is_stream_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_SId__size;
	const_byteptr const t_dataptr_after_is_stream = t_begin_of_data + (t_is_stream__size);
	BINPAC_ASSERT(t_dataptr_after_is_stream <= t_end_of_data);
	t_SId__size = t_dataptr_after_is_stream - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_SId__size) <= t_end_of_data);
	return t_SId__size;
	}

NewerVersions::NewerVersions(StreamID * stream)
	{
	extra_space_case_index_ = -1;
	plus_six_ = 0;
	plus_six__elem_ = 0;
	stream_ = stream;
	}

NewerVersions::~NewerVersions()
	{
	switch ( extra_space_case_index() )
		{
		case ((bool) 1):
			// Clean up "plus_six"
			{
			delete plus_six_;
			}
			break;
		case ((bool) 0):
			// Clean up "none"
			{
			}
			break;
		}
	}

int NewerVersions::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "extra_space"
	int t_extra_space__size;
	extra_space_case_index_ = stream()->extra_bit();
	switch ( extra_space_case_index() )
		{
		case ((bool) 1):
			// Parse "plus_six"
			{
			int t_plus_six__arraylength;
			t_plus_six__arraylength = 0;
			t_plus_six__arraylength = 7;
			if ( t_plus_six__arraylength < 0 )
				{
				throw binpac::ExceptionOutOfBound("NewerVersions:plus_six",
				  t_plus_six__arraylength, (t_end_of_data) - (t_begin_of_data));
				}
			// Check bounds for static-size array: NewerVersions:plus_six
			if ( t_plus_six__arraylength > ((t_end_of_data - t_begin_of_data) / 1) )
				throw binpac::ExceptionOutOfBound("NewerVersions:plus_six",
				  t_plus_six__arraylength, (t_end_of_data) - (t_begin_of_data));
			plus_six__elem_ = 0;
			int t_plus_six__elem__it;
			t_plus_six__elem__it = 0;
			plus_six_ = new vector<uint8>;
			plus_six_->reserve(t_plus_six__arraylength);
			const_byteptr t_plus_six__elem__dataptr = t_begin_of_data;
			for (; t_plus_six__elem__it < t_plus_six__arraylength; ++t_plus_six__elem__it)
				{
				plus_six__elem_ = *((uint8 const *) (t_plus_six__elem__dataptr));
				// Evaluate 'let' and 'withinput' fields
				plus_six_->push_back(plus_six__elem_);
				t_plus_six__elem__dataptr += 1;
				BINPAC_ASSERT(t_plus_six__elem__dataptr <= t_end_of_data);
				}
		end_of_plus_six: ;
			// Evaluate 'let' and 'withinput' fields
			t_extra_space__size = 7;
			}
			break;
		case ((bool) 0):
			// Parse "none"
			{
			// Evaluate 'let' and 'withinput' fields
			t_extra_space__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("NewerVersions", (int64)extra_space_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_NewerVersions__size;
	const_byteptr const t_dataptr_after_extra_space = t_begin_of_data + (t_extra_space__size);
	BINPAC_ASSERT(t_dataptr_after_extra_space <= t_end_of_data);
	t_NewerVersions__size = t_dataptr_after_extra_space - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_NewerVersions__size) <= t_end_of_data);
	return t_NewerVersions__size;
	}

DataLength::DataLength(StreamID * stream)
	{
	len_case_index_ = -1;
	yes_ = 0;
	stream_ = stream;
	}

DataLength::~DataLength()
	{
	switch ( len_case_index() )
		{
		case ((bool) 1):
			// Clean up "yes"
			{
			}
			break;
		case ((bool) 0):
			// Clean up "no"
			{
			}
			break;
		}
	}

int DataLength::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder)
	{
	// Parse "len"
	int t_len__size;
	len_case_index_ = stream()->data_length();
	switch ( len_case_index() )
		{
		case ((bool) 1):
			// Parse "yes"
			{
			// Checking out-of-bound for "DataLength:yes"
			if ( t_begin_of_data + (2) > t_end_of_data || t_begin_of_data + (2) < t_begin_of_data )
				{
				// Handle out-of-bound condition
				throw binpac::ExceptionOutOfBound("DataLength:yes",
					(0) + (2), 
					(t_end_of_data) - (t_begin_of_data));
				}
			yes_ = FixByteOrder(t_byteorder, *((uint16 const *) (t_begin_of_data)));
			// Evaluate 'let' and 'withinput' fields
			t_len__size = 2;
			}
			break;
		case ((bool) 0):
			// Parse "no"
			{
			// Evaluate 'let' and 'withinput' fields
			t_len__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("DataLength", (int64)len_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_DataLength__size;
	const_byteptr const t_dataptr_after_len = t_begin_of_data + (t_len__size);
	BINPAC_ASSERT(t_dataptr_after_len <= t_end_of_data);
	t_DataLength__size = t_dataptr_after_len - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_DataLength__size) <= t_end_of_data);
	return t_DataLength__size;
	}

StreamOffset::StreamOffset(StreamID * stream)
	{
	offset_type_case_index_ = -1;
	pkt_offset_bytes2_ = 0;
	pkt_offset_bytes2__elem_ = 0;
	pkt_offset_bytes3_ = 0;
	pkt_offset_bytes3__elem_ = 0;
	pkt_offset_bytes4_ = 0;
	pkt_offset_bytes4__elem_ = 0;
	pkt_offset_bytes5_ = 0;
	pkt_offset_bytes5__elem_ = 0;
	pkt_offset_bytes6_ = 0;
	pkt_offset_bytes6__elem_ = 0;
	pkt_offset_bytes7_ = 0;
	pkt_offset_bytes7__elem_ = 0;
	pkt_offset_bytes8_ = 0;
	pkt_offset_bytes8__elem_ = 0;
	stream_ = stream;
	}

StreamOffset::~StreamOffset()
	{
	switch ( offset_type_case_index() )
		{
		case ((int) 0):
			// Clean up "pkt_offset_bytes0"
			{
			}
			break;
		case ((int) 4):
			// Clean up "pkt_offset_bytes2"
			{
			delete pkt_offset_bytes2_;
			}
			break;
		case ((int) 8):
			// Clean up "pkt_offset_bytes3"
			{
			delete pkt_offset_bytes3_;
			}
			break;
		case ((int) 12):
			// Clean up "pkt_offset_bytes4"
			{
			delete pkt_offset_bytes4_;
			}
			break;
		case ((int) 16):
			// Clean up "pkt_offset_bytes5"
			{
			delete pkt_offset_bytes5_;
			}
			break;
		case ((int) 20):
			// Clean up "pkt_offset_bytes6"
			{
			delete pkt_offset_bytes6_;
			}
			break;
		case ((int) 24):
			// Clean up "pkt_offset_bytes7"
			{
			delete pkt_offset_bytes7_;
			}
			break;
		case ((int) 28):
			// Clean up "pkt_offset_bytes8"
			{
			delete pkt_offset_bytes8_;
			}
			break;
		default:
			// Clean up "pkt_offset_bytesx"
			{
			}
			break;
		}
	}

int StreamOffset::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "offset_type"
	int t_offset_type__size;
	offset_type_case_index_ = stream()->offset_length();
	switch ( offset_type_case_index() )
		{
		case ((int) 0):
			// Parse "pkt_offset_bytes0"
			{
			// Evaluate 'let' and 'withinput' fields
			t_offset_type__size = 0;
			}
			break;
		case ((int) 4):
			// Parse "pkt_offset_bytes2"
			{
			int t_pkt_offset_bytes2__arraylength;
			t_pkt_offset_bytes2__arraylength = 0;
			t_pkt_offset_bytes2__arraylength = 2;
			if ( t_pkt_offset_bytes2__arraylength < 0 )
				{
				throw binpac::ExceptionOutOfBound("StreamOffset:pkt_offset_bytes2",
				  t_pkt_offset_bytes2__arraylength, (t_end_of_data) - (t_begin_of_data));
				}
			// Check bounds for static-size array: StreamOffset:pkt_offset_bytes2
			if ( t_pkt_offset_bytes2__arraylength > ((t_end_of_data - t_begin_of_data) / 1) )
				throw binpac::ExceptionOutOfBound("StreamOffset:pkt_offset_bytes2",
				  t_pkt_offset_bytes2__arraylength, (t_end_of_data) - (t_begin_of_data));
			pkt_offset_bytes2__elem_ = 0;
			int t_pkt_offset_bytes2__elem__it;
			t_pkt_offset_bytes2__elem__it = 0;
			pkt_offset_bytes2_ = new vector<uint8>;
			pkt_offset_bytes2_->reserve(t_pkt_offset_bytes2__arraylength);
			const_byteptr t_pkt_offset_bytes2__elem__dataptr = t_begin_of_data;
			for (; t_pkt_offset_bytes2__elem__it < t_pkt_offset_bytes2__arraylength; ++t_pkt_offset_bytes2__elem__it)
				{
				pkt_offset_bytes2__elem_ = *((uint8 const *) (t_pkt_offset_bytes2__elem__dataptr));
				// Evaluate 'let' and 'withinput' fields
				pkt_offset_bytes2_->push_back(pkt_offset_bytes2__elem_);
				t_pkt_offset_bytes2__elem__dataptr += 1;
				BINPAC_ASSERT(t_pkt_offset_bytes2__elem__dataptr <= t_end_of_data);
				}
		end_of_pkt_offset_bytes2: ;
			// Evaluate 'let' and 'withinput' fields
			t_offset_type__size = 2;
			}
			break;
		case ((int) 8):
			// Parse "pkt_offset_bytes3"
			{
			int t_pkt_offset_bytes3__arraylength;
			t_pkt_offset_bytes3__arraylength = 0;
			t_pkt_offset_bytes3__arraylength = 3;
			if ( t_pkt_offset_bytes3__arraylength < 0 )
				{
				throw binpac::ExceptionOutOfBound("StreamOffset:pkt_offset_bytes3",
				  t_pkt_offset_bytes3__arraylength, (t_end_of_data) - (t_begin_of_data));
				}
			// Check bounds for static-size array: StreamOffset:pkt_offset_bytes3
			if ( t_pkt_offset_bytes3__arraylength > ((t_end_of_data - t_begin_of_data) / 1) )
				throw binpac::ExceptionOutOfBound("StreamOffset:pkt_offset_bytes3",
				  t_pkt_offset_bytes3__arraylength, (t_end_of_data) - (t_begin_of_data));
			pkt_offset_bytes3__elem_ = 0;
			int t_pkt_offset_bytes3__elem__it;
			t_pkt_offset_bytes3__elem__it = 0;
			pkt_offset_bytes3_ = new vector<uint8>;
			pkt_offset_bytes3_->reserve(t_pkt_offset_bytes3__arraylength);
			const_byteptr t_pkt_offset_bytes3__elem__dataptr = t_begin_of_data;
			for (; t_pkt_offset_bytes3__elem__it < t_pkt_offset_bytes3__arraylength; ++t_pkt_offset_bytes3__elem__it)
				{
				pkt_offset_bytes3__elem_ = *((uint8 const *) (t_pkt_offset_bytes3__elem__dataptr));
				// Evaluate 'let' and 'withinput' fields
				pkt_offset_bytes3_->push_back(pkt_offset_bytes3__elem_);
				t_pkt_offset_bytes3__elem__dataptr += 1;
				BINPAC_ASSERT(t_pkt_offset_bytes3__elem__dataptr <= t_end_of_data);
				}
		end_of_pkt_offset_bytes3: ;
			// Evaluate 'let' and 'withinput' fields
			t_offset_type__size = 3;
			}
			break;
		case ((int) 12):
			// Parse "pkt_offset_bytes4"
			{
			int t_pkt_offset_bytes4__arraylength;
			t_pkt_offset_bytes4__arraylength = 0;
			t_pkt_offset_bytes4__arraylength = 4;
			if ( t_pkt_offset_bytes4__arraylength < 0 )
				{
				throw binpac::ExceptionOutOfBound("StreamOffset:pkt_offset_bytes4",
				  t_pkt_offset_bytes4__arraylength, (t_end_of_data) - (t_begin_of_data));
				}
			// Check bounds for static-size array: StreamOffset:pkt_offset_bytes4
			if ( t_pkt_offset_bytes4__arraylength > ((t_end_of_data - t_begin_of_data) / 1) )
				throw binpac::ExceptionOutOfBound("StreamOffset:pkt_offset_bytes4",
				  t_pkt_offset_bytes4__arraylength, (t_end_of_data) - (t_begin_of_data));
			pkt_offset_bytes4__elem_ = 0;
			int t_pkt_offset_bytes4__elem__it;
			t_pkt_offset_bytes4__elem__it = 0;
			pkt_offset_bytes4_ = new vector<uint8>;
			pkt_offset_bytes4_->reserve(t_pkt_offset_bytes4__arraylength);
			const_byteptr t_pkt_offset_bytes4__elem__dataptr = t_begin_of_data;
			for (; t_pkt_offset_bytes4__elem__it < t_pkt_offset_bytes4__arraylength; ++t_pkt_offset_bytes4__elem__it)
				{
				pkt_offset_bytes4__elem_ = *((uint8 const *) (t_pkt_offset_bytes4__elem__dataptr));
				// Evaluate 'let' and 'withinput' fields
				pkt_offset_bytes4_->push_back(pkt_offset_bytes4__elem_);
				t_pkt_offset_bytes4__elem__dataptr += 1;
				BINPAC_ASSERT(t_pkt_offset_bytes4__elem__dataptr <= t_end_of_data);
				}
		end_of_pkt_offset_bytes4: ;
			// Evaluate 'let' and 'withinput' fields
			t_offset_type__size = 4;
			}
			break;
		case ((int) 16):
			// Parse "pkt_offset_bytes5"
			{
			int t_pkt_offset_bytes5__arraylength;
			t_pkt_offset_bytes5__arraylength = 0;
			t_pkt_offset_bytes5__arraylength = 5;
			if ( t_pkt_offset_bytes5__arraylength < 0 )
				{
				throw binpac::ExceptionOutOfBound("StreamOffset:pkt_offset_bytes5",
				  t_pkt_offset_bytes5__arraylength, (t_end_of_data) - (t_begin_of_data));
				}
			// Check bounds for static-size array: StreamOffset:pkt_offset_bytes5
			if ( t_pkt_offset_bytes5__arraylength > ((t_end_of_data - t_begin_of_data) / 1) )
				throw binpac::ExceptionOutOfBound("StreamOffset:pkt_offset_bytes5",
				  t_pkt_offset_bytes5__arraylength, (t_end_of_data) - (t_begin_of_data));
			pkt_offset_bytes5__elem_ = 0;
			int t_pkt_offset_bytes5__elem__it;
			t_pkt_offset_bytes5__elem__it = 0;
			pkt_offset_bytes5_ = new vector<uint8>;
			pkt_offset_bytes5_->reserve(t_pkt_offset_bytes5__arraylength);
			const_byteptr t_pkt_offset_bytes5__elem__dataptr = t_begin_of_data;
			for (; t_pkt_offset_bytes5__elem__it < t_pkt_offset_bytes5__arraylength; ++t_pkt_offset_bytes5__elem__it)
				{
				pkt_offset_bytes5__elem_ = *((uint8 const *) (t_pkt_offset_bytes5__elem__dataptr));
				// Evaluate 'let' and 'withinput' fields
				pkt_offset_bytes5_->push_back(pkt_offset_bytes5__elem_);
				t_pkt_offset_bytes5__elem__dataptr += 1;
				BINPAC_ASSERT(t_pkt_offset_bytes5__elem__dataptr <= t_end_of_data);
				}
		end_of_pkt_offset_bytes5: ;
			// Evaluate 'let' and 'withinput' fields
			t_offset_type__size = 5;
			}
			break;
		case ((int) 20):
			// Parse "pkt_offset_bytes6"
			{
			int t_pkt_offset_bytes6__arraylength;
			t_pkt_offset_bytes6__arraylength = 0;
			t_pkt_offset_bytes6__arraylength = 6;
			if ( t_pkt_offset_bytes6__arraylength < 0 )
				{
				throw binpac::ExceptionOutOfBound("StreamOffset:pkt_offset_bytes6",
				  t_pkt_offset_bytes6__arraylength, (t_end_of_data) - (t_begin_of_data));
				}
			// Check bounds for static-size array: StreamOffset:pkt_offset_bytes6
			if ( t_pkt_offset_bytes6__arraylength > ((t_end_of_data - t_begin_of_data) / 1) )
				throw binpac::ExceptionOutOfBound("StreamOffset:pkt_offset_bytes6",
				  t_pkt_offset_bytes6__arraylength, (t_end_of_data) - (t_begin_of_data));
			pkt_offset_bytes6__elem_ = 0;
			int t_pkt_offset_bytes6__elem__it;
			t_pkt_offset_bytes6__elem__it = 0;
			pkt_offset_bytes6_ = new vector<uint8>;
			pkt_offset_bytes6_->reserve(t_pkt_offset_bytes6__arraylength);
			const_byteptr t_pkt_offset_bytes6__elem__dataptr = t_begin_of_data;
			for (; t_pkt_offset_bytes6__elem__it < t_pkt_offset_bytes6__arraylength; ++t_pkt_offset_bytes6__elem__it)
				{
				pkt_offset_bytes6__elem_ = *((uint8 const *) (t_pkt_offset_bytes6__elem__dataptr));
				// Evaluate 'let' and 'withinput' fields
				pkt_offset_bytes6_->push_back(pkt_offset_bytes6__elem_);
				t_pkt_offset_bytes6__elem__dataptr += 1;
				BINPAC_ASSERT(t_pkt_offset_bytes6__elem__dataptr <= t_end_of_data);
				}
		end_of_pkt_offset_bytes6: ;
			// Evaluate 'let' and 'withinput' fields
			t_offset_type__size = 6;
			}
			break;
		case ((int) 24):
			// Parse "pkt_offset_bytes7"
			{
			int t_pkt_offset_bytes7__arraylength;
			t_pkt_offset_bytes7__arraylength = 0;
			t_pkt_offset_bytes7__arraylength = 7;
			if ( t_pkt_offset_bytes7__arraylength < 0 )
				{
				throw binpac::ExceptionOutOfBound("StreamOffset:pkt_offset_bytes7",
				  t_pkt_offset_bytes7__arraylength, (t_end_of_data) - (t_begin_of_data));
				}
			// Check bounds for static-size array: StreamOffset:pkt_offset_bytes7
			if ( t_pkt_offset_bytes7__arraylength > ((t_end_of_data - t_begin_of_data) / 1) )
				throw binpac::ExceptionOutOfBound("StreamOffset:pkt_offset_bytes7",
				  t_pkt_offset_bytes7__arraylength, (t_end_of_data) - (t_begin_of_data));
			pkt_offset_bytes7__elem_ = 0;
			int t_pkt_offset_bytes7__elem__it;
			t_pkt_offset_bytes7__elem__it = 0;
			pkt_offset_bytes7_ = new vector<uint8>;
			pkt_offset_bytes7_->reserve(t_pkt_offset_bytes7__arraylength);
			const_byteptr t_pkt_offset_bytes7__elem__dataptr = t_begin_of_data;
			for (; t_pkt_offset_bytes7__elem__it < t_pkt_offset_bytes7__arraylength; ++t_pkt_offset_bytes7__elem__it)
				{
				pkt_offset_bytes7__elem_ = *((uint8 const *) (t_pkt_offset_bytes7__elem__dataptr));
				// Evaluate 'let' and 'withinput' fields
				pkt_offset_bytes7_->push_back(pkt_offset_bytes7__elem_);
				t_pkt_offset_bytes7__elem__dataptr += 1;
				BINPAC_ASSERT(t_pkt_offset_bytes7__elem__dataptr <= t_end_of_data);
				}
		end_of_pkt_offset_bytes7: ;
			// Evaluate 'let' and 'withinput' fields
			t_offset_type__size = 7;
			}
			break;
		case ((int) 28):
			// Parse "pkt_offset_bytes8"
			{
			int t_pkt_offset_bytes8__arraylength;
			t_pkt_offset_bytes8__arraylength = 0;
			t_pkt_offset_bytes8__arraylength = 8;
			if ( t_pkt_offset_bytes8__arraylength < 0 )
				{
				throw binpac::ExceptionOutOfBound("StreamOffset:pkt_offset_bytes8",
				  t_pkt_offset_bytes8__arraylength, (t_end_of_data) - (t_begin_of_data));
				}
			// Check bounds for static-size array: StreamOffset:pkt_offset_bytes8
			if ( t_pkt_offset_bytes8__arraylength > ((t_end_of_data - t_begin_of_data) / 1) )
				throw binpac::ExceptionOutOfBound("StreamOffset:pkt_offset_bytes8",
				  t_pkt_offset_bytes8__arraylength, (t_end_of_data) - (t_begin_of_data));
			pkt_offset_bytes8__elem_ = 0;
			int t_pkt_offset_bytes8__elem__it;
			t_pkt_offset_bytes8__elem__it = 0;
			pkt_offset_bytes8_ = new vector<uint8>;
			pkt_offset_bytes8_->reserve(t_pkt_offset_bytes8__arraylength);
			const_byteptr t_pkt_offset_bytes8__elem__dataptr = t_begin_of_data;
			for (; t_pkt_offset_bytes8__elem__it < t_pkt_offset_bytes8__arraylength; ++t_pkt_offset_bytes8__elem__it)
				{
				pkt_offset_bytes8__elem_ = *((uint8 const *) (t_pkt_offset_bytes8__elem__dataptr));
				// Evaluate 'let' and 'withinput' fields
				pkt_offset_bytes8_->push_back(pkt_offset_bytes8__elem_);
				t_pkt_offset_bytes8__elem__dataptr += 1;
				BINPAC_ASSERT(t_pkt_offset_bytes8__elem__dataptr <= t_end_of_data);
				}
		end_of_pkt_offset_bytes8: ;
			// Evaluate 'let' and 'withinput' fields
			t_offset_type__size = 8;
			}
			break;
		default:
			// Parse "pkt_offset_bytesx"
			{
			// Evaluate 'let' and 'withinput' fields
			t_offset_type__size = 0;
			}
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_StreamOffset__size;
	const_byteptr const t_dataptr_after_offset_type = t_begin_of_data + (t_offset_type__size);
	BINPAC_ASSERT(t_dataptr_after_offset_type <= t_end_of_data);
	t_StreamOffset__size = t_dataptr_after_offset_type - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_StreamOffset__size) <= t_end_of_data);
	return t_StreamOffset__size;
	}

HelloCheck::HelloCheck(PublicFlags * flags, bool is_orig)
	{
	flags_ = flags;
	is_orig_ = is_orig;
	hello_check_ = 0;
	rej_check_ = 0;
	}

HelloCheck::~HelloCheck()
	{
	hello_string_.free();
	}

int HelloCheck::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "hello_string"
	// Checking out-of-bound for "HelloCheck:hello_string"
	if ( t_begin_of_data + (4) > t_end_of_data || t_begin_of_data + (4) < t_begin_of_data )
		{
		// Handle out-of-bound condition
		throw binpac::ExceptionOutOfBound("HelloCheck:hello_string",
			(0) + (4), 
			(t_end_of_data) - (t_begin_of_data));
		}
	{
	// Setting t_end_of_data with &length
	const_byteptr t_end_of_data = t_begin_of_data + 4;
	int t_hello_string_string_length;
	t_hello_string_string_length = 4;
	int t_hello_string__size;
	t_hello_string__size = t_hello_string_string_length;
	hello_string_.init(t_begin_of_data, t_hello_string_string_length);
	// Evaluate 'let' and 'withinput' fields
	}
	
	int t_HelloCheck__size;
	const_byteptr const t_dataptr_after_hello_string = t_begin_of_data + (4);
	BINPAC_ASSERT(t_dataptr_after_hello_string <= t_end_of_data);
	t_HelloCheck__size = t_dataptr_after_hello_string - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	hello_check_ =  (  ( hello_string()[0] == 0x43 )  &&  ( hello_string()[1] == 0x48 )  &&  ( hello_string()[2] == 0x4c )  &&  ( hello_string()[3] == 0x4f )  ) ;
	rej_check_ =  (  ( hello_string()[0] == 0x52 )  &&  ( hello_string()[1] == 0x45 )  &&  ( hello_string()[2] == 0x4a )  &&  ( hello_string()[3] == 0x00 )  ) ;
	BINPAC_ASSERT(t_begin_of_data + (t_HelloCheck__size) <= t_end_of_data);
	return t_HelloCheck__size;
	}

TypeHello::TypeHello(PublicFlags * flags, bool is_orig, HelloCheck * expected_string)
	{
	client_case_index_ = -1;
	yes_ = 0;
	server_case_index_ = -1;
	rej_ = 0;
	flags_ = flags;
	is_orig_ = is_orig;
	expected_string_ = expected_string;
	}

TypeHello::~TypeHello()
	{
	switch ( client_case_index() )
		{
		case ((bool) 1):
			// Clean up "yes"
			{
			delete yes_;
			yes_ = 0;
			}
			break;
		case ((bool) 0):
			// Clean up "no"
			{
			}
			break;
		}
	switch ( server_case_index() )
		{
		case ((bool) 1):
			// Clean up "rej"
			{
			delete rej_;
			rej_ = 0;
			}
			break;
		case ((bool) 0):
			// Clean up "none"
			{
			}
			break;
		}
	}

int TypeHello::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder)
	{
	// Parse "client"
	int t_client__size;
	client_case_index_ = expected_string()->hello_check();
	switch ( client_case_index() )
		{
		case ((bool) 1):
			// Parse "yes"
			{
			yes_ = new HelloPacket(flags(), is_orig());
			int t_yes__size;
			t_yes__size = yes_->Parse(t_begin_of_data, t_end_of_data, t_byteorder);
			// Evaluate 'let' and 'withinput' fields
			t_client__size = t_yes__size;
			}
			break;
		case ((bool) 0):
			// Parse "no"
			{
			// Evaluate 'let' and 'withinput' fields
			t_client__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("TypeHello", (int64)client_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_client = t_begin_of_data + (t_client__size);
	BINPAC_ASSERT(t_dataptr_after_client <= t_end_of_data);
	// Parse "server"
	int t_server__size;
	server_case_index_ = expected_string()->rej_check();
	switch ( server_case_index() )
		{
		case ((bool) 1):
			// Parse "rej"
			{
			rej_ = new RejPacket(flags(), is_orig());
			int t_rej__size;
			t_rej__size = rej_->Parse(t_dataptr_after_client, t_end_of_data, t_byteorder);
			// Evaluate 'let' and 'withinput' fields
			t_server__size = t_rej__size;
			}
			break;
		case ((bool) 0):
			// Parse "none"
			{
			// Evaluate 'let' and 'withinput' fields
			t_server__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("TypeHello", (int64)server_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_TypeHello__size;
	const_byteptr const t_dataptr_after_server = t_dataptr_after_client + (t_server__size);
	BINPAC_ASSERT(t_dataptr_after_server <= t_end_of_data);
	t_TypeHello__size = t_dataptr_after_server - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_TypeHello__size) <= t_end_of_data);
	return t_TypeHello__size;
	}

HelloPacket::HelloPacket(PublicFlags * flags, bool is_orig)
	{
	tag_number_ = 0;
	zero_pading_ = 0;
	other_tags_ = 0;
	pad_ = 0;
	sni_ = 0;
	stk_ = 0;
	sno_ = 0;
	ver_ = 0;
	ccs_ = 0;
	nonc_ = 0;
	mspc_ = 0;
	aead_ = 0;
	uaid_ = 0;
	scid_ = 0;
	tcid_ = 0;
	pdmd_ = 0;
	smhl_ = 0;
	icsl_ = 0;
	ctim_ = 0;
	nonp_ = 0;
	pubs_ = 0;
	mids_ = 0;
	scls_ = 0;
	kexs_ = 0;
	xlct_ = 0;
	csct_ = 0;
	copt_ = 0;
	ccrt_ = 0;
	irtt_ = 0;
	cetv_ = 0;
	cfcw_ = 0;
	sfcw_ = 0;
	flags_ = flags;
	is_orig_ = is_orig;
	p_tag_offset_ = 0;
	}

HelloPacket::~HelloPacket()
	{
	delete other_tags_;
	other_tags_ = 0;
	delete pad_;
	pad_ = 0;
	delete sni_;
	sni_ = 0;
	delete stk_;
	stk_ = 0;
	delete sno_;
	sno_ = 0;
	delete ver_;
	ver_ = 0;
	delete ccs_;
	ccs_ = 0;
	delete nonc_;
	nonc_ = 0;
	delete mspc_;
	mspc_ = 0;
	delete aead_;
	aead_ = 0;
	delete uaid_;
	uaid_ = 0;
	delete scid_;
	scid_ = 0;
	delete tcid_;
	tcid_ = 0;
	delete pdmd_;
	pdmd_ = 0;
	delete smhl_;
	smhl_ = 0;
	delete icsl_;
	icsl_ = 0;
	delete ctim_;
	ctim_ = 0;
	delete nonp_;
	nonp_ = 0;
	delete pubs_;
	pubs_ = 0;
	delete mids_;
	mids_ = 0;
	delete scls_;
	scls_ = 0;
	delete kexs_;
	kexs_ = 0;
	delete xlct_;
	xlct_ = 0;
	delete csct_;
	csct_ = 0;
	delete copt_;
	copt_ = 0;
	delete ccrt_;
	ccrt_ = 0;
	delete irtt_;
	irtt_ = 0;
	delete cetv_;
	cetv_ = 0;
	delete cfcw_;
	cfcw_ = 0;
	delete sfcw_;
	sfcw_ = 0;
	}

int HelloPacket::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "HelloPacket:zero_pading"
	if ( (t_begin_of_data + 2) + (2) > t_end_of_data || (t_begin_of_data + 2) + (2) < (t_begin_of_data + 2) )
		{
		// Handle out-of-bound condition
		throw binpac::ExceptionOutOfBound("HelloPacket:zero_pading",
			(2) + (2), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "tag_number"
	tag_number_ = FixByteOrder(littleendian, *((uint16 const *) (t_begin_of_data)));
	// Evaluate 'let' and 'withinput' fields
	
	// Parse "zero_pading"
	zero_pading_ = FixByteOrder(t_byteorder, *((uint16 const *) ((t_begin_of_data + 2))));
	// Evaluate 'let' and 'withinput' fields
	
	// Parse "other_tags"
	other_tags_ = new TagFinder(tag_number());
	int t_other_tags__size;
	t_other_tags__size = other_tags_->Parse((t_begin_of_data + 4), t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_other_tags = (t_begin_of_data + 4) + (t_other_tags__size);
	BINPAC_ASSERT(t_dataptr_after_other_tags <= t_end_of_data);
	// Parse "pad"
	pad_ = new ExtractPAD(other_tags(), tag_number(), p_tag_offset());
	int t_pad__size;
	t_pad__size = pad_->Parse(t_dataptr_after_other_tags, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_pad = t_dataptr_after_other_tags + (t_pad__size);
	BINPAC_ASSERT(t_dataptr_after_pad <= t_end_of_data);
	// Parse "sni"
	sni_ = new ExtractSNI(other_tags(), tag_number(), p_tag_offset());
	int t_sni__size;
	t_sni__size = sni_->Parse(t_dataptr_after_pad, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_sni = t_dataptr_after_pad + (t_sni__size);
	BINPAC_ASSERT(t_dataptr_after_sni <= t_end_of_data);
	// Parse "stk"
	stk_ = new ExtractSTK(other_tags(), tag_number(), p_tag_offset());
	int t_stk__size;
	t_stk__size = stk_->Parse(t_dataptr_after_sni, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_stk = t_dataptr_after_sni + (t_stk__size);
	BINPAC_ASSERT(t_dataptr_after_stk <= t_end_of_data);
	// Parse "sno"
	sno_ = new ExtractSNO(other_tags(), tag_number(), p_tag_offset());
	int t_sno__size;
	t_sno__size = sno_->Parse(t_dataptr_after_stk, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_sno = t_dataptr_after_stk + (t_sno__size);
	BINPAC_ASSERT(t_dataptr_after_sno <= t_end_of_data);
	// Parse "ver"
	ver_ = new ExtractVER(other_tags(), tag_number(), p_tag_offset());
	int t_ver__size;
	t_ver__size = ver_->Parse(t_dataptr_after_sno, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_ver = t_dataptr_after_sno + (t_ver__size);
	BINPAC_ASSERT(t_dataptr_after_ver <= t_end_of_data);
	// Parse "ccs"
	ccs_ = new ExtractCCS(other_tags(), tag_number(), p_tag_offset());
	int t_ccs__size;
	t_ccs__size = ccs_->Parse(t_dataptr_after_ver, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_ccs = t_dataptr_after_ver + (t_ccs__size);
	BINPAC_ASSERT(t_dataptr_after_ccs <= t_end_of_data);
	// Parse "nonc"
	nonc_ = new ExtractNONC(other_tags(), tag_number(), p_tag_offset());
	int t_nonc__size;
	t_nonc__size = nonc_->Parse(t_dataptr_after_ccs, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_nonc = t_dataptr_after_ccs + (t_nonc__size);
	BINPAC_ASSERT(t_dataptr_after_nonc <= t_end_of_data);
	// Parse "mspc"
	mspc_ = new ExtractMSPC(other_tags(), tag_number(), p_tag_offset());
	int t_mspc__size;
	t_mspc__size = mspc_->Parse(t_dataptr_after_nonc, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_mspc = t_dataptr_after_nonc + (t_mspc__size);
	BINPAC_ASSERT(t_dataptr_after_mspc <= t_end_of_data);
	// Parse "aead"
	aead_ = new ExtractAEAD(other_tags(), tag_number(), p_tag_offset());
	int t_aead__size;
	t_aead__size = aead_->Parse(t_dataptr_after_mspc, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_aead = t_dataptr_after_mspc + (t_aead__size);
	BINPAC_ASSERT(t_dataptr_after_aead <= t_end_of_data);
	// Parse "uaid"
	uaid_ = new ExtractUAID(other_tags(), tag_number(), p_tag_offset());
	int t_uaid__size;
	t_uaid__size = uaid_->Parse(t_dataptr_after_aead, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_uaid = t_dataptr_after_aead + (t_uaid__size);
	BINPAC_ASSERT(t_dataptr_after_uaid <= t_end_of_data);
	// Parse "scid"
	scid_ = new ExtractSCID(other_tags(), tag_number(), p_tag_offset());
	int t_scid__size;
	t_scid__size = scid_->Parse(t_dataptr_after_uaid, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_scid = t_dataptr_after_uaid + (t_scid__size);
	BINPAC_ASSERT(t_dataptr_after_scid <= t_end_of_data);
	// Parse "tcid"
	tcid_ = new ExtractTCID(other_tags(), tag_number(), p_tag_offset());
	int t_tcid__size;
	t_tcid__size = tcid_->Parse(t_dataptr_after_scid, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_tcid = t_dataptr_after_scid + (t_tcid__size);
	BINPAC_ASSERT(t_dataptr_after_tcid <= t_end_of_data);
	// Parse "pdmd"
	pdmd_ = new ExtractPDMD(other_tags(), tag_number(), p_tag_offset());
	int t_pdmd__size;
	t_pdmd__size = pdmd_->Parse(t_dataptr_after_tcid, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_pdmd = t_dataptr_after_tcid + (t_pdmd__size);
	BINPAC_ASSERT(t_dataptr_after_pdmd <= t_end_of_data);
	// Parse "smhl"
	smhl_ = new ExtractSMHL(other_tags(), tag_number(), p_tag_offset());
	int t_smhl__size;
	t_smhl__size = smhl_->Parse(t_dataptr_after_pdmd, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_smhl = t_dataptr_after_pdmd + (t_smhl__size);
	BINPAC_ASSERT(t_dataptr_after_smhl <= t_end_of_data);
	// Parse "icsl"
	icsl_ = new ExtractICSL(other_tags(), tag_number(), p_tag_offset());
	int t_icsl__size;
	t_icsl__size = icsl_->Parse(t_dataptr_after_smhl, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_icsl = t_dataptr_after_smhl + (t_icsl__size);
	BINPAC_ASSERT(t_dataptr_after_icsl <= t_end_of_data);
	// Parse "ctim"
	ctim_ = new ExtractCTIM(other_tags(), tag_number(), p_tag_offset());
	int t_ctim__size;
	t_ctim__size = ctim_->Parse(t_dataptr_after_icsl, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_ctim = t_dataptr_after_icsl + (t_ctim__size);
	BINPAC_ASSERT(t_dataptr_after_ctim <= t_end_of_data);
	// Parse "nonp"
	nonp_ = new ExtractNONP(other_tags(), tag_number(), p_tag_offset());
	int t_nonp__size;
	t_nonp__size = nonp_->Parse(t_dataptr_after_ctim, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_nonp = t_dataptr_after_ctim + (t_nonp__size);
	BINPAC_ASSERT(t_dataptr_after_nonp <= t_end_of_data);
	// Parse "pubs"
	pubs_ = new ExtractPUBS(other_tags(), tag_number(), p_tag_offset());
	int t_pubs__size;
	t_pubs__size = pubs_->Parse(t_dataptr_after_nonp, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_pubs = t_dataptr_after_nonp + (t_pubs__size);
	BINPAC_ASSERT(t_dataptr_after_pubs <= t_end_of_data);
	// Parse "mids"
	mids_ = new ExtractMIDS(other_tags(), tag_number(), p_tag_offset());
	int t_mids__size;
	t_mids__size = mids_->Parse(t_dataptr_after_pubs, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_mids = t_dataptr_after_pubs + (t_mids__size);
	BINPAC_ASSERT(t_dataptr_after_mids <= t_end_of_data);
	// Parse "scls"
	scls_ = new ExtractSCLS(other_tags(), tag_number(), p_tag_offset());
	int t_scls__size;
	t_scls__size = scls_->Parse(t_dataptr_after_mids, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_scls = t_dataptr_after_mids + (t_scls__size);
	BINPAC_ASSERT(t_dataptr_after_scls <= t_end_of_data);
	// Parse "kexs"
	kexs_ = new ExtractKEXS(other_tags(), tag_number(), p_tag_offset());
	int t_kexs__size;
	t_kexs__size = kexs_->Parse(t_dataptr_after_scls, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_kexs = t_dataptr_after_scls + (t_kexs__size);
	BINPAC_ASSERT(t_dataptr_after_kexs <= t_end_of_data);
	// Parse "xlct"
	xlct_ = new ExtractXLCT(other_tags(), tag_number(), p_tag_offset());
	int t_xlct__size;
	t_xlct__size = xlct_->Parse(t_dataptr_after_kexs, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_xlct = t_dataptr_after_kexs + (t_xlct__size);
	BINPAC_ASSERT(t_dataptr_after_xlct <= t_end_of_data);
	// Parse "csct"
	csct_ = new ExtractCSCT(other_tags(), tag_number(), p_tag_offset());
	int t_csct__size;
	t_csct__size = csct_->Parse(t_dataptr_after_xlct, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_csct = t_dataptr_after_xlct + (t_csct__size);
	BINPAC_ASSERT(t_dataptr_after_csct <= t_end_of_data);
	// Parse "copt"
	copt_ = new ExtractCOPT(other_tags(), tag_number(), p_tag_offset());
	int t_copt__size;
	t_copt__size = copt_->Parse(t_dataptr_after_csct, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_copt = t_dataptr_after_csct + (t_copt__size);
	BINPAC_ASSERT(t_dataptr_after_copt <= t_end_of_data);
	// Parse "ccrt"
	ccrt_ = new ExtractCCRT(other_tags(), tag_number(), p_tag_offset());
	int t_ccrt__size;
	t_ccrt__size = ccrt_->Parse(t_dataptr_after_copt, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_ccrt = t_dataptr_after_copt + (t_ccrt__size);
	BINPAC_ASSERT(t_dataptr_after_ccrt <= t_end_of_data);
	// Parse "irtt"
	irtt_ = new ExtractIRTT(other_tags(), tag_number(), p_tag_offset());
	int t_irtt__size;
	t_irtt__size = irtt_->Parse(t_dataptr_after_ccrt, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_irtt = t_dataptr_after_ccrt + (t_irtt__size);
	BINPAC_ASSERT(t_dataptr_after_irtt <= t_end_of_data);
	// Parse "cetv"
	cetv_ = new ExtractCETV(other_tags(), tag_number(), p_tag_offset());
	int t_cetv__size;
	t_cetv__size = cetv_->Parse(t_dataptr_after_irtt, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_cetv = t_dataptr_after_irtt + (t_cetv__size);
	BINPAC_ASSERT(t_dataptr_after_cetv <= t_end_of_data);
	// Parse "cfcw"
	cfcw_ = new ExtractCFCW(other_tags(), tag_number(), p_tag_offset());
	int t_cfcw__size;
	t_cfcw__size = cfcw_->Parse(t_dataptr_after_cetv, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_cfcw = t_dataptr_after_cetv + (t_cfcw__size);
	BINPAC_ASSERT(t_dataptr_after_cfcw <= t_end_of_data);
	// Parse "sfcw"
	sfcw_ = new ExtractSFCW(other_tags(), tag_number(), p_tag_offset());
	int t_sfcw__size;
	t_sfcw__size = sfcw_->Parse(t_dataptr_after_cfcw, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	int t_HelloPacket__size;
	const_byteptr const t_dataptr_after_sfcw = t_dataptr_after_cfcw + (t_sfcw__size);
	BINPAC_ASSERT(t_dataptr_after_sfcw <= t_end_of_data);
	t_HelloPacket__size = t_dataptr_after_sfcw - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_HelloPacket__size) <= t_end_of_data);
	return t_HelloPacket__size;
	}

RejPacket::RejPacket(PublicFlags * flags, bool is_orig)
	{
	tag_number_ = 0;
	zero_pading_ = 0;
	other_tags_ = 0;
	stk_ = 0;
	sno_ = 0;
	svid_ = 0;
	prof_ = 0;
	scfg_ = 0;
	rrej_ = 0;
	sttl_ = 0;
	csct_ = 0;
	flags_ = flags;
	is_orig_ = is_orig;
	p_tag_offset_ = 0;
	}

RejPacket::~RejPacket()
	{
	delete other_tags_;
	other_tags_ = 0;
	delete stk_;
	stk_ = 0;
	delete sno_;
	sno_ = 0;
	delete svid_;
	svid_ = 0;
	delete prof_;
	prof_ = 0;
	delete scfg_;
	scfg_ = 0;
	delete rrej_;
	rrej_ = 0;
	delete sttl_;
	sttl_ = 0;
	delete csct_;
	csct_ = 0;
	}

int RejPacket::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "RejPacket:zero_pading"
	if ( (t_begin_of_data + 2) + (2) > t_end_of_data || (t_begin_of_data + 2) + (2) < (t_begin_of_data + 2) )
		{
		// Handle out-of-bound condition
		throw binpac::ExceptionOutOfBound("RejPacket:zero_pading",
			(2) + (2), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "tag_number"
	tag_number_ = FixByteOrder(littleendian, *((uint16 const *) (t_begin_of_data)));
	// Evaluate 'let' and 'withinput' fields
	
	// Parse "zero_pading"
	zero_pading_ = FixByteOrder(t_byteorder, *((uint16 const *) ((t_begin_of_data + 2))));
	// Evaluate 'let' and 'withinput' fields
	
	// Parse "other_tags"
	other_tags_ = new TagFinder(tag_number());
	int t_other_tags__size;
	t_other_tags__size = other_tags_->Parse((t_begin_of_data + 4), t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_other_tags = (t_begin_of_data + 4) + (t_other_tags__size);
	BINPAC_ASSERT(t_dataptr_after_other_tags <= t_end_of_data);
	// Parse "stk"
	stk_ = new ExtractSTK(other_tags(), tag_number(), p_tag_offset());
	int t_stk__size;
	t_stk__size = stk_->Parse(t_dataptr_after_other_tags, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_stk = t_dataptr_after_other_tags + (t_stk__size);
	BINPAC_ASSERT(t_dataptr_after_stk <= t_end_of_data);
	// Parse "sno"
	sno_ = new ExtractSNO(other_tags(), tag_number(), p_tag_offset());
	int t_sno__size;
	t_sno__size = sno_->Parse(t_dataptr_after_stk, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_sno = t_dataptr_after_stk + (t_sno__size);
	BINPAC_ASSERT(t_dataptr_after_sno <= t_end_of_data);
	// Parse "svid"
	svid_ = new ExtractSVID(other_tags(), tag_number(), p_tag_offset());
	int t_svid__size;
	t_svid__size = svid_->Parse(t_dataptr_after_sno, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_svid = t_dataptr_after_sno + (t_svid__size);
	BINPAC_ASSERT(t_dataptr_after_svid <= t_end_of_data);
	// Parse "prof"
	prof_ = new ExtractPROF(other_tags(), tag_number(), p_tag_offset());
	int t_prof__size;
	t_prof__size = prof_->Parse(t_dataptr_after_svid, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_prof = t_dataptr_after_svid + (t_prof__size);
	BINPAC_ASSERT(t_dataptr_after_prof <= t_end_of_data);
	// Parse "scfg"
	scfg_ = new ExtractSCFG(other_tags(), tag_number(), p_tag_offset());
	int t_scfg__size;
	t_scfg__size = scfg_->Parse(t_dataptr_after_prof, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_scfg = t_dataptr_after_prof + (t_scfg__size);
	BINPAC_ASSERT(t_dataptr_after_scfg <= t_end_of_data);
	// Parse "rrej"
	rrej_ = new ExtractRREJ(other_tags(), tag_number(), p_tag_offset());
	int t_rrej__size;
	t_rrej__size = rrej_->Parse(t_dataptr_after_scfg, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_rrej = t_dataptr_after_scfg + (t_rrej__size);
	BINPAC_ASSERT(t_dataptr_after_rrej <= t_end_of_data);
	// Parse "sttl"
	sttl_ = new ExtractSTTL(other_tags(), tag_number(), p_tag_offset());
	int t_sttl__size;
	t_sttl__size = sttl_->Parse(t_dataptr_after_rrej, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_sttl = t_dataptr_after_rrej + (t_sttl__size);
	BINPAC_ASSERT(t_dataptr_after_sttl <= t_end_of_data);
	// Parse "csct"
	csct_ = new ExtractCSCT(other_tags(), tag_number(), p_tag_offset());
	int t_csct__size;
	t_csct__size = csct_->Parse(t_dataptr_after_sttl, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	int t_RejPacket__size;
	const_byteptr const t_dataptr_after_csct = t_dataptr_after_sttl + (t_csct__size);
	BINPAC_ASSERT(t_dataptr_after_csct <= t_end_of_data);
	t_RejPacket__size = t_dataptr_after_csct - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_RejPacket__size) <= t_end_of_data);
	return t_RejPacket__size;
	}

RejPacketSCFG::RejPacketSCFG()
	{
	tag_number_ = 0;
	other_tags_ = 0;
	ver_ = 0;
	aead_ = 0;
	scid_ = 0;
	pdmd_ = 0;
	tbkp_ = 0;
	pubs_ = 0;
	kexs_ = 0;
	obit_ = 0;
	expy_ = 0;
	p_tag_offset_ = 0;
	}

RejPacketSCFG::~RejPacketSCFG()
	{
	tag_.free();
	delete other_tags_;
	other_tags_ = 0;
	delete ver_;
	ver_ = 0;
	delete aead_;
	aead_ = 0;
	delete scid_;
	scid_ = 0;
	delete pdmd_;
	pdmd_ = 0;
	delete tbkp_;
	tbkp_ = 0;
	delete pubs_;
	pubs_ = 0;
	delete kexs_;
	kexs_ = 0;
	delete obit_;
	obit_ = 0;
	delete expy_;
	expy_ = 0;
	}

int RejPacketSCFG::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "tag"
	// Checking out-of-bound for "RejPacketSCFG:tag"
	if ( t_begin_of_data + (4) > t_end_of_data || t_begin_of_data + (4) < t_begin_of_data )
		{
		// Handle out-of-bound condition
		throw binpac::ExceptionOutOfBound("RejPacketSCFG:tag",
			(0) + (4), 
			(t_end_of_data) - (t_begin_of_data));
		}
	{
	// Setting t_end_of_data with &length
	const_byteptr t_end_of_data = t_begin_of_data + 4;
	int t_tag_string_length;
	t_tag_string_length = 4;
	int t_tag__size;
	t_tag__size = t_tag_string_length;
	tag_.init(t_begin_of_data, t_tag_string_length);
	// Evaluate 'let' and 'withinput' fields
	}
	
	const_byteptr const t_dataptr_after_tag = t_begin_of_data + (4);
	BINPAC_ASSERT(t_dataptr_after_tag <= t_end_of_data);
	// Checking out-of-bound for "RejPacketSCFG:tag_number"
	if ( t_dataptr_after_tag + (4) > t_end_of_data || t_dataptr_after_tag + (4) < t_dataptr_after_tag )
		{
		// Handle out-of-bound condition
		throw binpac::ExceptionOutOfBound("RejPacketSCFG:tag_number",
			((t_dataptr_after_tag - t_begin_of_data)) + (4), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "tag_number"
	tag_number_ = FixByteOrder(littleendian, *((uint32 const *) (t_dataptr_after_tag)));
	// Evaluate 'let' and 'withinput' fields
	
	// Parse "other_tags"
	other_tags_ = new TagFinder(tag_number());
	int t_other_tags__size;
	t_other_tags__size = other_tags_->Parse((t_dataptr_after_tag + 4), t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_other_tags = (t_dataptr_after_tag + 4) + (t_other_tags__size);
	BINPAC_ASSERT(t_dataptr_after_other_tags <= t_end_of_data);
	// Parse "ver"
	ver_ = new ExtractVER(other_tags(), tag_number(), p_tag_offset());
	int t_ver__size;
	t_ver__size = ver_->Parse(t_dataptr_after_other_tags, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_ver = t_dataptr_after_other_tags + (t_ver__size);
	BINPAC_ASSERT(t_dataptr_after_ver <= t_end_of_data);
	// Parse "aead"
	aead_ = new ExtractAEAD(other_tags(), tag_number(), p_tag_offset());
	int t_aead__size;
	t_aead__size = aead_->Parse(t_dataptr_after_ver, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_aead = t_dataptr_after_ver + (t_aead__size);
	BINPAC_ASSERT(t_dataptr_after_aead <= t_end_of_data);
	// Parse "scid"
	scid_ = new ExtractSCID(other_tags(), tag_number(), p_tag_offset());
	int t_scid__size;
	t_scid__size = scid_->Parse(t_dataptr_after_aead, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_scid = t_dataptr_after_aead + (t_scid__size);
	BINPAC_ASSERT(t_dataptr_after_scid <= t_end_of_data);
	// Parse "pdmd"
	pdmd_ = new ExtractPDMD(other_tags(), tag_number(), p_tag_offset());
	int t_pdmd__size;
	t_pdmd__size = pdmd_->Parse(t_dataptr_after_scid, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_pdmd = t_dataptr_after_scid + (t_pdmd__size);
	BINPAC_ASSERT(t_dataptr_after_pdmd <= t_end_of_data);
	// Parse "tbkp"
	tbkp_ = new ExtractTBKP(other_tags(), tag_number(), p_tag_offset());
	int t_tbkp__size;
	t_tbkp__size = tbkp_->Parse(t_dataptr_after_pdmd, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_tbkp = t_dataptr_after_pdmd + (t_tbkp__size);
	BINPAC_ASSERT(t_dataptr_after_tbkp <= t_end_of_data);
	// Parse "pubs"
	pubs_ = new ExtractPUBS(other_tags(), tag_number(), p_tag_offset());
	int t_pubs__size;
	t_pubs__size = pubs_->Parse(t_dataptr_after_tbkp, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_pubs = t_dataptr_after_tbkp + (t_pubs__size);
	BINPAC_ASSERT(t_dataptr_after_pubs <= t_end_of_data);
	// Parse "kexs"
	kexs_ = new ExtractKEXS(other_tags(), tag_number(), p_tag_offset());
	int t_kexs__size;
	t_kexs__size = kexs_->Parse(t_dataptr_after_pubs, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_kexs = t_dataptr_after_pubs + (t_kexs__size);
	BINPAC_ASSERT(t_dataptr_after_kexs <= t_end_of_data);
	// Parse "obit"
	obit_ = new ExtractOBIT(other_tags(), tag_number(), p_tag_offset());
	int t_obit__size;
	t_obit__size = obit_->Parse(t_dataptr_after_kexs, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_obit = t_dataptr_after_kexs + (t_obit__size);
	BINPAC_ASSERT(t_dataptr_after_obit <= t_end_of_data);
	// Parse "expy"
	expy_ = new ExtractEXPY(other_tags(), tag_number(), p_tag_offset());
	int t_expy__size;
	t_expy__size = expy_->Parse(t_dataptr_after_obit, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	int t_RejPacketSCFG__size;
	const_byteptr const t_dataptr_after_expy = t_dataptr_after_obit + (t_expy__size);
	BINPAC_ASSERT(t_dataptr_after_expy <= t_end_of_data);
	t_RejPacketSCFG__size = t_dataptr_after_expy - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_RejPacketSCFG__size) <= t_end_of_data);
	return t_RejPacketSCFG__size;
	}

ExtractPAD::ExtractPAD(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset)
	{
	exists_case_index_ = -1;
	other_tags_ = other_tags;
	tag_number_ = tag_number;
	p_tag_offset_ = p_tag_offset;
	}

ExtractPAD::~ExtractPAD()
	{
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Clean up "collect"
			{
			collect_.free();
			}
			break;
		case ((bool) 0):
			// Clean up "blank"
			{
			}
			break;
		}
	}

int ExtractPAD::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "exists"
	int t_exists__size;
	exists_case_index_ = other_tags()->pad_check();
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Parse "collect"
			{
			int t_collect__size;
			t_collect__size =  ( find_pad_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// Checking out-of-bound for "ExtractPAD:collect"
			if ( t_begin_of_data + (t_collect__size) > t_end_of_data || t_begin_of_data + (t_collect__size) < t_begin_of_data )
				{
				// Handle out-of-bound condition
				throw binpac::ExceptionOutOfBound("ExtractPAD:collect",
					(0) + (t_collect__size), 
					(t_end_of_data) - (t_begin_of_data));
				}
			{
			// Setting t_end_of_data with &length
			const_byteptr t_end_of_data = t_begin_of_data + t_collect__size;
			int t_collect_string_length;
			t_collect_string_length =  ( find_pad_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// check for negative sizes
			if ( t_collect_string_length < 0 )
			throw binpac::ExceptionInvalidStringLength("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:266", t_collect_string_length);
			collect_.init(t_begin_of_data, t_collect_string_length);
			// Evaluate 'let' and 'withinput' fields
			}
			t_exists__size = t_collect__size;
			}
			break;
		case ((bool) 0):
			// Parse "blank"
			{
			// Evaluate 'let' and 'withinput' fields
			t_exists__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("ExtractPAD", (int64)exists_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_ExtractPAD__size;
	const_byteptr const t_dataptr_after_exists = t_begin_of_data + (t_exists__size);
	BINPAC_ASSERT(t_dataptr_after_exists <= t_end_of_data);
	t_ExtractPAD__size = t_dataptr_after_exists - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_ExtractPAD__size) <= t_end_of_data);
	return t_ExtractPAD__size;
	}

ExtractSNI::ExtractSNI(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset)
	{
	exists_case_index_ = -1;
	other_tags_ = other_tags;
	tag_number_ = tag_number;
	p_tag_offset_ = p_tag_offset;
	}

ExtractSNI::~ExtractSNI()
	{
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Clean up "collect"
			{
			collect_.free();
			}
			break;
		case ((bool) 0):
			// Clean up "blank"
			{
			}
			break;
		}
	}

int ExtractSNI::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "exists"
	int t_exists__size;
	exists_case_index_ = other_tags()->sni_check();
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Parse "collect"
			{
			int t_collect__size;
			t_collect__size =  ( find_sni_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// Checking out-of-bound for "ExtractSNI:collect"
			if ( t_begin_of_data + (t_collect__size) > t_end_of_data || t_begin_of_data + (t_collect__size) < t_begin_of_data )
				{
				// Handle out-of-bound condition
				throw binpac::ExceptionOutOfBound("ExtractSNI:collect",
					(0) + (t_collect__size), 
					(t_end_of_data) - (t_begin_of_data));
				}
			{
			// Setting t_end_of_data with &length
			const_byteptr t_end_of_data = t_begin_of_data + t_collect__size;
			int t_collect_string_length;
			t_collect_string_length =  ( find_sni_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// check for negative sizes
			if ( t_collect_string_length < 0 )
			throw binpac::ExceptionInvalidStringLength("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:273", t_collect_string_length);
			collect_.init(t_begin_of_data, t_collect_string_length);
			// Evaluate 'let' and 'withinput' fields
			}
			t_exists__size = t_collect__size;
			}
			break;
		case ((bool) 0):
			// Parse "blank"
			{
			// Evaluate 'let' and 'withinput' fields
			t_exists__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("ExtractSNI", (int64)exists_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_ExtractSNI__size;
	const_byteptr const t_dataptr_after_exists = t_begin_of_data + (t_exists__size);
	BINPAC_ASSERT(t_dataptr_after_exists <= t_end_of_data);
	t_ExtractSNI__size = t_dataptr_after_exists - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_ExtractSNI__size) <= t_end_of_data);
	return t_ExtractSNI__size;
	}

ExtractSTK::ExtractSTK(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset)
	{
	exists_case_index_ = -1;
	other_tags_ = other_tags;
	tag_number_ = tag_number;
	p_tag_offset_ = p_tag_offset;
	}

ExtractSTK::~ExtractSTK()
	{
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Clean up "collect"
			{
			collect_.free();
			}
			break;
		case ((bool) 0):
			// Clean up "blank"
			{
			}
			break;
		}
	}

int ExtractSTK::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "exists"
	int t_exists__size;
	exists_case_index_ = other_tags()->stk_check();
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Parse "collect"
			{
			int t_collect__size;
			t_collect__size =  ( find_stk_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// Checking out-of-bound for "ExtractSTK:collect"
			if ( t_begin_of_data + (t_collect__size) > t_end_of_data || t_begin_of_data + (t_collect__size) < t_begin_of_data )
				{
				// Handle out-of-bound condition
				throw binpac::ExceptionOutOfBound("ExtractSTK:collect",
					(0) + (t_collect__size), 
					(t_end_of_data) - (t_begin_of_data));
				}
			{
			// Setting t_end_of_data with &length
			const_byteptr t_end_of_data = t_begin_of_data + t_collect__size;
			int t_collect_string_length;
			t_collect_string_length =  ( find_stk_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// check for negative sizes
			if ( t_collect_string_length < 0 )
			throw binpac::ExceptionInvalidStringLength("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:280", t_collect_string_length);
			collect_.init(t_begin_of_data, t_collect_string_length);
			// Evaluate 'let' and 'withinput' fields
			}
			t_exists__size = t_collect__size;
			}
			break;
		case ((bool) 0):
			// Parse "blank"
			{
			// Evaluate 'let' and 'withinput' fields
			t_exists__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("ExtractSTK", (int64)exists_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_ExtractSTK__size;
	const_byteptr const t_dataptr_after_exists = t_begin_of_data + (t_exists__size);
	BINPAC_ASSERT(t_dataptr_after_exists <= t_end_of_data);
	t_ExtractSTK__size = t_dataptr_after_exists - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_ExtractSTK__size) <= t_end_of_data);
	return t_ExtractSTK__size;
	}

ExtractSNO::ExtractSNO(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset)
	{
	exists_case_index_ = -1;
	other_tags_ = other_tags;
	tag_number_ = tag_number;
	p_tag_offset_ = p_tag_offset;
	}

ExtractSNO::~ExtractSNO()
	{
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Clean up "collect"
			{
			collect_.free();
			}
			break;
		case ((bool) 0):
			// Clean up "blank"
			{
			}
			break;
		}
	}

int ExtractSNO::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "exists"
	int t_exists__size;
	exists_case_index_ = other_tags()->sno_check();
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Parse "collect"
			{
			int t_collect__size;
			t_collect__size =  ( find_sno_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// Checking out-of-bound for "ExtractSNO:collect"
			if ( t_begin_of_data + (t_collect__size) > t_end_of_data || t_begin_of_data + (t_collect__size) < t_begin_of_data )
				{
				// Handle out-of-bound condition
				throw binpac::ExceptionOutOfBound("ExtractSNO:collect",
					(0) + (t_collect__size), 
					(t_end_of_data) - (t_begin_of_data));
				}
			{
			// Setting t_end_of_data with &length
			const_byteptr t_end_of_data = t_begin_of_data + t_collect__size;
			int t_collect_string_length;
			t_collect_string_length =  ( find_sno_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// check for negative sizes
			if ( t_collect_string_length < 0 )
			throw binpac::ExceptionInvalidStringLength("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:287", t_collect_string_length);
			collect_.init(t_begin_of_data, t_collect_string_length);
			// Evaluate 'let' and 'withinput' fields
			}
			t_exists__size = t_collect__size;
			}
			break;
		case ((bool) 0):
			// Parse "blank"
			{
			// Evaluate 'let' and 'withinput' fields
			t_exists__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("ExtractSNO", (int64)exists_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_ExtractSNO__size;
	const_byteptr const t_dataptr_after_exists = t_begin_of_data + (t_exists__size);
	BINPAC_ASSERT(t_dataptr_after_exists <= t_end_of_data);
	t_ExtractSNO__size = t_dataptr_after_exists - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_ExtractSNO__size) <= t_end_of_data);
	return t_ExtractSNO__size;
	}

ExtractVER::ExtractVER(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset)
	{
	exists_case_index_ = -1;
	other_tags_ = other_tags;
	tag_number_ = tag_number;
	p_tag_offset_ = p_tag_offset;
	}

ExtractVER::~ExtractVER()
	{
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Clean up "collect"
			{
			collect_.free();
			}
			break;
		case ((bool) 0):
			// Clean up "blank"
			{
			}
			break;
		}
	}

int ExtractVER::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "exists"
	int t_exists__size;
	exists_case_index_ = other_tags()->ver_check();
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Parse "collect"
			{
			int t_collect__size;
			t_collect__size =  ( find_ver_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// Checking out-of-bound for "ExtractVER:collect"
			if ( t_begin_of_data + (t_collect__size) > t_end_of_data || t_begin_of_data + (t_collect__size) < t_begin_of_data )
				{
				// Handle out-of-bound condition
				throw binpac::ExceptionOutOfBound("ExtractVER:collect",
					(0) + (t_collect__size), 
					(t_end_of_data) - (t_begin_of_data));
				}
			{
			// Setting t_end_of_data with &length
			const_byteptr t_end_of_data = t_begin_of_data + t_collect__size;
			int t_collect_string_length;
			t_collect_string_length =  ( find_ver_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// check for negative sizes
			if ( t_collect_string_length < 0 )
			throw binpac::ExceptionInvalidStringLength("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:294", t_collect_string_length);
			collect_.init(t_begin_of_data, t_collect_string_length);
			// Evaluate 'let' and 'withinput' fields
			}
			t_exists__size = t_collect__size;
			}
			break;
		case ((bool) 0):
			// Parse "blank"
			{
			// Evaluate 'let' and 'withinput' fields
			t_exists__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("ExtractVER", (int64)exists_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_ExtractVER__size;
	const_byteptr const t_dataptr_after_exists = t_begin_of_data + (t_exists__size);
	BINPAC_ASSERT(t_dataptr_after_exists <= t_end_of_data);
	t_ExtractVER__size = t_dataptr_after_exists - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_ExtractVER__size) <= t_end_of_data);
	return t_ExtractVER__size;
	}

ExtractCCS::ExtractCCS(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset)
	{
	exists_case_index_ = -1;
	other_tags_ = other_tags;
	tag_number_ = tag_number;
	p_tag_offset_ = p_tag_offset;
	}

ExtractCCS::~ExtractCCS()
	{
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Clean up "collect"
			{
			collect_.free();
			}
			break;
		case ((bool) 0):
			// Clean up "blank"
			{
			}
			break;
		}
	}

int ExtractCCS::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "exists"
	int t_exists__size;
	exists_case_index_ = other_tags()->ccs_check();
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Parse "collect"
			{
			int t_collect__size;
			t_collect__size =  ( find_ccs_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// Checking out-of-bound for "ExtractCCS:collect"
			if ( t_begin_of_data + (t_collect__size) > t_end_of_data || t_begin_of_data + (t_collect__size) < t_begin_of_data )
				{
				// Handle out-of-bound condition
				throw binpac::ExceptionOutOfBound("ExtractCCS:collect",
					(0) + (t_collect__size), 
					(t_end_of_data) - (t_begin_of_data));
				}
			{
			// Setting t_end_of_data with &length
			const_byteptr t_end_of_data = t_begin_of_data + t_collect__size;
			int t_collect_string_length;
			t_collect_string_length =  ( find_ccs_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// check for negative sizes
			if ( t_collect_string_length < 0 )
			throw binpac::ExceptionInvalidStringLength("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:302", t_collect_string_length);
			collect_.init(t_begin_of_data, t_collect_string_length);
			// Evaluate 'let' and 'withinput' fields
			}
			t_exists__size = t_collect__size;
			}
			break;
		case ((bool) 0):
			// Parse "blank"
			{
			// Evaluate 'let' and 'withinput' fields
			t_exists__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("ExtractCCS", (int64)exists_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_ExtractCCS__size;
	const_byteptr const t_dataptr_after_exists = t_begin_of_data + (t_exists__size);
	BINPAC_ASSERT(t_dataptr_after_exists <= t_end_of_data);
	t_ExtractCCS__size = t_dataptr_after_exists - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_ExtractCCS__size) <= t_end_of_data);
	return t_ExtractCCS__size;
	}

ExtractCRT::ExtractCRT(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset)
	{
	exists_case_index_ = -1;
	other_tags_ = other_tags;
	tag_number_ = tag_number;
	p_tag_offset_ = p_tag_offset;
	}

ExtractCRT::~ExtractCRT()
	{
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Clean up "collect"
			{
			collect_.free();
			}
			break;
		case ((bool) 0):
			// Clean up "blank"
			{
			}
			break;
		}
	}

int ExtractCRT::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "exists"
	int t_exists__size;
	exists_case_index_ = other_tags()->crt_check();
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Parse "collect"
			{
			int t_collect__size;
			t_collect__size =  ( find_crt_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// Checking out-of-bound for "ExtractCRT:collect"
			if ( t_begin_of_data + (t_collect__size) > t_end_of_data || t_begin_of_data + (t_collect__size) < t_begin_of_data )
				{
				// Handle out-of-bound condition
				throw binpac::ExceptionOutOfBound("ExtractCRT:collect",
					(0) + (t_collect__size), 
					(t_end_of_data) - (t_begin_of_data));
				}
			{
			// Setting t_end_of_data with &length
			const_byteptr t_end_of_data = t_begin_of_data + t_collect__size;
			int t_collect_string_length;
			t_collect_string_length =  ( find_crt_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// check for negative sizes
			if ( t_collect_string_length < 0 )
			throw binpac::ExceptionInvalidStringLength("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:309", t_collect_string_length);
			collect_.init(t_begin_of_data, t_collect_string_length);
			// Evaluate 'let' and 'withinput' fields
			}
			t_exists__size = t_collect__size;
			}
			break;
		case ((bool) 0):
			// Parse "blank"
			{
			// Evaluate 'let' and 'withinput' fields
			t_exists__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("ExtractCRT", (int64)exists_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_ExtractCRT__size;
	const_byteptr const t_dataptr_after_exists = t_begin_of_data + (t_exists__size);
	BINPAC_ASSERT(t_dataptr_after_exists <= t_end_of_data);
	t_ExtractCRT__size = t_dataptr_after_exists - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_ExtractCRT__size) <= t_end_of_data);
	return t_ExtractCRT__size;
	}

ExtractNONC::ExtractNONC(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset)
	{
	exists_case_index_ = -1;
	other_tags_ = other_tags;
	tag_number_ = tag_number;
	p_tag_offset_ = p_tag_offset;
	}

ExtractNONC::~ExtractNONC()
	{
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Clean up "collect"
			{
			collect_.free();
			}
			break;
		case ((bool) 0):
			// Clean up "blank"
			{
			}
			break;
		}
	}

int ExtractNONC::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "exists"
	int t_exists__size;
	exists_case_index_ = other_tags()->nonc_check();
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Parse "collect"
			{
			int t_collect__size;
			t_collect__size =  ( find_nonc_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// Checking out-of-bound for "ExtractNONC:collect"
			if ( t_begin_of_data + (t_collect__size) > t_end_of_data || t_begin_of_data + (t_collect__size) < t_begin_of_data )
				{
				// Handle out-of-bound condition
				throw binpac::ExceptionOutOfBound("ExtractNONC:collect",
					(0) + (t_collect__size), 
					(t_end_of_data) - (t_begin_of_data));
				}
			{
			// Setting t_end_of_data with &length
			const_byteptr t_end_of_data = t_begin_of_data + t_collect__size;
			int t_collect_string_length;
			t_collect_string_length =  ( find_nonc_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// check for negative sizes
			if ( t_collect_string_length < 0 )
			throw binpac::ExceptionInvalidStringLength("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:316", t_collect_string_length);
			collect_.init(t_begin_of_data, t_collect_string_length);
			// Evaluate 'let' and 'withinput' fields
			}
			t_exists__size = t_collect__size;
			}
			break;
		case ((bool) 0):
			// Parse "blank"
			{
			// Evaluate 'let' and 'withinput' fields
			t_exists__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("ExtractNONC", (int64)exists_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_ExtractNONC__size;
	const_byteptr const t_dataptr_after_exists = t_begin_of_data + (t_exists__size);
	BINPAC_ASSERT(t_dataptr_after_exists <= t_end_of_data);
	t_ExtractNONC__size = t_dataptr_after_exists - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_ExtractNONC__size) <= t_end_of_data);
	return t_ExtractNONC__size;
	}

ExtractMSPC::ExtractMSPC(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset)
	{
	exists_case_index_ = -1;
	other_tags_ = other_tags;
	tag_number_ = tag_number;
	p_tag_offset_ = p_tag_offset;
	}

ExtractMSPC::~ExtractMSPC()
	{
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Clean up "collect"
			{
			collect_.free();
			}
			break;
		case ((bool) 0):
			// Clean up "blank"
			{
			}
			break;
		}
	}

int ExtractMSPC::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "exists"
	int t_exists__size;
	exists_case_index_ = other_tags()->mspc_check();
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Parse "collect"
			{
			int t_collect__size;
			t_collect__size =  ( find_mspc_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// Checking out-of-bound for "ExtractMSPC:collect"
			if ( t_begin_of_data + (t_collect__size) > t_end_of_data || t_begin_of_data + (t_collect__size) < t_begin_of_data )
				{
				// Handle out-of-bound condition
				throw binpac::ExceptionOutOfBound("ExtractMSPC:collect",
					(0) + (t_collect__size), 
					(t_end_of_data) - (t_begin_of_data));
				}
			{
			// Setting t_end_of_data with &length
			const_byteptr t_end_of_data = t_begin_of_data + t_collect__size;
			int t_collect_string_length;
			t_collect_string_length =  ( find_mspc_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// check for negative sizes
			if ( t_collect_string_length < 0 )
			throw binpac::ExceptionInvalidStringLength("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:323", t_collect_string_length);
			collect_.init(t_begin_of_data, t_collect_string_length);
			// Evaluate 'let' and 'withinput' fields
			}
			t_exists__size = t_collect__size;
			}
			break;
		case ((bool) 0):
			// Parse "blank"
			{
			// Evaluate 'let' and 'withinput' fields
			t_exists__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("ExtractMSPC", (int64)exists_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_ExtractMSPC__size;
	const_byteptr const t_dataptr_after_exists = t_begin_of_data + (t_exists__size);
	BINPAC_ASSERT(t_dataptr_after_exists <= t_end_of_data);
	t_ExtractMSPC__size = t_dataptr_after_exists - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_ExtractMSPC__size) <= t_end_of_data);
	return t_ExtractMSPC__size;
	}

ExtractAEAD::ExtractAEAD(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset)
	{
	exists_case_index_ = -1;
	other_tags_ = other_tags;
	tag_number_ = tag_number;
	p_tag_offset_ = p_tag_offset;
	}

ExtractAEAD::~ExtractAEAD()
	{
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Clean up "collect"
			{
			collect_.free();
			}
			break;
		case ((bool) 0):
			// Clean up "blank"
			{
			}
			break;
		}
	}

int ExtractAEAD::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "exists"
	int t_exists__size;
	exists_case_index_ = other_tags()->aead_check();
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Parse "collect"
			{
			int t_collect__size;
			t_collect__size =  ( find_aead_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// Checking out-of-bound for "ExtractAEAD:collect"
			if ( t_begin_of_data + (t_collect__size) > t_end_of_data || t_begin_of_data + (t_collect__size) < t_begin_of_data )
				{
				// Handle out-of-bound condition
				throw binpac::ExceptionOutOfBound("ExtractAEAD:collect",
					(0) + (t_collect__size), 
					(t_end_of_data) - (t_begin_of_data));
				}
			{
			// Setting t_end_of_data with &length
			const_byteptr t_end_of_data = t_begin_of_data + t_collect__size;
			int t_collect_string_length;
			t_collect_string_length =  ( find_aead_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// check for negative sizes
			if ( t_collect_string_length < 0 )
			throw binpac::ExceptionInvalidStringLength("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:330", t_collect_string_length);
			collect_.init(t_begin_of_data, t_collect_string_length);
			// Evaluate 'let' and 'withinput' fields
			}
			t_exists__size = t_collect__size;
			}
			break;
		case ((bool) 0):
			// Parse "blank"
			{
			// Evaluate 'let' and 'withinput' fields
			t_exists__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("ExtractAEAD", (int64)exists_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_ExtractAEAD__size;
	const_byteptr const t_dataptr_after_exists = t_begin_of_data + (t_exists__size);
	BINPAC_ASSERT(t_dataptr_after_exists <= t_end_of_data);
	t_ExtractAEAD__size = t_dataptr_after_exists - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_ExtractAEAD__size) <= t_end_of_data);
	return t_ExtractAEAD__size;
	}

ExtractUAID::ExtractUAID(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset)
	{
	exists_case_index_ = -1;
	other_tags_ = other_tags;
	tag_number_ = tag_number;
	p_tag_offset_ = p_tag_offset;
	}

ExtractUAID::~ExtractUAID()
	{
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Clean up "collect"
			{
			collect_.free();
			}
			break;
		case ((bool) 0):
			// Clean up "blank"
			{
			}
			break;
		}
	}

int ExtractUAID::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "exists"
	int t_exists__size;
	exists_case_index_ = other_tags()->uaid_check();
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Parse "collect"
			{
			int t_collect__size;
			t_collect__size =  ( find_uaid_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// Checking out-of-bound for "ExtractUAID:collect"
			if ( t_begin_of_data + (t_collect__size) > t_end_of_data || t_begin_of_data + (t_collect__size) < t_begin_of_data )
				{
				// Handle out-of-bound condition
				throw binpac::ExceptionOutOfBound("ExtractUAID:collect",
					(0) + (t_collect__size), 
					(t_end_of_data) - (t_begin_of_data));
				}
			{
			// Setting t_end_of_data with &length
			const_byteptr t_end_of_data = t_begin_of_data + t_collect__size;
			int t_collect_string_length;
			t_collect_string_length =  ( find_uaid_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// check for negative sizes
			if ( t_collect_string_length < 0 )
			throw binpac::ExceptionInvalidStringLength("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:337", t_collect_string_length);
			collect_.init(t_begin_of_data, t_collect_string_length);
			// Evaluate 'let' and 'withinput' fields
			}
			t_exists__size = t_collect__size;
			}
			break;
		case ((bool) 0):
			// Parse "blank"
			{
			// Evaluate 'let' and 'withinput' fields
			t_exists__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("ExtractUAID", (int64)exists_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_ExtractUAID__size;
	const_byteptr const t_dataptr_after_exists = t_begin_of_data + (t_exists__size);
	BINPAC_ASSERT(t_dataptr_after_exists <= t_end_of_data);
	t_ExtractUAID__size = t_dataptr_after_exists - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_ExtractUAID__size) <= t_end_of_data);
	return t_ExtractUAID__size;
	}

ExtractSCID::ExtractSCID(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset)
	{
	exists_case_index_ = -1;
	other_tags_ = other_tags;
	tag_number_ = tag_number;
	p_tag_offset_ = p_tag_offset;
	}

ExtractSCID::~ExtractSCID()
	{
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Clean up "collect"
			{
			collect_.free();
			}
			break;
		case ((bool) 0):
			// Clean up "blank"
			{
			}
			break;
		}
	}

int ExtractSCID::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "exists"
	int t_exists__size;
	exists_case_index_ = other_tags()->scid_check();
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Parse "collect"
			{
			int t_collect__size;
			t_collect__size =  ( find_scid_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// Checking out-of-bound for "ExtractSCID:collect"
			if ( t_begin_of_data + (t_collect__size) > t_end_of_data || t_begin_of_data + (t_collect__size) < t_begin_of_data )
				{
				// Handle out-of-bound condition
				throw binpac::ExceptionOutOfBound("ExtractSCID:collect",
					(0) + (t_collect__size), 
					(t_end_of_data) - (t_begin_of_data));
				}
			{
			// Setting t_end_of_data with &length
			const_byteptr t_end_of_data = t_begin_of_data + t_collect__size;
			int t_collect_string_length;
			t_collect_string_length =  ( find_scid_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// check for negative sizes
			if ( t_collect_string_length < 0 )
			throw binpac::ExceptionInvalidStringLength("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:344", t_collect_string_length);
			collect_.init(t_begin_of_data, t_collect_string_length);
			// Evaluate 'let' and 'withinput' fields
			}
			t_exists__size = t_collect__size;
			}
			break;
		case ((bool) 0):
			// Parse "blank"
			{
			// Evaluate 'let' and 'withinput' fields
			t_exists__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("ExtractSCID", (int64)exists_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_ExtractSCID__size;
	const_byteptr const t_dataptr_after_exists = t_begin_of_data + (t_exists__size);
	BINPAC_ASSERT(t_dataptr_after_exists <= t_end_of_data);
	t_ExtractSCID__size = t_dataptr_after_exists - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_ExtractSCID__size) <= t_end_of_data);
	return t_ExtractSCID__size;
	}

ExtractTCID::ExtractTCID(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset)
	{
	exists_case_index_ = -1;
	other_tags_ = other_tags;
	tag_number_ = tag_number;
	p_tag_offset_ = p_tag_offset;
	}

ExtractTCID::~ExtractTCID()
	{
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Clean up "collect"
			{
			collect_.free();
			}
			break;
		case ((bool) 0):
			// Clean up "blank"
			{
			}
			break;
		}
	}

int ExtractTCID::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "exists"
	int t_exists__size;
	exists_case_index_ = other_tags()->tcid_check();
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Parse "collect"
			{
			int t_collect__size;
			t_collect__size =  ( find_tcid_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// Checking out-of-bound for "ExtractTCID:collect"
			if ( t_begin_of_data + (t_collect__size) > t_end_of_data || t_begin_of_data + (t_collect__size) < t_begin_of_data )
				{
				// Handle out-of-bound condition
				throw binpac::ExceptionOutOfBound("ExtractTCID:collect",
					(0) + (t_collect__size), 
					(t_end_of_data) - (t_begin_of_data));
				}
			{
			// Setting t_end_of_data with &length
			const_byteptr t_end_of_data = t_begin_of_data + t_collect__size;
			int t_collect_string_length;
			t_collect_string_length =  ( find_tcid_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// check for negative sizes
			if ( t_collect_string_length < 0 )
			throw binpac::ExceptionInvalidStringLength("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:351", t_collect_string_length);
			collect_.init(t_begin_of_data, t_collect_string_length);
			// Evaluate 'let' and 'withinput' fields
			}
			t_exists__size = t_collect__size;
			}
			break;
		case ((bool) 0):
			// Parse "blank"
			{
			// Evaluate 'let' and 'withinput' fields
			t_exists__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("ExtractTCID", (int64)exists_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_ExtractTCID__size;
	const_byteptr const t_dataptr_after_exists = t_begin_of_data + (t_exists__size);
	BINPAC_ASSERT(t_dataptr_after_exists <= t_end_of_data);
	t_ExtractTCID__size = t_dataptr_after_exists - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_ExtractTCID__size) <= t_end_of_data);
	return t_ExtractTCID__size;
	}

ExtractPDMD::ExtractPDMD(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset)
	{
	exists_case_index_ = -1;
	other_tags_ = other_tags;
	tag_number_ = tag_number;
	p_tag_offset_ = p_tag_offset;
	}

ExtractPDMD::~ExtractPDMD()
	{
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Clean up "collect"
			{
			collect_.free();
			}
			break;
		case ((bool) 0):
			// Clean up "blank"
			{
			}
			break;
		}
	}

int ExtractPDMD::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "exists"
	int t_exists__size;
	exists_case_index_ = other_tags()->pdmd_check();
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Parse "collect"
			{
			int t_collect__size;
			t_collect__size =  ( find_pdmd_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// Checking out-of-bound for "ExtractPDMD:collect"
			if ( t_begin_of_data + (t_collect__size) > t_end_of_data || t_begin_of_data + (t_collect__size) < t_begin_of_data )
				{
				// Handle out-of-bound condition
				throw binpac::ExceptionOutOfBound("ExtractPDMD:collect",
					(0) + (t_collect__size), 
					(t_end_of_data) - (t_begin_of_data));
				}
			{
			// Setting t_end_of_data with &length
			const_byteptr t_end_of_data = t_begin_of_data + t_collect__size;
			int t_collect_string_length;
			t_collect_string_length =  ( find_pdmd_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// check for negative sizes
			if ( t_collect_string_length < 0 )
			throw binpac::ExceptionInvalidStringLength("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:358", t_collect_string_length);
			collect_.init(t_begin_of_data, t_collect_string_length);
			// Evaluate 'let' and 'withinput' fields
			}
			t_exists__size = t_collect__size;
			}
			break;
		case ((bool) 0):
			// Parse "blank"
			{
			// Evaluate 'let' and 'withinput' fields
			t_exists__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("ExtractPDMD", (int64)exists_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_ExtractPDMD__size;
	const_byteptr const t_dataptr_after_exists = t_begin_of_data + (t_exists__size);
	BINPAC_ASSERT(t_dataptr_after_exists <= t_end_of_data);
	t_ExtractPDMD__size = t_dataptr_after_exists - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_ExtractPDMD__size) <= t_end_of_data);
	return t_ExtractPDMD__size;
	}

ExtractSMHL::ExtractSMHL(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset)
	{
	exists_case_index_ = -1;
	other_tags_ = other_tags;
	tag_number_ = tag_number;
	p_tag_offset_ = p_tag_offset;
	}

ExtractSMHL::~ExtractSMHL()
	{
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Clean up "collect"
			{
			collect_.free();
			}
			break;
		case ((bool) 0):
			// Clean up "blank"
			{
			}
			break;
		}
	}

int ExtractSMHL::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "exists"
	int t_exists__size;
	exists_case_index_ = other_tags()->smhl_check();
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Parse "collect"
			{
			int t_collect__size;
			t_collect__size =  ( find_smhl_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// Checking out-of-bound for "ExtractSMHL:collect"
			if ( t_begin_of_data + (t_collect__size) > t_end_of_data || t_begin_of_data + (t_collect__size) < t_begin_of_data )
				{
				// Handle out-of-bound condition
				throw binpac::ExceptionOutOfBound("ExtractSMHL:collect",
					(0) + (t_collect__size), 
					(t_end_of_data) - (t_begin_of_data));
				}
			{
			// Setting t_end_of_data with &length
			const_byteptr t_end_of_data = t_begin_of_data + t_collect__size;
			int t_collect_string_length;
			t_collect_string_length =  ( find_smhl_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// check for negative sizes
			if ( t_collect_string_length < 0 )
			throw binpac::ExceptionInvalidStringLength("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:365", t_collect_string_length);
			collect_.init(t_begin_of_data, t_collect_string_length);
			// Evaluate 'let' and 'withinput' fields
			}
			t_exists__size = t_collect__size;
			}
			break;
		case ((bool) 0):
			// Parse "blank"
			{
			// Evaluate 'let' and 'withinput' fields
			t_exists__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("ExtractSMHL", (int64)exists_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_ExtractSMHL__size;
	const_byteptr const t_dataptr_after_exists = t_begin_of_data + (t_exists__size);
	BINPAC_ASSERT(t_dataptr_after_exists <= t_end_of_data);
	t_ExtractSMHL__size = t_dataptr_after_exists - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_ExtractSMHL__size) <= t_end_of_data);
	return t_ExtractSMHL__size;
	}

ExtractICSL::ExtractICSL(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset)
	{
	exists_case_index_ = -1;
	other_tags_ = other_tags;
	tag_number_ = tag_number;
	p_tag_offset_ = p_tag_offset;
	}

ExtractICSL::~ExtractICSL()
	{
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Clean up "collect"
			{
			collect_.free();
			}
			break;
		case ((bool) 0):
			// Clean up "blank"
			{
			}
			break;
		}
	}

int ExtractICSL::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "exists"
	int t_exists__size;
	exists_case_index_ = other_tags()->icsl_check();
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Parse "collect"
			{
			int t_collect__size;
			t_collect__size =  ( find_icsl_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// Checking out-of-bound for "ExtractICSL:collect"
			if ( t_begin_of_data + (t_collect__size) > t_end_of_data || t_begin_of_data + (t_collect__size) < t_begin_of_data )
				{
				// Handle out-of-bound condition
				throw binpac::ExceptionOutOfBound("ExtractICSL:collect",
					(0) + (t_collect__size), 
					(t_end_of_data) - (t_begin_of_data));
				}
			{
			// Setting t_end_of_data with &length
			const_byteptr t_end_of_data = t_begin_of_data + t_collect__size;
			int t_collect_string_length;
			t_collect_string_length =  ( find_icsl_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// check for negative sizes
			if ( t_collect_string_length < 0 )
			throw binpac::ExceptionInvalidStringLength("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:372", t_collect_string_length);
			collect_.init(t_begin_of_data, t_collect_string_length);
			// Evaluate 'let' and 'withinput' fields
			}
			t_exists__size = t_collect__size;
			}
			break;
		case ((bool) 0):
			// Parse "blank"
			{
			// Evaluate 'let' and 'withinput' fields
			t_exists__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("ExtractICSL", (int64)exists_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_ExtractICSL__size;
	const_byteptr const t_dataptr_after_exists = t_begin_of_data + (t_exists__size);
	BINPAC_ASSERT(t_dataptr_after_exists <= t_end_of_data);
	t_ExtractICSL__size = t_dataptr_after_exists - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_ExtractICSL__size) <= t_end_of_data);
	return t_ExtractICSL__size;
	}

ExtractNONP::ExtractNONP(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset)
	{
	exists_case_index_ = -1;
	other_tags_ = other_tags;
	tag_number_ = tag_number;
	p_tag_offset_ = p_tag_offset;
	}

ExtractNONP::~ExtractNONP()
	{
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Clean up "collect"
			{
			collect_.free();
			}
			break;
		case ((bool) 0):
			// Clean up "blank"
			{
			}
			break;
		}
	}

int ExtractNONP::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "exists"
	int t_exists__size;
	exists_case_index_ = other_tags()->nonp_check();
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Parse "collect"
			{
			int t_collect__size;
			t_collect__size =  ( find_nonp_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// Checking out-of-bound for "ExtractNONP:collect"
			if ( t_begin_of_data + (t_collect__size) > t_end_of_data || t_begin_of_data + (t_collect__size) < t_begin_of_data )
				{
				// Handle out-of-bound condition
				throw binpac::ExceptionOutOfBound("ExtractNONP:collect",
					(0) + (t_collect__size), 
					(t_end_of_data) - (t_begin_of_data));
				}
			{
			// Setting t_end_of_data with &length
			const_byteptr t_end_of_data = t_begin_of_data + t_collect__size;
			int t_collect_string_length;
			t_collect_string_length =  ( find_nonp_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// check for negative sizes
			if ( t_collect_string_length < 0 )
			throw binpac::ExceptionInvalidStringLength("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:379", t_collect_string_length);
			collect_.init(t_begin_of_data, t_collect_string_length);
			// Evaluate 'let' and 'withinput' fields
			}
			t_exists__size = t_collect__size;
			}
			break;
		case ((bool) 0):
			// Parse "blank"
			{
			// Evaluate 'let' and 'withinput' fields
			t_exists__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("ExtractNONP", (int64)exists_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_ExtractNONP__size;
	const_byteptr const t_dataptr_after_exists = t_begin_of_data + (t_exists__size);
	BINPAC_ASSERT(t_dataptr_after_exists <= t_end_of_data);
	t_ExtractNONP__size = t_dataptr_after_exists - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_ExtractNONP__size) <= t_end_of_data);
	return t_ExtractNONP__size;
	}

ExtractPUBS::ExtractPUBS(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset)
	{
	exists_case_index_ = -1;
	other_tags_ = other_tags;
	tag_number_ = tag_number;
	p_tag_offset_ = p_tag_offset;
	}

ExtractPUBS::~ExtractPUBS()
	{
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Clean up "collect"
			{
			collect_.free();
			}
			break;
		case ((bool) 0):
			// Clean up "blank"
			{
			}
			break;
		}
	}

int ExtractPUBS::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "exists"
	int t_exists__size;
	exists_case_index_ = other_tags()->pubs_check();
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Parse "collect"
			{
			int t_collect__size;
			t_collect__size =  ( find_pubs_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// Checking out-of-bound for "ExtractPUBS:collect"
			if ( t_begin_of_data + (t_collect__size) > t_end_of_data || t_begin_of_data + (t_collect__size) < t_begin_of_data )
				{
				// Handle out-of-bound condition
				throw binpac::ExceptionOutOfBound("ExtractPUBS:collect",
					(0) + (t_collect__size), 
					(t_end_of_data) - (t_begin_of_data));
				}
			{
			// Setting t_end_of_data with &length
			const_byteptr t_end_of_data = t_begin_of_data + t_collect__size;
			int t_collect_string_length;
			t_collect_string_length =  ( find_pubs_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// check for negative sizes
			if ( t_collect_string_length < 0 )
			throw binpac::ExceptionInvalidStringLength("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:386", t_collect_string_length);
			collect_.init(t_begin_of_data, t_collect_string_length);
			// Evaluate 'let' and 'withinput' fields
			}
			t_exists__size = t_collect__size;
			}
			break;
		case ((bool) 0):
			// Parse "blank"
			{
			// Evaluate 'let' and 'withinput' fields
			t_exists__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("ExtractPUBS", (int64)exists_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_ExtractPUBS__size;
	const_byteptr const t_dataptr_after_exists = t_begin_of_data + (t_exists__size);
	BINPAC_ASSERT(t_dataptr_after_exists <= t_end_of_data);
	t_ExtractPUBS__size = t_dataptr_after_exists - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_ExtractPUBS__size) <= t_end_of_data);
	return t_ExtractPUBS__size;
	}

ExtractMIDS::ExtractMIDS(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset)
	{
	exists_case_index_ = -1;
	other_tags_ = other_tags;
	tag_number_ = tag_number;
	p_tag_offset_ = p_tag_offset;
	}

ExtractMIDS::~ExtractMIDS()
	{
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Clean up "collect"
			{
			collect_.free();
			}
			break;
		case ((bool) 0):
			// Clean up "blank"
			{
			}
			break;
		}
	}

int ExtractMIDS::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "exists"
	int t_exists__size;
	exists_case_index_ = other_tags()->mids_check();
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Parse "collect"
			{
			int t_collect__size;
			t_collect__size =  ( find_mids_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// Checking out-of-bound for "ExtractMIDS:collect"
			if ( t_begin_of_data + (t_collect__size) > t_end_of_data || t_begin_of_data + (t_collect__size) < t_begin_of_data )
				{
				// Handle out-of-bound condition
				throw binpac::ExceptionOutOfBound("ExtractMIDS:collect",
					(0) + (t_collect__size), 
					(t_end_of_data) - (t_begin_of_data));
				}
			{
			// Setting t_end_of_data with &length
			const_byteptr t_end_of_data = t_begin_of_data + t_collect__size;
			int t_collect_string_length;
			t_collect_string_length =  ( find_mids_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// check for negative sizes
			if ( t_collect_string_length < 0 )
			throw binpac::ExceptionInvalidStringLength("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:393", t_collect_string_length);
			collect_.init(t_begin_of_data, t_collect_string_length);
			// Evaluate 'let' and 'withinput' fields
			}
			t_exists__size = t_collect__size;
			}
			break;
		case ((bool) 0):
			// Parse "blank"
			{
			// Evaluate 'let' and 'withinput' fields
			t_exists__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("ExtractMIDS", (int64)exists_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_ExtractMIDS__size;
	const_byteptr const t_dataptr_after_exists = t_begin_of_data + (t_exists__size);
	BINPAC_ASSERT(t_dataptr_after_exists <= t_end_of_data);
	t_ExtractMIDS__size = t_dataptr_after_exists - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_ExtractMIDS__size) <= t_end_of_data);
	return t_ExtractMIDS__size;
	}

ExtractSCLS::ExtractSCLS(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset)
	{
	exists_case_index_ = -1;
	other_tags_ = other_tags;
	tag_number_ = tag_number;
	p_tag_offset_ = p_tag_offset;
	}

ExtractSCLS::~ExtractSCLS()
	{
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Clean up "collect"
			{
			collect_.free();
			}
			break;
		case ((bool) 0):
			// Clean up "blank"
			{
			}
			break;
		}
	}

int ExtractSCLS::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "exists"
	int t_exists__size;
	exists_case_index_ = other_tags()->scls_check();
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Parse "collect"
			{
			int t_collect__size;
			t_collect__size =  ( find_scls_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// Checking out-of-bound for "ExtractSCLS:collect"
			if ( t_begin_of_data + (t_collect__size) > t_end_of_data || t_begin_of_data + (t_collect__size) < t_begin_of_data )
				{
				// Handle out-of-bound condition
				throw binpac::ExceptionOutOfBound("ExtractSCLS:collect",
					(0) + (t_collect__size), 
					(t_end_of_data) - (t_begin_of_data));
				}
			{
			// Setting t_end_of_data with &length
			const_byteptr t_end_of_data = t_begin_of_data + t_collect__size;
			int t_collect_string_length;
			t_collect_string_length =  ( find_scls_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// check for negative sizes
			if ( t_collect_string_length < 0 )
			throw binpac::ExceptionInvalidStringLength("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:400", t_collect_string_length);
			collect_.init(t_begin_of_data, t_collect_string_length);
			// Evaluate 'let' and 'withinput' fields
			}
			t_exists__size = t_collect__size;
			}
			break;
		case ((bool) 0):
			// Parse "blank"
			{
			// Evaluate 'let' and 'withinput' fields
			t_exists__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("ExtractSCLS", (int64)exists_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_ExtractSCLS__size;
	const_byteptr const t_dataptr_after_exists = t_begin_of_data + (t_exists__size);
	BINPAC_ASSERT(t_dataptr_after_exists <= t_end_of_data);
	t_ExtractSCLS__size = t_dataptr_after_exists - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_ExtractSCLS__size) <= t_end_of_data);
	return t_ExtractSCLS__size;
	}

ExtractKEXS::ExtractKEXS(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset)
	{
	exists_case_index_ = -1;
	other_tags_ = other_tags;
	tag_number_ = tag_number;
	p_tag_offset_ = p_tag_offset;
	}

ExtractKEXS::~ExtractKEXS()
	{
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Clean up "collect"
			{
			collect_.free();
			}
			break;
		case ((bool) 0):
			// Clean up "blank"
			{
			}
			break;
		}
	}

int ExtractKEXS::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "exists"
	int t_exists__size;
	exists_case_index_ = other_tags()->kexs_check();
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Parse "collect"
			{
			int t_collect__size;
			t_collect__size =  ( find_kexs_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// Checking out-of-bound for "ExtractKEXS:collect"
			if ( t_begin_of_data + (t_collect__size) > t_end_of_data || t_begin_of_data + (t_collect__size) < t_begin_of_data )
				{
				// Handle out-of-bound condition
				throw binpac::ExceptionOutOfBound("ExtractKEXS:collect",
					(0) + (t_collect__size), 
					(t_end_of_data) - (t_begin_of_data));
				}
			{
			// Setting t_end_of_data with &length
			const_byteptr t_end_of_data = t_begin_of_data + t_collect__size;
			int t_collect_string_length;
			t_collect_string_length =  ( find_kexs_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// check for negative sizes
			if ( t_collect_string_length < 0 )
			throw binpac::ExceptionInvalidStringLength("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:407", t_collect_string_length);
			collect_.init(t_begin_of_data, t_collect_string_length);
			// Evaluate 'let' and 'withinput' fields
			}
			t_exists__size = t_collect__size;
			}
			break;
		case ((bool) 0):
			// Parse "blank"
			{
			// Evaluate 'let' and 'withinput' fields
			t_exists__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("ExtractKEXS", (int64)exists_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_ExtractKEXS__size;
	const_byteptr const t_dataptr_after_exists = t_begin_of_data + (t_exists__size);
	BINPAC_ASSERT(t_dataptr_after_exists <= t_end_of_data);
	t_ExtractKEXS__size = t_dataptr_after_exists - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_ExtractKEXS__size) <= t_end_of_data);
	return t_ExtractKEXS__size;
	}

ExtractXLCT::ExtractXLCT(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset)
	{
	exists_case_index_ = -1;
	other_tags_ = other_tags;
	tag_number_ = tag_number;
	p_tag_offset_ = p_tag_offset;
	}

ExtractXLCT::~ExtractXLCT()
	{
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Clean up "collect"
			{
			collect_.free();
			}
			break;
		case ((bool) 0):
			// Clean up "blank"
			{
			}
			break;
		}
	}

int ExtractXLCT::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "exists"
	int t_exists__size;
	exists_case_index_ = other_tags()->xlct_check();
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Parse "collect"
			{
			int t_collect__size;
			t_collect__size =  ( find_xlct_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// Checking out-of-bound for "ExtractXLCT:collect"
			if ( t_begin_of_data + (t_collect__size) > t_end_of_data || t_begin_of_data + (t_collect__size) < t_begin_of_data )
				{
				// Handle out-of-bound condition
				throw binpac::ExceptionOutOfBound("ExtractXLCT:collect",
					(0) + (t_collect__size), 
					(t_end_of_data) - (t_begin_of_data));
				}
			{
			// Setting t_end_of_data with &length
			const_byteptr t_end_of_data = t_begin_of_data + t_collect__size;
			int t_collect_string_length;
			t_collect_string_length =  ( find_xlct_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// check for negative sizes
			if ( t_collect_string_length < 0 )
			throw binpac::ExceptionInvalidStringLength("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:414", t_collect_string_length);
			collect_.init(t_begin_of_data, t_collect_string_length);
			// Evaluate 'let' and 'withinput' fields
			}
			t_exists__size = t_collect__size;
			}
			break;
		case ((bool) 0):
			// Parse "blank"
			{
			// Evaluate 'let' and 'withinput' fields
			t_exists__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("ExtractXLCT", (int64)exists_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_ExtractXLCT__size;
	const_byteptr const t_dataptr_after_exists = t_begin_of_data + (t_exists__size);
	BINPAC_ASSERT(t_dataptr_after_exists <= t_end_of_data);
	t_ExtractXLCT__size = t_dataptr_after_exists - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_ExtractXLCT__size) <= t_end_of_data);
	return t_ExtractXLCT__size;
	}

ExtractCSCT::ExtractCSCT(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset)
	{
	exists_case_index_ = -1;
	other_tags_ = other_tags;
	tag_number_ = tag_number;
	p_tag_offset_ = p_tag_offset;
	}

ExtractCSCT::~ExtractCSCT()
	{
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Clean up "collect"
			{
			collect_.free();
			}
			break;
		case ((bool) 0):
			// Clean up "blank"
			{
			}
			break;
		}
	}

int ExtractCSCT::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "exists"
	int t_exists__size;
	exists_case_index_ = other_tags()->csct_check();
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Parse "collect"
			{
			int t_collect__size;
			t_collect__size =  ( find_csct_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// Checking out-of-bound for "ExtractCSCT:collect"
			if ( t_begin_of_data + (t_collect__size) > t_end_of_data || t_begin_of_data + (t_collect__size) < t_begin_of_data )
				{
				// Handle out-of-bound condition
				throw binpac::ExceptionOutOfBound("ExtractCSCT:collect",
					(0) + (t_collect__size), 
					(t_end_of_data) - (t_begin_of_data));
				}
			{
			// Setting t_end_of_data with &length
			const_byteptr t_end_of_data = t_begin_of_data + t_collect__size;
			int t_collect_string_length;
			t_collect_string_length =  ( find_csct_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// check for negative sizes
			if ( t_collect_string_length < 0 )
			throw binpac::ExceptionInvalidStringLength("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:421", t_collect_string_length);
			collect_.init(t_begin_of_data, t_collect_string_length);
			// Evaluate 'let' and 'withinput' fields
			}
			t_exists__size = t_collect__size;
			}
			break;
		case ((bool) 0):
			// Parse "blank"
			{
			// Evaluate 'let' and 'withinput' fields
			t_exists__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("ExtractCSCT", (int64)exists_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_ExtractCSCT__size;
	const_byteptr const t_dataptr_after_exists = t_begin_of_data + (t_exists__size);
	BINPAC_ASSERT(t_dataptr_after_exists <= t_end_of_data);
	t_ExtractCSCT__size = t_dataptr_after_exists - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_ExtractCSCT__size) <= t_end_of_data);
	return t_ExtractCSCT__size;
	}

ExtractCOPT::ExtractCOPT(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset)
	{
	exists_case_index_ = -1;
	other_tags_ = other_tags;
	tag_number_ = tag_number;
	p_tag_offset_ = p_tag_offset;
	}

ExtractCOPT::~ExtractCOPT()
	{
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Clean up "collect"
			{
			collect_.free();
			}
			break;
		case ((bool) 0):
			// Clean up "blank"
			{
			}
			break;
		}
	}

int ExtractCOPT::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "exists"
	int t_exists__size;
	exists_case_index_ = other_tags()->copt_check();
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Parse "collect"
			{
			int t_collect__size;
			t_collect__size =  ( find_copt_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// Checking out-of-bound for "ExtractCOPT:collect"
			if ( t_begin_of_data + (t_collect__size) > t_end_of_data || t_begin_of_data + (t_collect__size) < t_begin_of_data )
				{
				// Handle out-of-bound condition
				throw binpac::ExceptionOutOfBound("ExtractCOPT:collect",
					(0) + (t_collect__size), 
					(t_end_of_data) - (t_begin_of_data));
				}
			{
			// Setting t_end_of_data with &length
			const_byteptr t_end_of_data = t_begin_of_data + t_collect__size;
			int t_collect_string_length;
			t_collect_string_length =  ( find_copt_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// check for negative sizes
			if ( t_collect_string_length < 0 )
			throw binpac::ExceptionInvalidStringLength("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:428", t_collect_string_length);
			collect_.init(t_begin_of_data, t_collect_string_length);
			// Evaluate 'let' and 'withinput' fields
			}
			t_exists__size = t_collect__size;
			}
			break;
		case ((bool) 0):
			// Parse "blank"
			{
			// Evaluate 'let' and 'withinput' fields
			t_exists__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("ExtractCOPT", (int64)exists_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_ExtractCOPT__size;
	const_byteptr const t_dataptr_after_exists = t_begin_of_data + (t_exists__size);
	BINPAC_ASSERT(t_dataptr_after_exists <= t_end_of_data);
	t_ExtractCOPT__size = t_dataptr_after_exists - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_ExtractCOPT__size) <= t_end_of_data);
	return t_ExtractCOPT__size;
	}

ExtractCCRT::ExtractCCRT(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset)
	{
	exists_case_index_ = -1;
	other_tags_ = other_tags;
	tag_number_ = tag_number;
	p_tag_offset_ = p_tag_offset;
	}

ExtractCCRT::~ExtractCCRT()
	{
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Clean up "collect"
			{
			collect_.free();
			}
			break;
		case ((bool) 0):
			// Clean up "blank"
			{
			}
			break;
		}
	}

int ExtractCCRT::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "exists"
	int t_exists__size;
	exists_case_index_ = other_tags()->ccrt_check();
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Parse "collect"
			{
			int t_collect__size;
			t_collect__size =  ( find_ccrt_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// Checking out-of-bound for "ExtractCCRT:collect"
			if ( t_begin_of_data + (t_collect__size) > t_end_of_data || t_begin_of_data + (t_collect__size) < t_begin_of_data )
				{
				// Handle out-of-bound condition
				throw binpac::ExceptionOutOfBound("ExtractCCRT:collect",
					(0) + (t_collect__size), 
					(t_end_of_data) - (t_begin_of_data));
				}
			{
			// Setting t_end_of_data with &length
			const_byteptr t_end_of_data = t_begin_of_data + t_collect__size;
			int t_collect_string_length;
			t_collect_string_length =  ( find_ccrt_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// check for negative sizes
			if ( t_collect_string_length < 0 )
			throw binpac::ExceptionInvalidStringLength("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:435", t_collect_string_length);
			collect_.init(t_begin_of_data, t_collect_string_length);
			// Evaluate 'let' and 'withinput' fields
			}
			t_exists__size = t_collect__size;
			}
			break;
		case ((bool) 0):
			// Parse "blank"
			{
			// Evaluate 'let' and 'withinput' fields
			t_exists__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("ExtractCCRT", (int64)exists_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_ExtractCCRT__size;
	const_byteptr const t_dataptr_after_exists = t_begin_of_data + (t_exists__size);
	BINPAC_ASSERT(t_dataptr_after_exists <= t_end_of_data);
	t_ExtractCCRT__size = t_dataptr_after_exists - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_ExtractCCRT__size) <= t_end_of_data);
	return t_ExtractCCRT__size;
	}

ExtractIRTT::ExtractIRTT(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset)
	{
	exists_case_index_ = -1;
	other_tags_ = other_tags;
	tag_number_ = tag_number;
	p_tag_offset_ = p_tag_offset;
	}

ExtractIRTT::~ExtractIRTT()
	{
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Clean up "collect"
			{
			collect_.free();
			}
			break;
		case ((bool) 0):
			// Clean up "blank"
			{
			}
			break;
		}
	}

int ExtractIRTT::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "exists"
	int t_exists__size;
	exists_case_index_ = other_tags()->irtt_check();
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Parse "collect"
			{
			int t_collect__size;
			t_collect__size =  ( find_irtt_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// Checking out-of-bound for "ExtractIRTT:collect"
			if ( t_begin_of_data + (t_collect__size) > t_end_of_data || t_begin_of_data + (t_collect__size) < t_begin_of_data )
				{
				// Handle out-of-bound condition
				throw binpac::ExceptionOutOfBound("ExtractIRTT:collect",
					(0) + (t_collect__size), 
					(t_end_of_data) - (t_begin_of_data));
				}
			{
			// Setting t_end_of_data with &length
			const_byteptr t_end_of_data = t_begin_of_data + t_collect__size;
			int t_collect_string_length;
			t_collect_string_length =  ( find_irtt_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// check for negative sizes
			if ( t_collect_string_length < 0 )
			throw binpac::ExceptionInvalidStringLength("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:442", t_collect_string_length);
			collect_.init(t_begin_of_data, t_collect_string_length);
			// Evaluate 'let' and 'withinput' fields
			}
			t_exists__size = t_collect__size;
			}
			break;
		case ((bool) 0):
			// Parse "blank"
			{
			// Evaluate 'let' and 'withinput' fields
			t_exists__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("ExtractIRTT", (int64)exists_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_ExtractIRTT__size;
	const_byteptr const t_dataptr_after_exists = t_begin_of_data + (t_exists__size);
	BINPAC_ASSERT(t_dataptr_after_exists <= t_end_of_data);
	t_ExtractIRTT__size = t_dataptr_after_exists - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_ExtractIRTT__size) <= t_end_of_data);
	return t_ExtractIRTT__size;
	}

ExtractCFCW::ExtractCFCW(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset)
	{
	exists_case_index_ = -1;
	other_tags_ = other_tags;
	tag_number_ = tag_number;
	p_tag_offset_ = p_tag_offset;
	}

ExtractCFCW::~ExtractCFCW()
	{
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Clean up "collect"
			{
			collect_.free();
			}
			break;
		case ((bool) 0):
			// Clean up "blank"
			{
			}
			break;
		}
	}

int ExtractCFCW::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "exists"
	int t_exists__size;
	exists_case_index_ = other_tags()->cfcw_check();
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Parse "collect"
			{
			int t_collect__size;
			t_collect__size =  ( find_cfcw_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// Checking out-of-bound for "ExtractCFCW:collect"
			if ( t_begin_of_data + (t_collect__size) > t_end_of_data || t_begin_of_data + (t_collect__size) < t_begin_of_data )
				{
				// Handle out-of-bound condition
				throw binpac::ExceptionOutOfBound("ExtractCFCW:collect",
					(0) + (t_collect__size), 
					(t_end_of_data) - (t_begin_of_data));
				}
			{
			// Setting t_end_of_data with &length
			const_byteptr t_end_of_data = t_begin_of_data + t_collect__size;
			int t_collect_string_length;
			t_collect_string_length =  ( find_cfcw_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// check for negative sizes
			if ( t_collect_string_length < 0 )
			throw binpac::ExceptionInvalidStringLength("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:449", t_collect_string_length);
			collect_.init(t_begin_of_data, t_collect_string_length);
			// Evaluate 'let' and 'withinput' fields
			}
			t_exists__size = t_collect__size;
			}
			break;
		case ((bool) 0):
			// Parse "blank"
			{
			// Evaluate 'let' and 'withinput' fields
			t_exists__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("ExtractCFCW", (int64)exists_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_ExtractCFCW__size;
	const_byteptr const t_dataptr_after_exists = t_begin_of_data + (t_exists__size);
	BINPAC_ASSERT(t_dataptr_after_exists <= t_end_of_data);
	t_ExtractCFCW__size = t_dataptr_after_exists - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_ExtractCFCW__size) <= t_end_of_data);
	return t_ExtractCFCW__size;
	}

ExtractSFCW::ExtractSFCW(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset)
	{
	exists_case_index_ = -1;
	other_tags_ = other_tags;
	tag_number_ = tag_number;
	p_tag_offset_ = p_tag_offset;
	}

ExtractSFCW::~ExtractSFCW()
	{
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Clean up "collect"
			{
			collect_.free();
			}
			break;
		case ((bool) 0):
			// Clean up "blank"
			{
			}
			break;
		}
	}

int ExtractSFCW::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "exists"
	int t_exists__size;
	exists_case_index_ = other_tags()->sfcw_check();
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Parse "collect"
			{
			int t_collect__size;
			t_collect__size =  ( find_sfcw_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// Checking out-of-bound for "ExtractSFCW:collect"
			if ( t_begin_of_data + (t_collect__size) > t_end_of_data || t_begin_of_data + (t_collect__size) < t_begin_of_data )
				{
				// Handle out-of-bound condition
				throw binpac::ExceptionOutOfBound("ExtractSFCW:collect",
					(0) + (t_collect__size), 
					(t_end_of_data) - (t_begin_of_data));
				}
			{
			// Setting t_end_of_data with &length
			const_byteptr t_end_of_data = t_begin_of_data + t_collect__size;
			int t_collect_string_length;
			t_collect_string_length =  ( find_sfcw_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// check for negative sizes
			if ( t_collect_string_length < 0 )
			throw binpac::ExceptionInvalidStringLength("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:456", t_collect_string_length);
			collect_.init(t_begin_of_data, t_collect_string_length);
			// Evaluate 'let' and 'withinput' fields
			}
			t_exists__size = t_collect__size;
			}
			break;
		case ((bool) 0):
			// Parse "blank"
			{
			// Evaluate 'let' and 'withinput' fields
			t_exists__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("ExtractSFCW", (int64)exists_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_ExtractSFCW__size;
	const_byteptr const t_dataptr_after_exists = t_begin_of_data + (t_exists__size);
	BINPAC_ASSERT(t_dataptr_after_exists <= t_end_of_data);
	t_ExtractSFCW__size = t_dataptr_after_exists - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_ExtractSFCW__size) <= t_end_of_data);
	return t_ExtractSFCW__size;
	}

ExtractPROF::ExtractPROF(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset)
	{
	exists_case_index_ = -1;
	other_tags_ = other_tags;
	tag_number_ = tag_number;
	p_tag_offset_ = p_tag_offset;
	}

ExtractPROF::~ExtractPROF()
	{
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Clean up "collect"
			{
			collect_.free();
			}
			break;
		case ((bool) 0):
			// Clean up "blank"
			{
			}
			break;
		}
	}

int ExtractPROF::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "exists"
	int t_exists__size;
	exists_case_index_ = other_tags()->prof_check();
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Parse "collect"
			{
			int t_collect__size;
			t_collect__size =  ( find_prof_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// Checking out-of-bound for "ExtractPROF:collect"
			if ( t_begin_of_data + (t_collect__size) > t_end_of_data || t_begin_of_data + (t_collect__size) < t_begin_of_data )
				{
				// Handle out-of-bound condition
				throw binpac::ExceptionOutOfBound("ExtractPROF:collect",
					(0) + (t_collect__size), 
					(t_end_of_data) - (t_begin_of_data));
				}
			{
			// Setting t_end_of_data with &length
			const_byteptr t_end_of_data = t_begin_of_data + t_collect__size;
			int t_collect_string_length;
			t_collect_string_length =  ( find_prof_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// check for negative sizes
			if ( t_collect_string_length < 0 )
			throw binpac::ExceptionInvalidStringLength("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:463", t_collect_string_length);
			collect_.init(t_begin_of_data, t_collect_string_length);
			// Evaluate 'let' and 'withinput' fields
			}
			t_exists__size = t_collect__size;
			}
			break;
		case ((bool) 0):
			// Parse "blank"
			{
			// Evaluate 'let' and 'withinput' fields
			t_exists__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("ExtractPROF", (int64)exists_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_ExtractPROF__size;
	const_byteptr const t_dataptr_after_exists = t_begin_of_data + (t_exists__size);
	BINPAC_ASSERT(t_dataptr_after_exists <= t_end_of_data);
	t_ExtractPROF__size = t_dataptr_after_exists - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_ExtractPROF__size) <= t_end_of_data);
	return t_ExtractPROF__size;
	}

ExtractSCFG::ExtractSCFG(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset)
	{
	exists_case_index_ = -1;
	collect_ = 0;
	other_tags_ = other_tags;
	tag_number_ = tag_number;
	p_tag_offset_ = p_tag_offset;
	}

ExtractSCFG::~ExtractSCFG()
	{
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Clean up "collect"
			{
			delete collect_;
			collect_ = 0;
			}
			break;
		case ((bool) 0):
			// Clean up "blank"
			{
			}
			break;
		}
	}

int ExtractSCFG::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "exists"
	int t_exists__size;
	exists_case_index_ = other_tags()->scfg_check();
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Parse "collect"
			{
			collect_ = new RejPacketSCFG();
			int t_collect__size;
			t_collect__size = collect_->Parse(t_begin_of_data, t_end_of_data);
			// Evaluate 'let' and 'withinput' fields
			t_exists__size = t_collect__size;
			}
			break;
		case ((bool) 0):
			// Parse "blank"
			{
			// Evaluate 'let' and 'withinput' fields
			t_exists__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("ExtractSCFG", (int64)exists_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_ExtractSCFG__size;
	const_byteptr const t_dataptr_after_exists = t_begin_of_data + (t_exists__size);
	BINPAC_ASSERT(t_dataptr_after_exists <= t_end_of_data);
	t_ExtractSCFG__size = t_dataptr_after_exists - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_ExtractSCFG__size) <= t_end_of_data);
	return t_ExtractSCFG__size;
	}

ExtractRREJ::ExtractRREJ(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset)
	{
	exists_case_index_ = -1;
	other_tags_ = other_tags;
	tag_number_ = tag_number;
	p_tag_offset_ = p_tag_offset;
	}

ExtractRREJ::~ExtractRREJ()
	{
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Clean up "collect"
			{
			collect_.free();
			}
			break;
		case ((bool) 0):
			// Clean up "blank"
			{
			}
			break;
		}
	}

int ExtractRREJ::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "exists"
	int t_exists__size;
	exists_case_index_ = other_tags()->rrej_check();
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Parse "collect"
			{
			int t_collect__size;
			t_collect__size =  ( find_rrej_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// Checking out-of-bound for "ExtractRREJ:collect"
			if ( t_begin_of_data + (t_collect__size) > t_end_of_data || t_begin_of_data + (t_collect__size) < t_begin_of_data )
				{
				// Handle out-of-bound condition
				throw binpac::ExceptionOutOfBound("ExtractRREJ:collect",
					(0) + (t_collect__size), 
					(t_end_of_data) - (t_begin_of_data));
				}
			{
			// Setting t_end_of_data with &length
			const_byteptr t_end_of_data = t_begin_of_data + t_collect__size;
			int t_collect_string_length;
			t_collect_string_length =  ( find_rrej_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// check for negative sizes
			if ( t_collect_string_length < 0 )
			throw binpac::ExceptionInvalidStringLength("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:479", t_collect_string_length);
			collect_.init(t_begin_of_data, t_collect_string_length);
			// Evaluate 'let' and 'withinput' fields
			}
			t_exists__size = t_collect__size;
			}
			break;
		case ((bool) 0):
			// Parse "blank"
			{
			// Evaluate 'let' and 'withinput' fields
			t_exists__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("ExtractRREJ", (int64)exists_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_ExtractRREJ__size;
	const_byteptr const t_dataptr_after_exists = t_begin_of_data + (t_exists__size);
	BINPAC_ASSERT(t_dataptr_after_exists <= t_end_of_data);
	t_ExtractRREJ__size = t_dataptr_after_exists - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_ExtractRREJ__size) <= t_end_of_data);
	return t_ExtractRREJ__size;
	}

ExtractOBIT::ExtractOBIT(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset)
	{
	exists_case_index_ = -1;
	other_tags_ = other_tags;
	tag_number_ = tag_number;
	p_tag_offset_ = p_tag_offset;
	}

ExtractOBIT::~ExtractOBIT()
	{
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Clean up "collect"
			{
			collect_.free();
			}
			break;
		case ((bool) 0):
			// Clean up "blank"
			{
			}
			break;
		}
	}

int ExtractOBIT::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "exists"
	int t_exists__size;
	exists_case_index_ = other_tags()->obit_check();
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Parse "collect"
			{
			int t_collect__size;
			t_collect__size =  ( find_obit_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// Checking out-of-bound for "ExtractOBIT:collect"
			if ( t_begin_of_data + (t_collect__size) > t_end_of_data || t_begin_of_data + (t_collect__size) < t_begin_of_data )
				{
				// Handle out-of-bound condition
				throw binpac::ExceptionOutOfBound("ExtractOBIT:collect",
					(0) + (t_collect__size), 
					(t_end_of_data) - (t_begin_of_data));
				}
			{
			// Setting t_end_of_data with &length
			const_byteptr t_end_of_data = t_begin_of_data + t_collect__size;
			int t_collect_string_length;
			t_collect_string_length =  ( find_obit_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// check for negative sizes
			if ( t_collect_string_length < 0 )
			throw binpac::ExceptionInvalidStringLength("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:486", t_collect_string_length);
			collect_.init(t_begin_of_data, t_collect_string_length);
			// Evaluate 'let' and 'withinput' fields
			}
			t_exists__size = t_collect__size;
			}
			break;
		case ((bool) 0):
			// Parse "blank"
			{
			// Evaluate 'let' and 'withinput' fields
			t_exists__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("ExtractOBIT", (int64)exists_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_ExtractOBIT__size;
	const_byteptr const t_dataptr_after_exists = t_begin_of_data + (t_exists__size);
	BINPAC_ASSERT(t_dataptr_after_exists <= t_end_of_data);
	t_ExtractOBIT__size = t_dataptr_after_exists - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_ExtractOBIT__size) <= t_end_of_data);
	return t_ExtractOBIT__size;
	}

ExtractEXPY::ExtractEXPY(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset)
	{
	exists_case_index_ = -1;
	other_tags_ = other_tags;
	tag_number_ = tag_number;
	p_tag_offset_ = p_tag_offset;
	}

ExtractEXPY::~ExtractEXPY()
	{
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Clean up "collect"
			{
			collect_.free();
			}
			break;
		case ((bool) 0):
			// Clean up "blank"
			{
			}
			break;
		}
	}

int ExtractEXPY::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "exists"
	int t_exists__size;
	exists_case_index_ = other_tags()->expy_check();
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Parse "collect"
			{
			int t_collect__size;
			t_collect__size =  ( find_expy_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// Checking out-of-bound for "ExtractEXPY:collect"
			if ( t_begin_of_data + (t_collect__size) > t_end_of_data || t_begin_of_data + (t_collect__size) < t_begin_of_data )
				{
				// Handle out-of-bound condition
				throw binpac::ExceptionOutOfBound("ExtractEXPY:collect",
					(0) + (t_collect__size), 
					(t_end_of_data) - (t_begin_of_data));
				}
			{
			// Setting t_end_of_data with &length
			const_byteptr t_end_of_data = t_begin_of_data + t_collect__size;
			int t_collect_string_length;
			t_collect_string_length =  ( find_expy_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// check for negative sizes
			if ( t_collect_string_length < 0 )
			throw binpac::ExceptionInvalidStringLength("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:493", t_collect_string_length);
			collect_.init(t_begin_of_data, t_collect_string_length);
			// Evaluate 'let' and 'withinput' fields
			}
			t_exists__size = t_collect__size;
			}
			break;
		case ((bool) 0):
			// Parse "blank"
			{
			// Evaluate 'let' and 'withinput' fields
			t_exists__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("ExtractEXPY", (int64)exists_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_ExtractEXPY__size;
	const_byteptr const t_dataptr_after_exists = t_begin_of_data + (t_exists__size);
	BINPAC_ASSERT(t_dataptr_after_exists <= t_end_of_data);
	t_ExtractEXPY__size = t_dataptr_after_exists - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_ExtractEXPY__size) <= t_end_of_data);
	return t_ExtractEXPY__size;
	}

ExtractSRBF::ExtractSRBF(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset)
	{
	exists_case_index_ = -1;
	other_tags_ = other_tags;
	tag_number_ = tag_number;
	p_tag_offset_ = p_tag_offset;
	}

ExtractSRBF::~ExtractSRBF()
	{
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Clean up "collect"
			{
			collect_.free();
			}
			break;
		case ((bool) 0):
			// Clean up "blank"
			{
			}
			break;
		}
	}

int ExtractSRBF::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "exists"
	int t_exists__size;
	exists_case_index_ = other_tags()->srbf_check();
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Parse "collect"
			{
			int t_collect__size;
			t_collect__size =  ( find_srbf_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// Checking out-of-bound for "ExtractSRBF:collect"
			if ( t_begin_of_data + (t_collect__size) > t_end_of_data || t_begin_of_data + (t_collect__size) < t_begin_of_data )
				{
				// Handle out-of-bound condition
				throw binpac::ExceptionOutOfBound("ExtractSRBF:collect",
					(0) + (t_collect__size), 
					(t_end_of_data) - (t_begin_of_data));
				}
			{
			// Setting t_end_of_data with &length
			const_byteptr t_end_of_data = t_begin_of_data + t_collect__size;
			int t_collect_string_length;
			t_collect_string_length =  ( find_srbf_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// check for negative sizes
			if ( t_collect_string_length < 0 )
			throw binpac::ExceptionInvalidStringLength("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:500", t_collect_string_length);
			collect_.init(t_begin_of_data, t_collect_string_length);
			// Evaluate 'let' and 'withinput' fields
			}
			t_exists__size = t_collect__size;
			}
			break;
		case ((bool) 0):
			// Parse "blank"
			{
			// Evaluate 'let' and 'withinput' fields
			t_exists__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("ExtractSRBF", (int64)exists_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_ExtractSRBF__size;
	const_byteptr const t_dataptr_after_exists = t_begin_of_data + (t_exists__size);
	BINPAC_ASSERT(t_dataptr_after_exists <= t_end_of_data);
	t_ExtractSRBF__size = t_dataptr_after_exists - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_ExtractSRBF__size) <= t_end_of_data);
	return t_ExtractSRBF__size;
	}

ExtractCETV::ExtractCETV(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset)
	{
	exists_case_index_ = -1;
	other_tags_ = other_tags;
	tag_number_ = tag_number;
	p_tag_offset_ = p_tag_offset;
	}

ExtractCETV::~ExtractCETV()
	{
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Clean up "collect"
			{
			collect_.free();
			}
			break;
		case ((bool) 0):
			// Clean up "blank"
			{
			}
			break;
		}
	}

int ExtractCETV::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "exists"
	int t_exists__size;
	exists_case_index_ = other_tags()->cetv_check();
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Parse "collect"
			{
			int t_collect__size;
			t_collect__size =  ( find_cetv_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// Checking out-of-bound for "ExtractCETV:collect"
			if ( t_begin_of_data + (t_collect__size) > t_end_of_data || t_begin_of_data + (t_collect__size) < t_begin_of_data )
				{
				// Handle out-of-bound condition
				throw binpac::ExceptionOutOfBound("ExtractCETV:collect",
					(0) + (t_collect__size), 
					(t_end_of_data) - (t_begin_of_data));
				}
			{
			// Setting t_end_of_data with &length
			const_byteptr t_end_of_data = t_begin_of_data + t_collect__size;
			int t_collect_string_length;
			t_collect_string_length =  ( find_cetv_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// check for negative sizes
			if ( t_collect_string_length < 0 )
			throw binpac::ExceptionInvalidStringLength("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:507", t_collect_string_length);
			collect_.init(t_begin_of_data, t_collect_string_length);
			// Evaluate 'let' and 'withinput' fields
			}
			t_exists__size = t_collect__size;
			}
			break;
		case ((bool) 0):
			// Parse "blank"
			{
			// Evaluate 'let' and 'withinput' fields
			t_exists__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("ExtractCETV", (int64)exists_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_ExtractCETV__size;
	const_byteptr const t_dataptr_after_exists = t_begin_of_data + (t_exists__size);
	BINPAC_ASSERT(t_dataptr_after_exists <= t_end_of_data);
	t_ExtractCETV__size = t_dataptr_after_exists - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_ExtractCETV__size) <= t_end_of_data);
	return t_ExtractCETV__size;
	}

ExtractCTIM::ExtractCTIM(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset)
	{
	exists_case_index_ = -1;
	other_tags_ = other_tags;
	tag_number_ = tag_number;
	p_tag_offset_ = p_tag_offset;
	}

ExtractCTIM::~ExtractCTIM()
	{
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Clean up "collect"
			{
			collect_.free();
			}
			break;
		case ((bool) 0):
			// Clean up "blank"
			{
			}
			break;
		}
	}

int ExtractCTIM::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "exists"
	int t_exists__size;
	exists_case_index_ = other_tags()->ctim_check();
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Parse "collect"
			{
			int t_collect__size;
			t_collect__size =  ( find_ctim_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// Checking out-of-bound for "ExtractCTIM:collect"
			if ( t_begin_of_data + (t_collect__size) > t_end_of_data || t_begin_of_data + (t_collect__size) < t_begin_of_data )
				{
				// Handle out-of-bound condition
				throw binpac::ExceptionOutOfBound("ExtractCTIM:collect",
					(0) + (t_collect__size), 
					(t_end_of_data) - (t_begin_of_data));
				}
			{
			// Setting t_end_of_data with &length
			const_byteptr t_end_of_data = t_begin_of_data + t_collect__size;
			int t_collect_string_length;
			t_collect_string_length =  ( find_ctim_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// check for negative sizes
			if ( t_collect_string_length < 0 )
			throw binpac::ExceptionInvalidStringLength("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:514", t_collect_string_length);
			collect_.init(t_begin_of_data, t_collect_string_length);
			// Evaluate 'let' and 'withinput' fields
			}
			t_exists__size = t_collect__size;
			}
			break;
		case ((bool) 0):
			// Parse "blank"
			{
			// Evaluate 'let' and 'withinput' fields
			t_exists__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("ExtractCTIM", (int64)exists_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_ExtractCTIM__size;
	const_byteptr const t_dataptr_after_exists = t_begin_of_data + (t_exists__size);
	BINPAC_ASSERT(t_dataptr_after_exists <= t_end_of_data);
	t_ExtractCTIM__size = t_dataptr_after_exists - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_ExtractCTIM__size) <= t_end_of_data);
	return t_ExtractCTIM__size;
	}

ExtractFHOL::ExtractFHOL(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset)
	{
	exists_case_index_ = -1;
	other_tags_ = other_tags;
	tag_number_ = tag_number;
	p_tag_offset_ = p_tag_offset;
	}

ExtractFHOL::~ExtractFHOL()
	{
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Clean up "collect"
			{
			collect_.free();
			}
			break;
		case ((bool) 0):
			// Clean up "blank"
			{
			}
			break;
		}
	}

int ExtractFHOL::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "exists"
	int t_exists__size;
	exists_case_index_ = other_tags()->fhol_check();
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Parse "collect"
			{
			int t_collect__size;
			t_collect__size =  ( find_fhol_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// Checking out-of-bound for "ExtractFHOL:collect"
			if ( t_begin_of_data + (t_collect__size) > t_end_of_data || t_begin_of_data + (t_collect__size) < t_begin_of_data )
				{
				// Handle out-of-bound condition
				throw binpac::ExceptionOutOfBound("ExtractFHOL:collect",
					(0) + (t_collect__size), 
					(t_end_of_data) - (t_begin_of_data));
				}
			{
			// Setting t_end_of_data with &length
			const_byteptr t_end_of_data = t_begin_of_data + t_collect__size;
			int t_collect_string_length;
			t_collect_string_length =  ( find_fhol_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// check for negative sizes
			if ( t_collect_string_length < 0 )
			throw binpac::ExceptionInvalidStringLength("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:521", t_collect_string_length);
			collect_.init(t_begin_of_data, t_collect_string_length);
			// Evaluate 'let' and 'withinput' fields
			}
			t_exists__size = t_collect__size;
			}
			break;
		case ((bool) 0):
			// Parse "blank"
			{
			// Evaluate 'let' and 'withinput' fields
			t_exists__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("ExtractFHOL", (int64)exists_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_ExtractFHOL__size;
	const_byteptr const t_dataptr_after_exists = t_begin_of_data + (t_exists__size);
	BINPAC_ASSERT(t_dataptr_after_exists <= t_end_of_data);
	t_ExtractFHOL__size = t_dataptr_after_exists - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_ExtractFHOL__size) <= t_end_of_data);
	return t_ExtractFHOL__size;
	}

ExtractSTTL::ExtractSTTL(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset)
	{
	exists_case_index_ = -1;
	other_tags_ = other_tags;
	tag_number_ = tag_number;
	p_tag_offset_ = p_tag_offset;
	}

ExtractSTTL::~ExtractSTTL()
	{
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Clean up "collect"
			{
			collect_.free();
			}
			break;
		case ((bool) 0):
			// Clean up "blank"
			{
			}
			break;
		}
	}

int ExtractSTTL::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "exists"
	int t_exists__size;
	exists_case_index_ = other_tags()->sttl_check();
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Parse "collect"
			{
			int t_collect__size;
			t_collect__size =  ( find_sttl_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// Checking out-of-bound for "ExtractSTTL:collect"
			if ( t_begin_of_data + (t_collect__size) > t_end_of_data || t_begin_of_data + (t_collect__size) < t_begin_of_data )
				{
				// Handle out-of-bound condition
				throw binpac::ExceptionOutOfBound("ExtractSTTL:collect",
					(0) + (t_collect__size), 
					(t_end_of_data) - (t_begin_of_data));
				}
			{
			// Setting t_end_of_data with &length
			const_byteptr t_end_of_data = t_begin_of_data + t_collect__size;
			int t_collect_string_length;
			t_collect_string_length =  ( find_sttl_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// check for negative sizes
			if ( t_collect_string_length < 0 )
			throw binpac::ExceptionInvalidStringLength("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:528", t_collect_string_length);
			collect_.init(t_begin_of_data, t_collect_string_length);
			// Evaluate 'let' and 'withinput' fields
			}
			t_exists__size = t_collect__size;
			}
			break;
		case ((bool) 0):
			// Parse "blank"
			{
			// Evaluate 'let' and 'withinput' fields
			t_exists__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("ExtractSTTL", (int64)exists_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_ExtractSTTL__size;
	const_byteptr const t_dataptr_after_exists = t_begin_of_data + (t_exists__size);
	BINPAC_ASSERT(t_dataptr_after_exists <= t_end_of_data);
	t_ExtractSTTL__size = t_dataptr_after_exists - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_ExtractSTTL__size) <= t_end_of_data);
	return t_ExtractSTTL__size;
	}

ExtractTBKP::ExtractTBKP(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset)
	{
	exists_case_index_ = -1;
	other_tags_ = other_tags;
	tag_number_ = tag_number;
	p_tag_offset_ = p_tag_offset;
	}

ExtractTBKP::~ExtractTBKP()
	{
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Clean up "collect"
			{
			collect_.free();
			}
			break;
		case ((bool) 0):
			// Clean up "blank"
			{
			}
			break;
		}
	}

int ExtractTBKP::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "exists"
	int t_exists__size;
	exists_case_index_ = other_tags()->tbkp_check();
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Parse "collect"
			{
			int t_collect__size;
			t_collect__size =  ( find_tbkp_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// Checking out-of-bound for "ExtractTBKP:collect"
			if ( t_begin_of_data + (t_collect__size) > t_end_of_data || t_begin_of_data + (t_collect__size) < t_begin_of_data )
				{
				// Handle out-of-bound condition
				throw binpac::ExceptionOutOfBound("ExtractTBKP:collect",
					(0) + (t_collect__size), 
					(t_end_of_data) - (t_begin_of_data));
				}
			{
			// Setting t_end_of_data with &length
			const_byteptr t_end_of_data = t_begin_of_data + t_collect__size;
			int t_collect_string_length;
			t_collect_string_length =  ( find_tbkp_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// check for negative sizes
			if ( t_collect_string_length < 0 )
			throw binpac::ExceptionInvalidStringLength("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:535", t_collect_string_length);
			collect_.init(t_begin_of_data, t_collect_string_length);
			// Evaluate 'let' and 'withinput' fields
			}
			t_exists__size = t_collect__size;
			}
			break;
		case ((bool) 0):
			// Parse "blank"
			{
			// Evaluate 'let' and 'withinput' fields
			t_exists__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("ExtractTBKP", (int64)exists_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_ExtractTBKP__size;
	const_byteptr const t_dataptr_after_exists = t_begin_of_data + (t_exists__size);
	BINPAC_ASSERT(t_dataptr_after_exists <= t_end_of_data);
	t_ExtractTBKP__size = t_dataptr_after_exists - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_ExtractTBKP__size) <= t_end_of_data);
	return t_ExtractTBKP__size;
	}

ExtractSVID::ExtractSVID(TagFinder * other_tags, uint16 tag_number, uint32 p_tag_offset)
	{
	exists_case_index_ = -1;
	other_tags_ = other_tags;
	tag_number_ = tag_number;
	p_tag_offset_ = p_tag_offset;
	}

ExtractSVID::~ExtractSVID()
	{
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Clean up "collect"
			{
			collect_.free();
			}
			break;
		case ((bool) 0):
			// Clean up "blank"
			{
			}
			break;
		}
	}

int ExtractSVID::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "exists"
	int t_exists__size;
	exists_case_index_ = other_tags()->svid_check();
	switch ( exists_case_index() )
		{
		case ((bool) 1):
			// Parse "collect"
			{
			int t_collect__size;
			t_collect__size =  ( find_svid_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// Checking out-of-bound for "ExtractSVID:collect"
			if ( t_begin_of_data + (t_collect__size) > t_end_of_data || t_begin_of_data + (t_collect__size) < t_begin_of_data )
				{
				// Handle out-of-bound condition
				throw binpac::ExceptionOutOfBound("ExtractSVID:collect",
					(0) + (t_collect__size), 
					(t_end_of_data) - (t_begin_of_data));
				}
			{
			// Setting t_end_of_data with &length
			const_byteptr t_end_of_data = t_begin_of_data + t_collect__size;
			int t_collect_string_length;
			t_collect_string_length =  ( find_svid_length(other_tags()->seek_tags(), tag_number(), p_tag_offset()) ) ;
			// check for negative sizes
			if ( t_collect_string_length < 0 )
			throw binpac::ExceptionInvalidStringLength("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:542", t_collect_string_length);
			collect_.init(t_begin_of_data, t_collect_string_length);
			// Evaluate 'let' and 'withinput' fields
			}
			t_exists__size = t_collect__size;
			}
			break;
		case ((bool) 0):
			// Parse "blank"
			{
			// Evaluate 'let' and 'withinput' fields
			t_exists__size = 0;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("ExtractSVID", (int64)exists_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	
	int t_ExtractSVID__size;
	const_byteptr const t_dataptr_after_exists = t_begin_of_data + (t_exists__size);
	BINPAC_ASSERT(t_dataptr_after_exists <= t_end_of_data);
	t_ExtractSVID__size = t_dataptr_after_exists - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_ExtractSVID__size) <= t_end_of_data);
	return t_ExtractSVID__size;
	}

TagFinder::TagFinder(uint16 tag_number)
	{
	tag_number_ = tag_number;
	pad_check_ = 0;
	sni_check_ = 0;
	stk_check_ = 0;
	sno_check_ = 0;
	ver_check_ = 0;
	ccs_check_ = 0;
	crt_check_ = 0;
	nonc_check_ = 0;
	mspc_check_ = 0;
	aead_check_ = 0;
	uaid_check_ = 0;
	scid_check_ = 0;
	tcid_check_ = 0;
	pdmd_check_ = 0;
	smhl_check_ = 0;
	icsl_check_ = 0;
	nonp_check_ = 0;
	pubs_check_ = 0;
	mids_check_ = 0;
	scls_check_ = 0;
	kexs_check_ = 0;
	xlct_check_ = 0;
	csct_check_ = 0;
	copt_check_ = 0;
	ccrt_check_ = 0;
	irtt_check_ = 0;
	cfcw_check_ = 0;
	sfcw_check_ = 0;
	prof_check_ = 0;
	scfg_check_ = 0;
	rrej_check_ = 0;
	obit_check_ = 0;
	expy_check_ = 0;
	srbf_check_ = 0;
	cetv_check_ = 0;
	ctim_check_ = 0;
	fhol_check_ = 0;
	sttl_check_ = 0;
	tbkp_check_ = 0;
	svid_check_ = 0;
	}

TagFinder::~TagFinder()
	{
	seek_tags_.free();
	}

int TagFinder::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "seek_tags"
	int t_seek_tags__size;
	t_seek_tags__size =  (  ( 8 * tag_number() )  ) ;
	// Checking out-of-bound for "TagFinder:seek_tags"
	if ( t_begin_of_data + (t_seek_tags__size) > t_end_of_data || t_begin_of_data + (t_seek_tags__size) < t_begin_of_data )
		{
		// Handle out-of-bound condition
		throw binpac::ExceptionOutOfBound("TagFinder:seek_tags",
			(0) + (t_seek_tags__size), 
			(t_end_of_data) - (t_begin_of_data));
		}
	{
	// Setting t_end_of_data with &length
	const_byteptr t_end_of_data = t_begin_of_data + t_seek_tags__size;
	int t_seek_tags_string_length;
	t_seek_tags_string_length =  (  ( 8 * tag_number() )  ) ;
	// check for negative sizes
	if ( t_seek_tags_string_length < 0 )
	throw binpac::ExceptionInvalidStringLength("/builddir/build/BUILD/GQUIC_Protocol_Analyzer-89b7b45043db496e64ea9189b8ddfc681d0c77a7/src/gquic-protocol.pac:549", t_seek_tags_string_length);
	seek_tags_.init(t_begin_of_data, t_seek_tags_string_length);
	// Evaluate 'let' and 'withinput' fields
	}
	
	int t_TagFinder__size;
	const_byteptr const t_dataptr_after_seek_tags = t_begin_of_data + (t_seek_tags__size);
	BINPAC_ASSERT(t_dataptr_after_seek_tags <= t_end_of_data);
	t_TagFinder__size = t_dataptr_after_seek_tags - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	pad_check_ = PAD_check(seek_tags(), tag_number());
	sni_check_ = SNI_check(seek_tags(), tag_number());
	stk_check_ = STK_check(seek_tags(), tag_number());
	sno_check_ = SNO_check(seek_tags(), tag_number());
	ver_check_ = VER_check(seek_tags(), tag_number());
	ccs_check_ = CCS_check(seek_tags(), tag_number());
	crt_check_ = CRT_check(seek_tags(), tag_number());
	nonc_check_ = NONC_check(seek_tags(), tag_number());
	mspc_check_ = MSPC_check(seek_tags(), tag_number());
	aead_check_ = AEAD_check(seek_tags(), tag_number());
	uaid_check_ = UAID_check(seek_tags(), tag_number());
	scid_check_ = SCID_check(seek_tags(), tag_number());
	tcid_check_ = TCID_check(seek_tags(), tag_number());
	pdmd_check_ = PDMD_check(seek_tags(), tag_number());
	smhl_check_ = SMHL_check(seek_tags(), tag_number());
	icsl_check_ = ICSL_check(seek_tags(), tag_number());
	nonp_check_ = NONP_check(seek_tags(), tag_number());
	pubs_check_ = PUBS_check(seek_tags(), tag_number());
	mids_check_ = MIDS_check(seek_tags(), tag_number());
	scls_check_ = SCLS_check(seek_tags(), tag_number());
	kexs_check_ = KEXS_check(seek_tags(), tag_number());
	xlct_check_ = XLCT_check(seek_tags(), tag_number());
	csct_check_ = CSCT_check(seek_tags(), tag_number());
	copt_check_ = COPT_check(seek_tags(), tag_number());
	ccrt_check_ = CCRT_check(seek_tags(), tag_number());
	irtt_check_ = IRTT_check(seek_tags(), tag_number());
	cfcw_check_ = CFCW_check(seek_tags(), tag_number());
	sfcw_check_ = SFCW_check(seek_tags(), tag_number());
	prof_check_ = PROF_check(seek_tags(), tag_number());
	scfg_check_ = SCFG_check(seek_tags(), tag_number());
	rrej_check_ = RREJ_check(seek_tags(), tag_number());
	obit_check_ = OBIT_check(seek_tags(), tag_number());
	expy_check_ = EXPY_check(seek_tags(), tag_number());
	srbf_check_ = SRBF_check(seek_tags(), tag_number());
	cetv_check_ = CETV_check(seek_tags(), tag_number());
	ctim_check_ = CTIM_check(seek_tags(), tag_number());
	fhol_check_ = FHOL_check(seek_tags(), tag_number());
	sttl_check_ = STTL_check(seek_tags(), tag_number());
	tbkp_check_ = TBKP_check(seek_tags(), tag_number());
	svid_check_ = SVID_check(seek_tags(), tag_number());
	BINPAC_ASSERT(t_begin_of_data + (t_TagFinder__size) <= t_end_of_data);
	return t_TagFinder__size;
	}

bool HelloLength(uint16 length, bool is_orig)
	{

		if ((length >= 60))
		{
			return true;
		}
		else
		{
			return false;
		}
	
	}

bool CIDCheck(bool is_orig, bool is_long)
	{

		if (is_orig == true)
			return true;
		else
		{
			if (is_long == true)
			{
				return true;
			}
			else
				return false;
		}
	
	}

bool PAD_check(bytestring const & other_tags, uint16 tag_number)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x50 && other_tags[(i*8)+1] == 0x41 && other_tags[(i*8)+2] == 0x44)
				{
				return true;
				}
			}
		return false;
	
	}

uint16 find_pad_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if ((other_tags[i*8] == 0x50) && (other_tags[(i*8)+1] == 0x41) && (other_tags[(i*8)+2] == 0x44))
				{
				if (i < 1)
					{
					return (other_tags[(i*8)+4]-(p_tag_offset-(256*other_tags[5])));
					}
				else
					{
					if (other_tags[(i*8)+5] == other_tags[(i*8)-3])
						{
						return (other_tags[(i*8)+4]-other_tags[(i*8)-4]);
						}
					if (other_tags[(i*8)+5] > other_tags[(i*8)-3])
						{
						return (256-other_tags[(i*8)-4]+other_tags[(i*8)+4]);
						}
					}
				}
			}
		return 0x00;
	
	}

bool SNI_check(bytestring const & other_tags, uint16 tag_number)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x53 && other_tags[(i*8)+1] == 0x4e && other_tags[(i*8)+2] == 0x49)
				{
				return true;
				}
			}
		return false;
	
	}

uint16 find_sni_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if ((other_tags[i*8] == 0x53) && (other_tags[(i*8)+1] == 0x4e) && (other_tags[(i*8)+2] == 0x49))
				{
				if (i < 1)
					{
					return (other_tags[(i*8)+4]-(p_tag_offset-(256*other_tags[5])));
					}
				else
					{
					if (other_tags[(i*8)+5] == other_tags[(i*8)-3])
						{
						return (other_tags[(i*8)+4]-other_tags[(i*8)-4]);
						}
					if (other_tags[(i*8)+5] > other_tags[(i*8)-3])
						{
						return (256-other_tags[(i*8)-4]+other_tags[(i*8)+4]);
						}
					}
				}
			}
		return 0x00;
	
	}

bool STK_check(bytestring const & other_tags, uint16 tag_number)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x53 && other_tags[(i*8)+1] == 0x54 && other_tags[(i*8)+2] == 0x4b)
				{
				return true;
				}
			}
		return false;
	
	}

uint16 find_stk_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if ((other_tags[i*8] == 0x53) && (other_tags[(i*8)+1] == 0x54) && (other_tags[(i*8)+2] == 0x4b))
				{
				if (i < 1) //(other_tags[(i*8)+5] == other_tags[(i*8)-3])
					{
					return (other_tags[(i*8)+4]-(p_tag_offset-(256*other_tags[5])));
					}
				else
					{
					if (other_tags[(i*8)+5] == other_tags[(i*8)-3])
						{
						return (other_tags[(i*8)+4]-other_tags[(i*8)-4]);
						}
					if (other_tags[(i*8)+5] > other_tags[(i*8)-3])
						{
						return (256-other_tags[(i*8)-4]+other_tags[(i*8)+4]);
						}
					}
				}
			}
		return 0x00;
	
	}

bool SNO_check(bytestring const & other_tags, uint16 tag_number)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x53 && other_tags[(i*8)+1] == 0x4e && other_tags[(i*8)+2] == 0x4f)
				{
				return true;
				}
			}
		return false;
	
	}

uint16 find_sno_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if ((other_tags[i*8] == 0x53) && (other_tags[(i*8)+1] == 0x4e) && (other_tags[(i*8)+2] == 0x4f))
				{
				if (i < 1)
					{
					return (other_tags[(i*8)+4]-(p_tag_offset-(256*other_tags[5])));
					}
				else
					{
					if (other_tags[(i*8)+5] == other_tags[(i*8)-3])
						{
						return (other_tags[(i*8)+4]-other_tags[(i*8)-4]);
						}
					if (other_tags[(i*8)+5] > other_tags[(i*8)-3])
						{
						return (256-other_tags[(i*8)-4]+other_tags[(i*8)+4]);
						}
					}
				}
			}
		return 0x00;
	
	}

bool VER_check(bytestring const & other_tags, uint16 tag_number)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x56 && other_tags[(i*8)+1] == 0x45 && other_tags[(i*8)+2] == 0x52)
				{
				return true;
				}
			}
		return false;
	
	}

uint16 find_ver_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x56 && other_tags[(i*8)+1] == 0x45 && other_tags[(i*8)+2] == 0x52)
				{
				if (i < 1)
					{
					return ((other_tags[4])-(p_tag_offset-(256*other_tags[5])));
					}
				else
					{
					if (other_tags[(i*8)+5] == other_tags[(i*8)-3])
						{
						return (other_tags[(i*8)+4]-other_tags[(i*8)-4]);
						}
					if (other_tags[(i*8)+5] > other_tags[(i*8)-3])
						{
						return (256-other_tags[(i*8)-4]+other_tags[(i*8)+4]);
						}
					}
				}
			}
		return 0x00;
	
	}

bool CCS_check(bytestring const & other_tags, uint16 tag_number)
	{

		for ( int i = 0; i < tag_number-2; i++ )
			{
			if (other_tags[i*8] == 0x43 && other_tags[(i*8)+1] == 0x43 && other_tags[(i*8)+2] == 0x53)
				{
				return true;
				}
			}
		return false;
	
	}

uint16 find_ccs_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x43 && other_tags[(i*8)+1] == 0x43 && other_tags[(i*8)+2] == 0x53)
				{
				if (i < 1)
					{
					return ((other_tags[4])-(p_tag_offset-(256*other_tags[5])));
					}
				else
					{
					if (other_tags[(i*8)+5] == other_tags[(i*8)-3])
						{
						return (other_tags[(i*8)+4]-other_tags[(i*8)-4]);
						}
					if (other_tags[(i*8)+5] > other_tags[(i*8)-3])
						{
						return (256-other_tags[(i*8)-4]+other_tags[(i*8)+4]);
						}
					}
				}
			}
		return 0x00;
	
	}

bool CRT_check(bytestring const & other_tags, uint16 tag_number)
	{

		for ( int i = 0; i < tag_number-2; i++ )
			{
			if (other_tags[i*8] == 0x43 && other_tags[(i*8)+1] == 0x52 && other_tags[(i*8)+2] == 0x54)
				{
				return true;
				}
			}
		return false;
	
	}

uint16 find_crt_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x43 && other_tags[(i*8)+1] == 0x52 && other_tags[(i*8)+2] == 0x54)
				{
				if (i < 1)
					{
					return ((other_tags[4])-(p_tag_offset-(256*other_tags[5])));
					}
				else
					{
					if (other_tags[(i*8)+5] == other_tags[(i*8)-3])
						{
						return (other_tags[(i*8)+4]-other_tags[(i*8)-4]);
						}
					if (other_tags[(i*8)+5] > other_tags[(i*8)-3])
						{
						return (256-other_tags[(i*8)-4]+other_tags[(i*8)+4]);
						}
					}
				}
			}
		return 0x00;
	
	}

bool NONC_check(bytestring const & other_tags, uint16 tag_number)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x4e && other_tags[(i*8)+1] == 0x4f && other_tags[(i*8)+2] == 0x4e && other_tags[(i*8)+3] == 0x43)
				{
				return true;
				}
			}
		return false;
	
	}

uint16 find_nonc_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x4e && other_tags[(i*8)+1] == 0x4f && other_tags[(i*8)+2] == 0x4e && other_tags[(i*8)+3] == 0x43)
				{
				if (i < 1)
					{
					return ((other_tags[4])-(p_tag_offset-(256*other_tags[5])));
					}
				else
					{
					if (other_tags[(i*8)+5] == other_tags[(i*8)-3])
						{
						return (other_tags[(i*8)+4]-other_tags[(i*8)-4]);
						}
					if (other_tags[(i*8)+5] > other_tags[(i*8)-3])
						{
						return (256-other_tags[(i*8)-4]+other_tags[(i*8)+4]);
						}
					}
				}
			}
		return 0x00;
	
	}

bool MSPC_check(bytestring const & other_tags, uint16 tag_number)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x4d && other_tags[(i*8)+1] == 0x53 && other_tags[(i*8)+2] == 0x50 && other_tags[(i*8)+3] == 0x43)
				{
				return true;
				}
			}
		return false;
	
	}

uint16 find_mspc_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x4d && other_tags[(i*8)+1] == 0x53 && other_tags[(i*8)+2] == 0x50 && other_tags[(i*8)+3] == 0x43)
				{
				if (i < 1)
					{
					return ((other_tags[4])-(p_tag_offset-(256*other_tags[5])));
					}
				else
					{
					if (other_tags[(i*8)+5] == other_tags[(i*8)-3])
						{
						return (other_tags[(i*8)+4]-other_tags[(i*8)-4]);
						}
					if (other_tags[(i*8)+5] > other_tags[(i*8)-3])
						{
						return (256-other_tags[(i*8)-4]+other_tags[(i*8)+4]);
						}
					}
				}
			}
		return 0x00;
	
	}

bool AEAD_check(bytestring const & other_tags, uint16 tag_number)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x41 && other_tags[(i*8)+1] == 0x45 && other_tags[(i*8)+2] == 0x41 && other_tags[(i*8)+3] == 0x44)
				{
				return true;
				}
			}
		return false;
	
	}

uint16 find_aead_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x41 && other_tags[(i*8)+1] == 0x45 && other_tags[(i*8)+2] == 0x41 && other_tags[(i*8)+3] == 0x44)
				{
				if (i < 1)
					{
					return ((other_tags[4])-(p_tag_offset-(256*other_tags[5])));
					}
				else
					{
					if (other_tags[(i*8)+5] == other_tags[(i*8)-3])
						{
						return (other_tags[(i*8)+4]-other_tags[(i*8)-4]);
						}
					if (other_tags[(i*8)+5] > other_tags[(i*8)-3])
						{
						return (256-other_tags[(i*8)-4]+other_tags[(i*8)+4]);
						}
					}
				}
			}
		return 0x00;
	
	}

bool UAID_check(bytestring const & other_tags, uint16 tag_number)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x55 && other_tags[(i*8)+1] == 0x41 && other_tags[(i*8)+2] == 0x49 && other_tags[(i*8)+3] == 0x44)
				{
				return true;
				}
			}
		return false;
	
	}

uint16 find_uaid_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x55 && other_tags[(i*8)+1] == 0x41 && other_tags[(i*8)+2] == 0x49 && other_tags[(i*8)+3] == 0x44)
				{
				if (i < 1)
					{
					return ((other_tags[4])-(p_tag_offset-(256*other_tags[5])));
					}
				else
					{
					if (other_tags[(i*8)+5] == other_tags[(i*8)-3])
						{
						return (other_tags[(i*8)+4]-other_tags[(i*8)-4]);
						}
					if (other_tags[(i*8)+5] > other_tags[(i*8)-3])
						{
						return (256-other_tags[(i*8)-4]+other_tags[(i*8)+4]);
						}
					}
				}
			}
		return 0x00;
	
	}

bool SCID_check(bytestring const & other_tags, uint16 tag_number)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x53 && other_tags[(i*8)+1] == 0x43 && other_tags[(i*8)+2] == 0x49 && other_tags[(i*8)+3] == 0x44)
				{
				return true;
				}
			}
		return false;
	
	}

uint16 find_scid_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x53 && other_tags[(i*8)+1] == 0x43 && other_tags[(i*8)+2] == 0x49 && other_tags[(i*8)+3] == 0x44)
				{
				if (i < 1)
					{
					return ((other_tags[4])-(p_tag_offset-(256*other_tags[5])));
					}
				else
					{
					if (other_tags[(i*8)+5] == other_tags[(i*8)-3])
						{
						return (other_tags[(i*8)+4]-other_tags[(i*8)-4]);
						}
					if (other_tags[(i*8)+5] > other_tags[(i*8)-3])
						{
						return (256-other_tags[(i*8)-4]+other_tags[(i*8)+4]);
						}
					}
				}
			}
		return 0x00;
	
	}

bool TCID_check(bytestring const & other_tags, uint16 tag_number)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x54 && other_tags[(i*8)+1] == 0x43 && other_tags[(i*8)+2] == 0x49 && other_tags[(i*8)+3] == 0x44)
				{
				return true;
				}
			}
		return false;
	
	}

uint16 find_tcid_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x54 && other_tags[(i*8)+1] == 0x43 && other_tags[(i*8)+2] == 0x49 && other_tags[(i*8)+3] == 0x44)
				{
				if (i < 1)
					{
					return ((other_tags[4])-(p_tag_offset-(256*other_tags[5])));
					}
				else
					{
					if (other_tags[(i*8)+5] == other_tags[(i*8)-3])
						{
						return (other_tags[(i*8)+4]-other_tags[(i*8)-4]);
						}
					if (other_tags[(i*8)+5] > other_tags[(i*8)-3])
						{
						return (256-other_tags[(i*8)-4]+other_tags[(i*8)+4]);
						}
					}
				}
			}
		return 0x00;
	
	}

bool PDMD_check(bytestring const & other_tags, uint16 tag_number)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x50 && other_tags[(i*8)+1] == 0x44 && other_tags[(i*8)+2] == 0x4d && other_tags[(i*8)+3] == 0x44)
				{
				return true;
				}
			}
		return false;
	
	}

uint16 find_pdmd_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x50 && other_tags[(i*8)+1] == 0x44 && other_tags[(i*8)+2] == 0x4d && other_tags[(i*8)+3] == 0x44)
				{
				if (i < 1)
					{
					return ((other_tags[4])-(p_tag_offset-(256*other_tags[5])));
					}
				else
					{
					if (other_tags[(i*8)+5] == other_tags[(i*8)-3])
						{
						return (other_tags[(i*8)+4]-other_tags[(i*8)-4]);
						}
					if (other_tags[(i*8)+5] > other_tags[(i*8)-3])
						{
						return (256-other_tags[(i*8)-4]+other_tags[(i*8)+4]);
						}
					}
				}
			}
		return 0x00;
	
	}

bool SMHL_check(bytestring const & other_tags, uint16 tag_number)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x53 && other_tags[(i*8)+1] == 0x4d && other_tags[(i*8)+2] == 0x48 && other_tags[(i*8)+3] == 0x4c)
				{
				return true;
				}
			}
		return false;
	
	}

uint16 find_smhl_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x53 && other_tags[(i*8)+1] == 0x4d && other_tags[(i*8)+2] == 0x48 && other_tags[(i*8)+3] == 0x4c)
				{
				if (i < 1)
					{
					return ((other_tags[4])-(p_tag_offset-(256*other_tags[5])));
					}
				else
					{
					if (other_tags[(i*8)+5] == other_tags[(i*8)-3])
						{
						return (other_tags[(i*8)+4]-other_tags[(i*8)-4]);
						}
					if (other_tags[(i*8)+5] > other_tags[(i*8)-3])
						{
						return (256-other_tags[(i*8)-4]+other_tags[(i*8)+4]);
						}
					}
				}
			}
		return 0x00;
	
	}

bool NONP_check(bytestring const & other_tags, uint16 tag_number)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x4e && other_tags[(i*8)+1] == 0x4f && other_tags[(i*8)+2] == 0x4e && other_tags[(i*8)+3] == 0x50)
				{
				return true;
				}
			}
		return false;
	
	}

uint16 find_nonp_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x4e && other_tags[(i*8)+1] == 0x4f && other_tags[(i*8)+2] == 0x4e && other_tags[(i*8)+3] == 0x50)
				{
				if (i < 1)
					{
					return ((other_tags[4])-(p_tag_offset-(256*other_tags[5])));
					}
				else
					{
					if (other_tags[(i*8)+5] == other_tags[(i*8)-3])
						{
						return (other_tags[(i*8)+4]-other_tags[(i*8)-4]);
						}
					if (other_tags[(i*8)+5] > other_tags[(i*8)-3])
						{
						return (256-other_tags[(i*8)-4]+other_tags[(i*8)+4]);
						}
					}
				}
			}

		return 0x00;
	
	}

bool PUBS_check(bytestring const & other_tags, uint16 tag_number)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x50 && other_tags[(i*8)+1] == 0x55 && other_tags[(i*8)+2] == 0x42 && other_tags[(i*8)+3] == 0x53)
				{
				return true;
				}
			}
		return false;
	
	}

uint16 find_pubs_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x50 && other_tags[(i*8)+1] == 0x55 && other_tags[(i*8)+2] == 0x42 && other_tags[(i*8)+3] == 0x53)
				{
				if (i < 1)
					{
					return ((other_tags[4])-(p_tag_offset-(256*other_tags[5])));
					}
				else
					{
					if (other_tags[(i*8)+5] == other_tags[(i*8)-3])
						{
						return (other_tags[(i*8)+4]-other_tags[(i*8)-4]);
						}
					if (other_tags[(i*8)+5] > other_tags[(i*8)-3])
						{
						return (256-other_tags[(i*8)-4]+other_tags[(i*8)+4]);
						}
					}
				}
			}
		return 0x00;
	
	}

bool MIDS_check(bytestring const & other_tags, uint16 tag_number)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x4d && other_tags[(i*8)+1] == 0x49 && other_tags[(i*8)+2] == 0x44 && other_tags[(i*8)+3] == 0x53)
				{
				return true;
				}
			}
		return false;
	
	}

uint16 find_mids_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x4d && other_tags[(i*8)+1] == 0x49 && other_tags[(i*8)+2] == 0x44 && other_tags[(i*8)+3] == 0x53)
				{
				if (i < 1)
					{
					return ((other_tags[4])-(p_tag_offset-(256*other_tags[5])));
					}
				else
					{
					if (other_tags[(i*8)+5] == other_tags[(i*8)-3])
						{
						return (other_tags[(i*8)+4]-other_tags[(i*8)-4]);
						}
					if (other_tags[(i*8)+5] > other_tags[(i*8)-3])
						{
						return (256-other_tags[(i*8)-4]+other_tags[(i*8)+4]);
						}
					}
				}
			}
		return 0x00;
	
	}

bool SCLS_check(bytestring const & other_tags, uint16 tag_number)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x53 && other_tags[(i*8)+1] == 0x43 && other_tags[(i*8)+2] == 0x4c && other_tags[(i*8)+3] == 0x53)
				{
				return true;
				}
			}
		return false;
	
	}

uint16 find_scls_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x53 && other_tags[(i*8)+1] == 0x43 && other_tags[(i*8)+2] == 0x4c && other_tags[(i*8)+3] == 0x53)
				{
				if (i < 1)
					{
					return ((other_tags[4])-(p_tag_offset-(256*other_tags[5])));
					}
				else
					{
					if (other_tags[(i*8)+5] == other_tags[(i*8)-3])
						{
						return (other_tags[(i*8)+4]-other_tags[(i*8)-4]);
						}
					if (other_tags[(i*8)+5] > other_tags[(i*8)-3])
						{
						return (256-other_tags[(i*8)-4]+other_tags[(i*8)+4]);
						}
					}
				}
			}
		return 0x00;
	
	}

bool KEXS_check(bytestring const & other_tags, uint16 tag_number)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x4b && other_tags[(i*8)+1] == 0x45 && other_tags[(i*8)+2] == 0x58 && other_tags[(i*8)+3] == 0x53)
				{
				return true;
				}
			}
		return false;
	
	}

uint16 find_kexs_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x4b && other_tags[(i*8)+1] == 0x45 && other_tags[(i*8)+2] == 0x58 && other_tags[(i*8)+3] == 0x53)
				{
				if (i < 1)
					{
					return ((other_tags[4])-(p_tag_offset-(256*other_tags[5])));
					}
				else
					{
					if (other_tags[(i*8)+5] == other_tags[(i*8)-3])
						{
						return (other_tags[(i*8)+4]-other_tags[(i*8)-4]);
						}
					if (other_tags[(i*8)+5] > other_tags[(i*8)-3])
						{
						return (256-other_tags[(i*8)-4]+other_tags[(i*8)+4]);
						}
					}
				}
			}
		return 0x00;
	
	}

bool XLCT_check(bytestring const & other_tags, uint16 tag_number)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x58 && other_tags[(i*8)+1] == 0x4c && other_tags[(i*8)+2] == 0x43 && other_tags[(i*8)+3] == 0x54)
				{
				return true;
				}
			}
		return false;
	
	}

uint16 find_xlct_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x58 && other_tags[(i*8)+1] == 0x4c && other_tags[(i*8)+2] == 0x43 && other_tags[(i*8)+3] == 0x54)
				{
				if (i < 1)
					{
					return ((other_tags[4])-(p_tag_offset-(256*other_tags[5])));
					}
				else
					{
					if (other_tags[(i*8)+5] == other_tags[(i*8)-3])
						{
						return (other_tags[(i*8)+4]-other_tags[(i*8)-4]);
						}
					if (other_tags[(i*8)+5] > other_tags[(i*8)-3])
						{
						return (256-other_tags[(i*8)-4]+other_tags[(i*8)+4]);
						}
					}
				}
			}
		return 0x00;
	
	}

bool CSCT_check(bytestring const & other_tags, uint16 tag_number)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x43 && other_tags[(i*8)+1] == 0x53 && other_tags[(i*8)+2] == 0x43 && other_tags[(i*8)+3] == 0x54)
				{
				return true;
				}
			}
		return false;
	
	}

uint16 find_csct_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x43 && other_tags[(i*8)+1] == 0x53 && other_tags[(i*8)+2] == 0x43 && other_tags[(i*8)+3] == 0x54)
				{
				if (i < 1)
					{
					return ((other_tags[4])-(p_tag_offset-(256*other_tags[5])));
					}
				else
					{
					if (other_tags[(i*8)+5] == other_tags[(i*8)-3])
						{
						return (other_tags[(i*8)+4]-other_tags[(i*8)-4]);
						}
					if (other_tags[(i*8)+5] > other_tags[(i*8)-3])
						{
						return (256-other_tags[(i*8)-4]+other_tags[(i*8)+4]);
						}
					}
				}
			}
		return 0x00;
	
	}

bool COPT_check(bytestring const & other_tags, uint16 tag_number)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x43 && other_tags[(i*8)+1] == 0x4f && other_tags[(i*8)+2] == 0x50 && other_tags[(i*8)+3] == 0x54)
				{
				return true;
				}
			}
		return false;
	
	}

uint16 find_copt_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x43 && other_tags[(i*8)+1] == 0x4f && other_tags[(i*8)+2] == 0x50 && other_tags[(i*8)+3] == 0x54)
				{
				if (i < 1)
					{
					return ((other_tags[4])-(p_tag_offset-(256*other_tags[5])));
					}
				else
					{
					if (other_tags[(i*8)+5] == other_tags[(i*8)-3])
						{
						return (other_tags[(i*8)+4]-other_tags[(i*8)-4]);
						}
					if (other_tags[(i*8)+5] > other_tags[(i*8)-3])
						{
						return (256-other_tags[(i*8)-4]+other_tags[(i*8)+4]);
						}
					}
				}
			}
		return 0x00;
	
	}

bool CCRT_check(bytestring const & other_tags, uint16 tag_number)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x43 && other_tags[(i*8)+1] == 0x43 && other_tags[(i*8)+2] == 0x52 && other_tags[(i*8)+3] == 0x54)
				{
				return true;
				}
			}
		return false;
	
	}

uint16 find_ccrt_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x43 && other_tags[(i*8)+1] == 0x43 && other_tags[(i*8)+2] == 0x52 && other_tags[(i*8)+3] == 0x54)
				{
				if (i < 1)
					{
					return ((other_tags[4])-(p_tag_offset-(256*other_tags[5])));
					}
				else
					{
					if (other_tags[(i*8)+5] == other_tags[(i*8)-3])
						{
						return (other_tags[(i*8)+4]-other_tags[(i*8)-4]);
						}
					if (other_tags[(i*8)+5] > other_tags[(i*8)-3])
						{
						return (256-other_tags[(i*8)-4]+other_tags[(i*8)+4]);
						}
					}
				}
			}
		return 0x00;
	
	}

bool IRTT_check(bytestring const & other_tags, uint16 tag_number)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x49 && other_tags[(i*8)+1] == 0x52 && other_tags[(i*8)+2] == 0x54 && other_tags[(i*8)+3] == 0x54)
				{
				return true;
				}
			}
		return false;
	
	}

uint16 find_irtt_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x49 && other_tags[(i*8)+1] == 0x52 && other_tags[(i*8)+2] == 0x54 && other_tags[(i*8)+3] == 0x54)
				{
				if (i < 1)
					{
					return ((other_tags[4])-(p_tag_offset-(256*other_tags[5])));
					}
				else
					{
					if (other_tags[(i*8)+5] == other_tags[(i*8)-3])
						{
						return (other_tags[(i*8)+4]-other_tags[(i*8)-4]);
						}
					if (other_tags[(i*8)+5] > other_tags[(i*8)-3])
						{
						return (256-other_tags[(i*8)-4]+other_tags[(i*8)+4]);
						}
					}
				}
			}
		return 0x00;
	
	}

bool CFCW_check(bytestring const & other_tags, uint16 tag_number)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x43 && other_tags[(i*8)+1] == 0x46 && other_tags[(i*8)+2] == 0x43 && other_tags[(i*8)+3] == 0x57)
				{
				return true;
				}
			}
		return false;
	
	}

uint16 find_cfcw_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x43 && other_tags[(i*8)+1] == 0x46 && other_tags[(i*8)+2] == 0x43 && other_tags[(i*8)+3] == 0x57)
				{
				if (i < 1)
					{
					return ((other_tags[4])-(p_tag_offset-(256*other_tags[5])));
					}
				else
					{
					if (other_tags[(i*8)+5] == other_tags[(i*8)-3])
						{
						return (other_tags[(i*8)+4]-other_tags[(i*8)-4]);
						}
					if (other_tags[(i*8)+5] > other_tags[(i*8)-3])
						{
						return (256-other_tags[(i*8)-4]+other_tags[(i*8)+4]);
						}
					}
				}
			}
		return 0x00;
	
	}

bool SFCW_check(bytestring const & other_tags, uint16 tag_number)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x53 && other_tags[(i*8)+1] == 0x46 && other_tags[(i*8)+2] == 0x43 && other_tags[(i*8)+3] == 0x57)
				{
				return true;
				}
			}
		return false;
	
	}

uint16 find_sfcw_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x53 && other_tags[(i*8)+1] == 0x46 && other_tags[(i*8)+2] == 0x43 && other_tags[(i*8)+3] == 0x57)
				{
				if (i < 1)
					{
					return ((other_tags[4])-(p_tag_offset-(256*other_tags[5])));
					}
				else
					{
					if (other_tags[(i*8)+5] == other_tags[(i*8)-3])
						{
						return (other_tags[(i*8)+4]-other_tags[(i*8)-4]);
						}
					if (other_tags[(i*8)+5] > other_tags[(i*8)-3])
						{
						return (256-other_tags[(i*8)-4]+other_tags[(i*8)+4]);
						}
					}
				}
			}
		return 0x00;
	
	}

bool PROF_check(bytestring const & other_tags, uint16 tag_number)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x50 && other_tags[(i*8)+1] == 0x52 && other_tags[(i*8)+2] == 0x4f && other_tags[(i*8)+3] == 0x46)
				{
				return true;
				}
			}
		return false;
	
	}

uint16 find_prof_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x50 && other_tags[(i*8)+1] == 0x52 && other_tags[(i*8)+2] == 0x4f && other_tags[(i*8)+3] == 0x46)
				{
				if (i < 1)
					{
					return ((other_tags[4])-(p_tag_offset-(256*other_tags[5])));
					}
				else
					{
					if (other_tags[(i*8)+5] == other_tags[(i*8)-3])
						{
						return (other_tags[(i*8)+4]-other_tags[(i*8)-4]);
						}
					if (other_tags[(i*8)+5] > other_tags[(i*8)-3])
						{
						return (256-other_tags[(i*8)-4]+other_tags[(i*8)+4]);
						}
					}
				}
			}
		return 0x00;
	
	}

bool SCFG_check(bytestring const & other_tags, uint16 tag_number)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x53 && other_tags[(i*8)+1] == 0x43 && other_tags[(i*8)+2] == 0x46 && other_tags[(i*8)+3] == 0x47)
				{
				return true;
				}
			}
		return false;
	
	}

uint16 find_scfg_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x53 && other_tags[(i*8)+1] == 0x43 && other_tags[(i*8)+2] == 0x46 && other_tags[(i*8)+3] == 0x47)
				{
				if (i < 1)
					{
					return ((other_tags[4])-(p_tag_offset-(256*other_tags[5])));
					}
				else
					{
					if (other_tags[(i*8)+5] == other_tags[(i*8)-3])
						{
						return (other_tags[(i*8)+4]-other_tags[(i*8)-4]);
						}
					if (other_tags[(i*8)+5] > other_tags[(i*8)-3])
						{
						return (256-other_tags[(i*8)-4]+other_tags[(i*8)+4]);
						}
					}
				}
			}
		return 0x00;
	
	}

bool RREJ_check(bytestring const & other_tags, uint16 tag_number)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x52 && other_tags[(i*8)+1] == 0x52 && other_tags[(i*8)+2] == 0x45 && other_tags[(i*8)+3] == 0x4a)
				{
				return true;
				}
			}
		return false;
	
	}

uint16 find_rrej_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x52 && other_tags[(i*8)+1] == 0x52 && other_tags[(i*8)+2] == 0x45 && other_tags[(i*8)+3] == 0x4a)
				{
				if (i < 1)
					{
					return ((other_tags[4])-(p_tag_offset-(256*other_tags[5])));
					}
				else
					{
					if (other_tags[(i*8)+5] == other_tags[(i*8)-3])
						{
						return (other_tags[(i*8)+4]-other_tags[(i*8)-4]);
						}
					if (other_tags[(i*8)+5] > other_tags[(i*8)-3])
						{
						return (256-other_tags[(i*8)-4]+other_tags[(i*8)+4]);
						}
					}
				}
			}
		return 0x00;
	
	}

bool OBIT_check(bytestring const & other_tags, uint16 tag_number)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x4f && other_tags[(i*8)+1] == 0x42 && other_tags[(i*8)+2] == 0x49 && other_tags[(i*8)+3] == 0x54)
				{
				return true;
				}
			}
		return false;
	
	}

uint16 find_obit_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x4f && other_tags[(i*8)+1] == 0x42 && other_tags[(i*8)+2] == 0x49 && other_tags[(i*8)+3] == 0x54)
				{
				if (i < 1)
					{
					return ((other_tags[4])-(p_tag_offset-(256*other_tags[5])));
					}
				else
					{
					if (other_tags[(i*8)+5] == other_tags[(i*8)-3])
						{
						return (other_tags[(i*8)+4]-other_tags[(i*8)-4]);
						}
					if (other_tags[(i*8)+5] > other_tags[(i*8)-3])
						{
						return (256-other_tags[(i*8)-4]+other_tags[(i*8)+4]);
						}
					}
				}
			}
		return 0x00;
	
	}

bool EXPY_check(bytestring const & other_tags, uint16 tag_number)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x45 && other_tags[(i*8)+1] == 0x58 && other_tags[(i*8)+2] == 0x50 && other_tags[(i*8)+3] == 0x59)
				{
				return true;
				}
			}
		return false;
	
	}

uint16 find_expy_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x45 && other_tags[(i*8)+1] == 0x58 && other_tags[(i*8)+2] == 0x50 && other_tags[(i*8)+3] == 0x59)
				{
				if (i < 1)
					{
					return ((other_tags[4])-(p_tag_offset-(256*other_tags[5])));
					}
				else
					{
					if (other_tags[(i*8)+5] == other_tags[(i*8)-3])
						{
						return (other_tags[(i*8)+4]-other_tags[(i*8)-4]);
						}
					if (other_tags[(i*8)+5] > other_tags[(i*8)-3])
						{
						return (256-other_tags[(i*8)-4]+other_tags[(i*8)+4]);
						}
					}
				}
			}
		return 0x00;
	
	}

bool SRBF_check(bytestring const & other_tags, uint16 tag_number)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x53 && other_tags[(i*8)+1] == 0x52 && other_tags[(i*8)+2] == 0x42 && other_tags[(i*8)+3] == 0x46)
				{
				return true;
				}
			}
		return false;
	
	}

uint16 find_srbf_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x53 && other_tags[(i*8)+1] == 0x52 && other_tags[(i*8)+2] == 0x42 && other_tags[(i*8)+3] == 0x46)
				{
				if (i < 1)
					{
					return ((other_tags[4])-(p_tag_offset-(256*other_tags[5])));
					}
				else
					{
					if (other_tags[(i*8)+5] == other_tags[(i*8)-3])
						{
						return (other_tags[(i*8)+4]-other_tags[(i*8)-4]);
						}
					if (other_tags[(i*8)+5] > other_tags[(i*8)-3])
						{
						return (256-other_tags[(i*8)-4]+other_tags[(i*8)+4]);
						}
					}
				}
			}
		return 0x00;
	
	}

bool CETV_check(bytestring const & other_tags, uint16 tag_number)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x43 && other_tags[(i*8)+1] == 0x45 && other_tags[(i*8)+2] == 0x54 && other_tags[(i*8)+3] == 0x56)
				{
				return true;
				}
			}
		return false;
	
	}

uint16 find_cetv_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x43 && other_tags[(i*8)+1] == 0x45 && other_tags[(i*8)+2] == 0x54 && other_tags[(i*8)+3] == 0x56)
				{
				if (i < 1)
					{
					return ((other_tags[4])-(p_tag_offset-(256*other_tags[5])));
					}
				else
					{
					if (other_tags[(i*8)+5] == other_tags[(i*8)-3])
						{
						return (other_tags[(i*8)+4]-other_tags[(i*8)-4]);
						}
					if (other_tags[(i*8)+5] > other_tags[(i*8)-3])
						{
						return (256-other_tags[(i*8)-4]+other_tags[(i*8)+4]);
						}
					}
				}
			}
		return 0x00;
	
	}

bool CTIM_check(bytestring const & other_tags, uint16 tag_number)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x43 && other_tags[(i*8)+1] == 0x54 && other_tags[(i*8)+2] == 0x49 && other_tags[(i*8)+3] == 0x4d)
				{
				return true;
				}
			}
		return false;
	
	}

uint16 find_ctim_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x43 && other_tags[(i*8)+1] == 0x54 && other_tags[(i*8)+2] == 0x49 && other_tags[(i*8)+3] == 0x4d)
				{
				if (i < 1)
					{
					return ((other_tags[4])-(p_tag_offset-(256*other_tags[5])));
					}
				else
					{
					if (other_tags[(i*8)+5] == other_tags[(i*8)-3])
						{
						return (other_tags[(i*8)+4]-other_tags[(i*8)-4]);
						}
					if (other_tags[(i*8)+5] > other_tags[(i*8)-3])
						{
						return (256-other_tags[(i*8)-4]+other_tags[(i*8)+4]);
						}
					}
				}
			}
		return 0x00;
	
	}

bool FHOL_check(bytestring const & other_tags, uint16 tag_number)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x46 && other_tags[(i*8)+1] == 0x48 && other_tags[(i*8)+2] == 0x4f && other_tags[(i*8)+3] == 0x4c)
				{
				return true;
				}
			}
		return false;
	
	}

uint16 find_fhol_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x46 && other_tags[(i*8)+1] == 0x48 && other_tags[(i*8)+2] == 0x4f && other_tags[(i*8)+3] == 0x4c)
				{
				if (i < 1)
					{
					return ((other_tags[4])-(p_tag_offset-(256*other_tags[5])));
					}
				else
					{
					if (other_tags[(i*8)+5] == other_tags[(i*8)-3])
						{
						return (other_tags[(i*8)+4]-other_tags[(i*8)-4]);
						}
					if (other_tags[(i*8)+5] > other_tags[(i*8)-3])
						{
						return (256-other_tags[(i*8)-4]+other_tags[(i*8)+4]);
						}
					}
				}
			}
		return 0x00;
	
	}

bool STTL_check(bytestring const & other_tags, uint16 tag_number)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x53 && other_tags[(i*8)+1] == 0x54 && other_tags[(i*8)+2] == 0x54 && other_tags[(i*8)+3] == 0x4c)
				{
				return true;
				}
			}
		return false;
	
	}

uint16 find_sttl_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x53 && other_tags[(i*8)+1] == 0x54 && other_tags[(i*8)+2] == 0x54 && other_tags[(i*8)+3] == 0x4c)
				{
				if (i < 1)
					{
					return ((other_tags[4])-(p_tag_offset-(256*other_tags[5])));
					}
				else
					{
					if (other_tags[(i*8)+5] == other_tags[(i*8)-3])
						{
						return (other_tags[(i*8)+4]-other_tags[(i*8)-4]);
						}
					if (other_tags[(i*8)+5] > other_tags[(i*8)-3])
						{
						return (256-other_tags[(i*8)-4]+other_tags[(i*8)+4]);
						}
					}
				}
			}
		return 0x00;
	
	}

bool TBKP_check(bytestring const & other_tags, uint16 tag_number)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x54 && other_tags[(i*8)+1] == 0x42 && other_tags[(i*8)+2] == 0x4b && other_tags[(i*8)+3] == 0x50)
				{
				return true;
				}
			}
		return false;
	
	}

uint16 find_tbkp_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x54 && other_tags[(i*8)+1] == 0x42 && other_tags[(i*8)+2] == 0x4b && other_tags[(i*8)+3] == 0x50)
				{
				if (i < 1)
					{
					return ((other_tags[4])-(p_tag_offset-(256*other_tags[5])));
					}
				else
					{
					if (other_tags[(i*8)+5] == other_tags[(i*8)-3])
						{
						return (other_tags[(i*8)+4]-other_tags[(i*8)-4]);
						}
					if (other_tags[(i*8)+5] > other_tags[(i*8)-3])
						{
						return (256-other_tags[(i*8)-4]+other_tags[(i*8)+4]);
						}
					}
				}
			}
		return 0x00;
	
	}

bool ICSL_check(bytestring const & other_tags, uint16 tag_number)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x49 && other_tags[(i*8)+1] == 0x43 && other_tags[(i*8)+2] == 0x53 && other_tags[(i*8)+3] == 0x4c)
				{
				return true;
				}
			}
		return false;
	
	}

uint16 find_icsl_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x49 && other_tags[(i*8)+1] == 0x43 && other_tags[(i*8)+2] == 0x53 && other_tags[(i*8)+3] == 0x4c)
				{
				if (i < 1)
					{
					return ((other_tags[4])-(p_tag_offset-(256*other_tags[5])));
					}
				else
					{
					if (other_tags[(i*8)+5] == other_tags[(i*8)-3])
						{
						return (other_tags[(i*8)+4]-other_tags[(i*8)-4]);
						}
					if (other_tags[(i*8)+5] > other_tags[(i*8)-3])
						{
						return (256-other_tags[(i*8)-4]+other_tags[(i*8)+4]);
						}
					}
				}
			}
		return 0x00;
	
	}

bool SVID_check(bytestring const & other_tags, uint16 tag_number)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x53 && other_tags[(i*8)+1] == 0x56 && other_tags[(i*8)+2] == 0x49 && other_tags[(i*8)+3] == 0x44)
				{
				return true;
				}
			}
		return false;
	
	}

uint16 find_svid_length(bytestring const & other_tags, uint16 tag_number, uint32 p_tag_offset)
	{

		for ( int i = 0; i < tag_number; i++ )
			{
			if (other_tags[i*8] == 0x53 && other_tags[(i*8)+1] == 0x56 && other_tags[(i*8)+2] == 0x49 && other_tags[(i*8)+3] == 0x44)
				{
				if (i < 1)
					{
					return ((other_tags[4])-(p_tag_offset-(256*other_tags[5])));
					}
				else
					{
					if (other_tags[(i*8)+5] == other_tags[(i*8)-3])
						{
						return (other_tags[(i*8)+4]-other_tags[(i*8)-4]);
						}
					if (other_tags[(i*8)+5] > other_tags[(i*8)-3])
						{
						return (256-other_tags[(i*8)-4]+other_tags[(i*8)+4]);
						}
					}
				}
			}
		return 0x00;
	
	}

GQUIC_Flow::GQUIC_Flow(GQUIC_Conn * connection, bool is_orig)
	{
	connection_ = connection;
	is_orig_ = is_orig;
	dataunit_ = 0;
	context_ = 0;
	}

GQUIC_Flow::~GQUIC_Flow()
	{
	delete dataunit_;
	dataunit_ = 0;
	delete context_;
	context_ = 0;
	}

void GQUIC_Flow::NewData(const_byteptr t_begin_of_data, const_byteptr t_end_of_data)
	{
	try
		{
		dataunit_ = new GQUIC_Packet(is_orig());
		context_ = new ContextGQUIC(connection(), this);
		int t_dataunit__size;
		t_dataunit__size = dataunit_->Parse(t_begin_of_data, t_end_of_data, context_);
		// Evaluate 'let' and 'withinput' fields
		delete dataunit_;
		dataunit_ = 0;
		delete context_;
		context_ = 0;
		}
	catch ( binpac::Exception const &e )
		{
		delete dataunit_;
		dataunit_ = 0;
		delete context_;
		context_ = 0;
		throw;
		}
	}

void GQUIC_Flow::NewGap(int gap_length)
	{
	}
void GQUIC_Flow::FlowEOF()
	{
	}


} // namespace GQUIC
}  // namespace binpac
